# -*- coding: UTF-8 -*-
# !/usr/bin/python
# @time     :2019/5/12 13:16
# @author   :Mo
# @function :chatbot based search, encode sentence_vec by bert

def chatbot_sentence_vec_by_bert_own():
    """bert encode is writted by my own"""
    from nlp_xiaojiang.FeatureProject.bert.extract_keras_bert_feature import KerasBertVector
    from nlp_xiaojiang.conf.path_config import chicken_and_gossip_path
    from nlp_xiaojiang.utils.text_tools import txtRead
    import numpy as np

    # 读取数据和一些参数，这里只取了100个标准问题
    topk = 5
    matrix_ques_save_path = "doc_vecs_chicken_and_gossip"
    questions = txtRead(chicken_and_gossip_path, encodeType='utf-8')
    ques = [ques.split('\t')[0] for ques in questions][0:100]

    # 生成标准问题的bert句向量
    bert_vector = KerasBertVector()
    ques_basic_vecs = bert_vector.bert_encode(ques)

    # 线上你可以生成，直接调用，然后直接load就好
    np.savetxt(matrix_ques_save_path, ques_basic_vecs)
    # matrix_ques = np.loadtxt(matrix_ques_save_path)

    query_bert_vec = bert_vector.bert_encode(["小姜机器人是什么"])[0]
    query_bert_vec = np.array(query_bert_vec)
    print(query_bert_vec)
    # 矩阵点乘，很快的，你也可以用annoy等工具，计算就更加快了
    qq_score = np.sum(query_bert_vec * ques_basic_vecs, axis=1) / np.linalg.norm(ques_basic_vecs, axis=1)
    topk_idx = np.argsort(qq_score)[::-1][:topk]
    for idx in topk_idx:
        print('小姜机器人回答检索： %s\t%s' % (qq_score[idx], questions[idx]))


    while True:
        print("你的问题:")
        query = input()
        query_bert_vec = bert_vector.bert_encode([query])[0]
        # 矩阵点乘，很快的，你也可以用annoy等工具，计算就更加快了
        qq_score = np.sum(query_bert_vec * ques_basic_vecs, axis=1) / np.linalg.norm(ques_basic_vecs, axis=1)
        topk_idx = np.argsort(qq_score)[::-1][:topk]
        for idx in topk_idx:
            print('小姜机器人回答检索： %s\t%s' % (qq_score[idx], questions[idx]))


def chatbot_sentence_vec_by_bert_bertasserver():
    """bert encode is used bert as server"""
    from nlp_xiaojiang.conf.path_config import chicken_and_gossip_path
    from bert_serving.client import BertClient
    from nlp_xiaojiang.utils import txtRead
    import numpy as np

    topk = 5
    matrix_ques_save_path = "doc_vecs_chicken_and_gossip"
    questions = txtRead(chicken_and_gossip_path, encodeType='utf-8')
    ques = [ques.split('\t')[0] for ques in questions][0:100]

    bc = BertClient(ip = 'localhost')
    doc_vecs = bc.encode(ques)
    np.savetxt(matrix_ques_save_path, doc_vecs)
    # matrix_ques = np.loadtxt(matrix_ques_save_path)

    while True:
        query = input('你问: ')
        query_vec = bc.encode([query])[0]
        # compute normalized dot product as score
        score = np.sum(query_vec * doc_vecs, axis=1) / np.linalg.norm(doc_vecs, axis=1)
        topk_idx = np.argsort(score)[::-1][:topk]
        for idx in topk_idx:
            print('小姜机器人回答： %s\t%s' % (score[idx], questions[idx]))


if __name__=="__main__":
    chatbot_sentence_vec_by_bert_own()
    # chatbot_sentence_vec_by_bert_bertasserver()


# result
# 小姜机器人是什么
# Tokens: ['[CLS]', '小', '姜', '机', '器', '人', '是', '什', '么', '[SEP]']
# (1, 32, 768)
# [CLS] [768] [1.0393640995025635, -0.31394684314727783, -0.08567211031913757, -0.12281288206577301, 0.5685704946517944, -0.6734460592269897, 0.3936116099357605, -0.14657911658287048, -0.5451663732528687, 0.8552711009979248, -0.3694000840187073, -0.0018898732960224152, -0.005383625626564026, 0.15833452343940735, 2.392857074737549, -1.370668649673462, 0.9063063263893127, -1.142601490020752, -0.3274427652359009, -0.0483686625957489, -0.3603387475013733, 0.3079147934913635, -1.9008374214172363, -0.3452332615852356, 0.2769089639186859, 0.36075833439826965, -0.6220439672470093, -0.37962478399276733, -0.22173452377319336, 0.23706544935703278, -0.35481616854667664, 0.08377914130687714, 0.07834005355834961, 0.01608183979988098, 0.5389248728752136, -0.05104628950357437, -0.0463351309299469, 0.6286687850952148, 0.5550581812858582, 0.29511526226997375, -0.18117117881774902, -0.8892947435379028, 0.35202541947364807, 2.5349209308624268, 0.2730821371078491, -0.5735995769500732, 0.5421597957611084, -0.12932351231575012, -0.1580323725938797, 0.9569751024246216, -0.5882872343063354, 13.529970169067383, 2.0034232139587402, 0.6951251029968262, -0.5622572898864746, -0.1711845099925995, 0.2610630393028259, 0.28804582357406616, 0.5975360870361328, -0.3334871530532837, 0.17786279320716858, -1.4801167249679565, 0.31919431686401367, 1.429368257522583, 0.5202251076698303, -0.6386469602584839, 0.7738403081893921, -0.797601580619812, -1.7268284559249878, 0.17042164504528046, -0.2284141182899475, 0.24068456888198853, 1.0906034708023071, 0.46066683530807495, -0.22198253870010376, 1.173426628112793, -0.6383375525474548, 0.3471369743347168, 0.3537029027938843, 0.29926207661628723, 1.0131189823150635, -0.13712811470031738, -1.8245162963867188, 0.11569234728813171, -0.8640097975730896, -0.1749742031097412, -0.011555582284927368, -2.962400197982788, -0.11627554893493652, 0.24945443868637085, -0.3100139796733856, -0.8704608082771301, 0.032162562012672424, 0.6128078699111938, -1.1174049377441406, -0.44977766275405884, 0.17657610774040222, 0.4162853956222534, 0.6937737464904785, -2.9513731002807617, 0.38357841968536377, 1.7391315698623657, 0.5794513821601868, -0.38206565380096436, -1.0564782619476318, 0.14102795720100403, 0.31357455253601074, -0.2747744619846344, -0.3244108557701111, -0.4872910976409912, -0.7251763343811035, -0.3837529718875885, 0.24528835713863373, 0.6830307841300964, -0.1088501513004303, 0.12314638495445251, -0.24819502234458923, 1.0839656591415405, -2.670776128768921, 0.5944135189056396, 0.3986028730869293, -0.05877089500427246, -0.7175740003585815, -0.4379426836967468, -0.19564220309257507, -0.7169078588485718, 0.0030374452471733093, 1.0794694423675537, -0.11942365765571594, -0.6889951825141907, 1.95603609085083, 0.11340025067329407, 0.4678863286972046, -0.6270723342895508, 2.311574935913086, -0.8113616108894348, -0.3659091591835022, -0.6428304314613342, -0.9594523310661316, 0.23884108662605286, -1.3684000968933105, -0.690689206123352, -0.00838884711265564, 0.39292675256729126, 2.119372844696045, 0.04040103405714035, -0.11456340551376343, 0.015392228960990906, 1.2311854362487793, -0.046399034559726715, -1.3781243562698364, 0.5994658470153809, 0.4316205382347107, 0.044444456696510315, 0.5325354337692261, -1.1179237365722656, -0.024991288781166077, -0.4842575490474701, -0.654776930809021, -0.03246501088142395, -0.21410058438777924, 0.8774051666259766, -0.7459532618522644, -0.25158822536468506, -0.041556134819984436, -1.3501412868499756, -0.38786593079566956, 0.5247678756713867, -0.08411864936351776, 0.9078837037086487, 0.06668921560049057, 1.3836820125579834, 0.14796993136405945, 0.7352832555770874, -0.26403743028640747, -1.382176160812378, 0.17314867675304413, -0.6145512461662292, -0.7105323076248169, -0.639667272567749, -0.1825159788131714, 0.1757025420665741, -0.06639575958251953, 1.0266070365905762, -0.04459512233734131, -0.942766547203064, 0.35117611289024353, -0.09589405357837677, 0.15646091103553772, -0.2489067018032074, -0.4757929742336273, 1.4963650703430176, -3.8375892639160156, -1.125215768814087, 0.11426828801631927, 0.7319279909133911, -0.4793435037136078, -0.08055523037910461, -0.6498105525970459, 1.330226182937622, -0.767677903175354, -1.0113219022750854, -0.1875268816947937, -0.7547234296798706, -0.7324925661087036, 0.8555399179458618, -0.22023382782936096, 0.08166798949241638, 0.42404651641845703, 0.4217571020126343, -0.08496545255184174, -0.4639720320701599, -0.08549687266349792, 0.11486810445785522, 0.014650970697402954, 0.928145170211792, 1.7324540615081787, 0.35004931688308716, -0.23908495903015137, -1.1047712564468384, 0.06631737947463989, 0.6066029071807861, 0.5651320815086365, -0.686876118183136, -0.4084278643131256, 0.041524410247802734, -0.32491180300712585, 0.7272577285766602, -0.2967689335346222, -0.39164304733276367, 0.7326894402503967, -1.037513017654419, -0.2947050631046295, -0.5900390148162842, -0.45508116483688354, 0.06542198359966278, 0.34646064043045044, 0.7848807573318481, 0.8663140535354614, 0.15388602018356323, 0.01518973708152771, -0.5112730264663696, -0.9820221066474915, -0.265686571598053, -0.11338577419519424, 1.0446759462356567, 0.22747312486171722, 0.41790157556533813, -0.846001923084259, -0.3298998177051544, -0.5850996971130371, 0.685137927532196, -0.44857412576675415, -1.6691421270370483, 0.30494070053100586, 0.285444051027298, 1.2830568552017212, 0.42796385288238525, 0.32015544176101685, -0.5118119120597839, 0.5177421569824219, -0.5582244396209717, 0.4734779894351959, 0.3841489255428314, -0.08896642178297043, 0.41101324558258057, 3.302192211151123, -1.6114025115966797, 1.2247281074523926, 0.2591051161289215, -0.5630861520767212, 0.1482764482498169, 0.6570146083831787, 0.7148151993751526, -1.8664922714233398, -0.42903560400009155, 0.4595433175563812, 1.0260326862335205, 1.0998669862747192, -0.7587367296218872, 0.10187511146068573, -0.17247571051120758, 0.1842833310365677, -0.24146747589111328, 0.8463143110275269, -0.04841041564941406, 0.3939945697784424, 1.11798894405365, 0.3030907213687897, 0.20580124855041504, -0.8673887848854065, 0.6875064969062805, -0.0949491560459137, 1.151665449142456, 3.44063663482666, -0.01811183989048004, 0.6953613758087158, 0.23410934209823608, 0.8601164221763611, 0.9806221723556519, -0.3090303838253021, -0.04875170439481735, 0.3547508418560028, 0.8266265392303467, -0.5158435106277466, -0.2203104943037033, -0.6994569301605225, -0.8490405678749084, -1.1711769104003906, 0.05271817743778229, 0.9057762622833252, 0.7658257484436035, 0.050104737281799316, 0.23512278497219086, 0.7854899168014526, -0.8049912452697754, -0.6358420848846436, -0.8687168955802917, -1.037772297859192, -0.48705893754959106, -0.872538685798645, -0.3925281763076782, 0.5900484919548035, 1.308942198753357, 0.4550360441207886, -0.3307679295539856, 1.3428549766540527, -0.6910381317138672, 0.5195334553718567, 0.2417294681072235, 0.4292243421077728, 0.33380672335624695, 0.29642874002456665, -0.3568708896636963, 1.0596129894256592, -0.023354679346084595, -0.021873511373996735, 0.4691203534603119, 0.9936549663543701, -0.5132080316543579, 0.9309756755828857, -0.0435909777879715, 0.5513582229614258, 0.002806425094604492, 0.3143504858016968, -0.03220248222351074, 0.409281849861145, 0.1891966611146927, 0.12097416818141937, -1.3350553512573242, -1.332608699798584, -0.8775850534439087, -0.9554033875465393, 0.21868500113487244, -1.358860731124878, 1.634242057800293, 0.3185383975505829, 0.7157171368598938, 0.9095699191093445, 0.2764788866043091, -0.3132152259349823, 1.0906206369400024, -0.5535367727279663, -1.963536262512207, 0.445904016494751, 0.29366517066955566, 0.8938524127006531, 0.2094426453113556, 0.6533538103103638, -0.8820308446884155, -0.1885322630405426, 0.32854872941970825, 0.05052271485328674, -0.8957158923149109, -0.1259736865758896, 0.0614781454205513, -0.24110767245292664, 0.5958307981491089, 1.0880773067474365, -0.8448076248168945, -0.18200814723968506, 0.025652602314949036, -0.11371709406375885, -4.2636823654174805, 0.49037042260169983, -0.5793126225471497, 0.1286333054304123, -0.9713305830955505, 0.994056761264801, -0.9629271626472473, -1.0090351104736328, 0.8683590888977051, -0.5173664689064026, -1.7113308906555176, 0.7225280404090881, 1.294363021850586, 0.07891878485679626, -0.43197184801101685, 0.10857413709163666, -1.0328291654586792, -1.2394520044326782, 0.5970273613929749, 1.6733423471450806, -0.5601459741592407, -0.3178316652774811, -1.5754461288452148, 0.9935235977172852, 0.06740419566631317, 1.4791171550750732, -0.9345505237579346, -0.37930238246917725, 0.331820547580719, 0.4014897346496582, -0.48881232738494873, 0.9590104818344116, 0.5023470520973206, -0.047364383935928345, -0.7771788835525513, 0.6445488929748535, -0.6611612439155579, 0.42583486437797546, 0.6640713214874268, -2.4451019763946533, -0.4446567893028259, 0.5402612686157227, -1.5619834661483765, 0.11103729903697968, 0.0720236673951149, -1.0298588275909424, 1.2613070011138916, 0.268846333026886, 0.02242356166243553, -0.2912015914916992, 0.8465366363525391, -0.12878191471099854, 0.23823276162147522, -0.7912580966949463, 0.16552583873271942, 0.07682719826698303, 0.03596639633178711, 0.618706464767456, -0.8725828528404236, -0.3766016364097595, 1.0806834697723389, 1.6137094497680664, 1.6948652267456055, -0.22753238677978516, 0.27712753415107727, -0.6496586203575134, -0.21981775760650635, 0.4522777199745178, -0.39081862568855286, -1.029226303100586, -0.10414773225784302, -0.441707044839859, 0.2414306104183197, -1.2284561395645142, 1.0406458377838135, -1.74244225025177, 1.6481366157531738, 0.6732252836227417, 0.2150914967060089, 0.2031371295452118, 0.7108206152915955, 0.5635879039764404, -0.27661967277526855, -0.26785752177238464, -0.8063616156578064, -0.20705486834049225, 0.19609194993972778, -1.1310937404632568, 0.02918866276741028, 0.18111339211463928, 0.06118643283843994, 0.09755441546440125, -0.45386162400245667, -0.3440943658351898, -0.32668066024780273, -1.0928459167480469, -1.6380661725997925, 0.7102787494659424, -1.0305511951446533, 3.45426344871521, -0.801641583442688, 1.1312146186828613, 0.5013564825057983, -0.5230643153190613, 0.03315015882253647, 0.5032712817192078, -0.18282905220985413, -0.2527451813220978, 0.19830437004566193, 0.0075774528086185455, -0.767789900302887, -0.32297444343566895, 1.0229229927062988, 1.1790592670440674, -0.6858135461807251, 0.6466878652572632, 0.7030930519104004, -0.9260056018829346, -0.2493380308151245, 0.8735028505325317, -0.9988552927970886, 0.02605525031685829, 0.3044910430908203, -0.7436833381652832, -0.21889753639698029, -1.1034619808197021, -0.3591030240058899, 0.6111456155776978, 0.20647627115249634, 0.41164830327033997, -0.8840419054031372, 0.7064993381500244, 0.014509528875350952, -0.9978616237640381, 0.6833433508872986, 0.04416200518608093, 0.1324133574962616, -1.4808411598205566, 0.33116796612739563, 0.5300851464271545, 0.2695471942424774, -0.33054542541503906, -1.08912992477417, 0.3626489043235779, 0.7452893257141113, 0.7855616211891174, -1.454584002494812, 0.2830025553703308, -0.386371910572052, 0.8680127859115601, 0.233538419008255, -0.3539624512195587, 0.8915678262710571, 1.222000002861023, -0.5467571020126343, 1.1761376857757568, 0.4659765660762787, -0.10240273922681808, -0.03351156413555145, 0.26345545053482056, -0.5977382659912109, -0.15899759531021118, -0.4679335057735443, 0.4362480342388153, -0.42562708258628845, -0.7765315771102905, 1.6063389778137207, -0.8840594291687012, 0.9212234616279602, -0.2891073524951935, 0.6556053161621094, -0.5731973648071289, 0.8649685978889465, -1.0068089962005615, -0.18250180780887604, 0.9943163394927979, -0.249552384018898, 0.039320044219493866, 0.015799522399902344, 0.028559613972902298, -0.7696949243545532, -0.465707927942276, -0.1004343181848526, 0.4241652190685272, 0.29238563776016235, 0.9280701875686646, 0.2562389373779297, -0.19587364792823792, -0.17729049921035767, 0.05121392756700516, 0.7580090761184692, 0.7032148838043213, 0.6007342338562012, -0.6270080804824829, 0.9129643440246582, 0.9650322198867798, -0.6352081298828125, 1.1712051630020142, -0.05241229385137558, -0.45325982570648193, -1.0782016515731812, 0.2945493161678314, 0.10578308254480362, -0.26966118812561035, 0.04102446138858795, 0.21919354796409607, 0.29471659660339355, 1.3061431646347046, 0.21855583786964417, 0.15574893355369568, -0.6430723667144775, -0.2278270721435547, -0.18983396887779236, 0.2648279070854187, 0.2687186598777771, -0.09910212457180023, 0.5761136412620544, -1.3666666746139526, 0.1032581776380539, 0.7485387921333313, 0.18967989087104797, 2.07381010055542, -0.0387326180934906, 0.31854432821273804, -0.10957591235637665, -0.30754852294921875, 0.628326952457428, 0.0721748024225235, 0.05150926113128662, 0.12249238789081573, 0.5481188297271729, 0.3588549792766571, 0.8573632836341858, 0.583362877368927, -0.5162450075149536, -0.172942653298378, 0.02463555335998535, 0.11570310592651367, -1.5428348779678345, -0.334606409072876, 0.4399941563606262, 0.882591187953949, 1.3096742630004883, 0.5482164621353149, -0.7562257647514343, -0.045211270451545715, 0.42973145842552185, -0.4527057707309723, 0.5613487958908081, -0.14321856200695038, -0.4149778485298157, 1.1518337726593018, 0.03796003758907318, 0.29475265741348267, 0.4785069227218628, 1.0851726531982422, -1.7377843856811523, -0.11898565292358398, -0.10768938809633255, -0.5555472373962402, 0.17503120005130768, 0.4201439619064331, -1.028656005859375, -0.4962877035140991, -0.20779645442962646, 1.2763292789459229, -0.6626241207122803, 0.8296007513999939, 0.9012804627418518, 0.6043409109115601, 0.7111780643463135, 0.2796786427497864, -0.9860675930976868, 1.3089534044265747, -0.848642885684967, 0.5607987642288208, -0.8372105956077576, 0.28760939836502075, 0.058021873235702515, 1.7119874954223633, 0.9443587064743042, -0.2684830129146576, 0.30822402238845825, -0.6166646480560303, -0.3013598620891571, -0.13814030587673187, -1.1712441444396973, 0.7591502666473389, -0.2750362753868103, 0.6327939629554749, -0.6151797771453857, -1.2511980533599854, 1.45670747756958, -0.19959114491939545, -0.5005579590797424, -0.23995110392570496, -0.10842227935791016, -0.32417210936546326, -1.1563670635223389, 0.5998862385749817, 0.12111502885818481, -0.3829588294029236, -0.6028792858123779, -0.4440579414367676, -0.9685969948768616, 0.4051600396633148, 0.8104796409606934, -0.1489437371492386, 1.079170823097229, 0.4430067539215088, -0.6646348237991333, -1.74846613407135, -1.4558192491531372, -0.14752602577209473, 1.316192388534546, 0.22136107087135315, -0.5012724995613098, -0.12234920263290405, 0.3419454097747803, 0.1581020951271057, -1.1394883394241333, -1.4092646837234497, -0.9180330038070679, -0.09290523827075958, 0.8365627527236938, -0.854001522064209, 0.5521027445793152, -0.55048668384552, -0.5067843198776245, -0.3464510142803192, -0.8704931139945984, -0.7632593512535095, 1.6639128923416138, -0.7172688245773315, -1.737605094909668, -0.07170195877552032, 0.4930247366428375, 1.5721981525421143, -0.6016665697097778, 0.464435875415802, 0.7904404997825623, -0.6348875761032104, -0.3038531243801117, -0.3362879157066345, -0.31530946493148804, 0.14910349249839783, -1.417451024055481, -0.4710491895675659, -1.0826337337493896, 0.5495731830596924, 1.895046591758728, 0.20535409450531006, 0.9173596501350403, 3.357970714569092, 0.13453897833824158, -0.07278941571712494, -0.27837032079696655, 0.13945752382278442, 0.48070669174194336, -1.9531567096710205, 0.4830702841281891, -0.6365683078765869, 0.5758416652679443, 0.3910081684589386, 0.0015049055218696594, 0.8636984825134277, -0.24023380875587463, -0.9468706846237183, -0.5880921483039856, 1.885053277015686, -0.19099147617816925, -1.1987566947937012, -0.8956226706504822, -0.5463157296180725, -1.2801237106323242, -0.19831085205078125, 0.14944887161254883, 0.4946858584880829, -0.4049077033996582, 0.3898269534111023, -0.38325101137161255, 0.2377244234085083, 0.2654089033603668, 0.4208860993385315, 0.4263348877429962]
# 小 [768] [0.7013989090919495, -0.40084660053253174, -0.3503463864326477, -0.28014230728149414, 0.24524623155593872, -1.4014935493469238, -0.48182061314582825, 0.7045496702194214, -0.7937867641448975, 0.9948133230209351, 0.27720558643341064, -0.4045335054397583, 0.6907503604888916, 1.2042298316955566, 0.4897122383117676, -0.5221295952796936, 0.2876770496368408, 0.11579891294240952, 0.7904666662216187, 0.5078139305114746, 0.16494320333003998, -0.18098613619804382, -1.733884334564209, 0.17450891435146332, -0.09746397286653519, 0.5122889280319214, 0.019689559936523438, 0.41357332468032837, 0.5941380262374878, -0.00970509648323059, 0.03642579913139343, 0.48857560753822327, -0.07429119944572449, -0.18101593852043152, 1.028360366821289, -0.21736660599708557, -0.2383638322353363, 0.20419947803020477, 0.31829702854156494, -0.3149590492248535, -0.2510703206062317, 0.2534271478652954, 0.14567868411540985, 0.2319338172674179, 0.3649413585662842, 0.1805674433708191, -0.5328909158706665, 0.5089345574378967, 0.02326032519340515, 0.5185285806655884, -0.03602488338947296, 13.23004150390625, 0.31943079829216003, 0.31819868087768555, -0.5628607869148254, -0.34770768880844116, -0.3704322576522827, 0.733135461807251, 0.39142081141471863, -0.07821756601333618, 0.6557053923606873, -1.4232524633407593, 0.1223931536078453, 0.35612303018569946, 0.5520858764648438, -0.14224457740783691, -0.6926642656326294, -0.21290065348148346, -0.727562427520752, 0.2542659044265747, -0.21905115246772766, -0.43252062797546387, 0.15269272029399872, -0.268587201833725, -0.6478168368339539, -0.09649889171123505, 0.10818810760974884, 0.2659958004951477, -0.346390962600708, -0.23846548795700073, 0.7241268157958984, -0.0521911084651947, 0.11241340637207031, 0.04608302190899849, -0.9711634516716003, -0.9330838918685913, 0.17905132472515106, -0.2551179528236389, 0.44264543056488037, -0.4120326638221741, -0.5413451194763184, 0.08398193120956421, -0.395668625831604, 0.9123923182487488, -1.1473755836486816, -0.5696380734443665, 0.8185130953788757, 0.6347101926803589, -0.26726728677749634, -0.182166188955307, 0.12661710381507874, 0.5086371302604675, 0.4014352262020111, 0.10769515484571457, 0.30653589963912964, 0.5972214341163635, -0.21417462825775146, -0.33978620171546936, 0.367564857006073, -0.4109450876712799, -0.8661223649978638, -0.17045378684997559, -0.02865658700466156, 0.14752477407455444, -0.047945618629455566, -0.5561912059783936, -0.05496034398674965, -0.34370046854019165, -1.2060298919677734, -0.06461216509342194, 0.4678424894809723, 0.8913548588752747, -0.33447980880737305, -0.2494858205318451, -0.48272737860679626, -0.4084215760231018, -0.3778826892375946, 0.6545575857162476, 0.5170661211013794, -0.8236882090568542, -0.36036837100982666, -0.46584826707839966, 0.7188559174537659, -0.564550518989563, 0.47952741384506226, -0.3798064589500427, -0.21900220215320587, -0.15563258528709412, -0.08829883486032486, -0.17994266748428345, -0.399281769990921, -0.4733112156391144, -0.21865881979465485, -0.12982884049415588, -0.3553037941455841, -0.308330774307251, 0.43909066915512085, 1.1502102613449097, 1.3080053329467773, 0.4716566205024719, -0.38191860914230347, 0.6847177147865295, 0.033568382263183594, -0.051911868155002594, 0.1490195393562317, 0.03159429877996445, 0.6111795902252197, -0.142357736825943, -0.40086889266967773, -0.0010315850377082825, -0.10361557453870773, -0.6477687954902649, 0.4214332103729248, -0.3108117878437042, -0.7002725005149841, 0.28235751390457153, 0.46478331089019775, -0.2929864525794983, -0.4169715344905853, 0.019363999366760254, -0.9090567827224731, 0.825052797794342, -0.01956877112388611, 0.22363334894180298, 0.10886000841856003, 0.4221210479736328, 0.38689321279525757, 0.8455225825309753, -0.42093002796173096, -0.04850585758686066, -0.04252397641539574, -0.4345197081565857, 0.05996394902467728, 0.763900637626648, 0.0038746967911720276, -0.3794044256210327, -0.11921600997447968, 0.6130219101905823, 0.46403050422668457, -0.07894879579544067, 0.5592401623725891, 0.24492678046226501, -0.7543622255325317, -0.34816864132881165, 0.698305606842041, 0.0386841744184494, -0.9570581912994385, 0.062332551926374435, -0.26435816287994385, 0.7102740406990051, -0.4852522909641266, -0.09100893139839172, -0.017934922128915787, -0.7206844091415405, -0.4539732336997986, -0.20684418082237244, -0.34784215688705444, 0.038087934255599976, 0.2584626078605652, -0.2852102816104889, -0.2957034707069397, 0.172571063041687, 0.7650099396705627, 0.13382618129253387, -0.26045337319374084, 0.9154592752456665, -0.13383787870407104, 0.18402554094791412, -0.2594204545021057, -1.2605700492858887, 0.45659878849983215, -0.7214091420173645, -0.6106175184249878, -0.618371307849884, -0.5539055466651917, 0.204253688454628, -0.5832352638244629, 0.23134346306324005, -0.036675937473773956, 0.7453190088272095, 0.7695425748825073, 0.038111403584480286, 0.3135799467563629, -0.1922348439693451, 0.43151336908340454, -0.4633033275604248, -0.07247912883758545, -0.40591758489608765, 0.19670897722244263, -0.13164451718330383, 0.9334826469421387, 0.49510765075683594, 0.07696268707513809, -0.5143380761146545, -1.6099224090576172, 0.23425889015197754, -0.38530123233795166, -0.33030012249946594, -0.2909112274646759, -0.6540465354919434, 0.7469956278800964, 0.9024442434310913, 0.48356783390045166, -0.9677979946136475, 0.10275474190711975, 0.11695751547813416, 0.8409345149993896, 0.12792854011058807, 0.557050347328186, -0.39183950424194336, 0.1732078492641449, -0.7493748664855957, -0.6757387518882751, -0.07659223675727844, 1.4940180778503418, 0.5874550342559814, 0.7671024799346924, -0.07616135478019714, 0.5489071607589722, -0.5804027318954468, 0.3699231445789337, 0.5327297449111938, 0.3937101364135742, 0.022715523838996887, -0.16108770668506622, -0.08219786733388901, 0.09265700727701187, 0.115011066198349, 0.4041610658168793, -0.5470716953277588, 0.04770117998123169, -0.22883912920951843, 1.200775384902954, -0.13151249289512634, -0.3276633024215698, 0.7200837135314941, 0.13817723095417023, -0.017010703682899475, -0.027614489197731018, -0.5906144380569458, -0.8919573426246643, 0.21873724460601807, 1.1369404792785645, 0.40667790174484253, 1.1117912530899048, -0.9211739301681519, 0.5205991268157959, 0.9117486476898193, 0.7525516748428345, 0.6873624324798584, 0.4240536093711853, 0.4663665294647217, 0.15621080994606018, -0.10126189887523651, 0.5561619400978088, 0.4205675721168518, 0.1232026219367981, 0.19420838356018066, -1.0594499111175537, 0.5230753421783447, 0.9318461418151855, 0.19158662855625153, -0.4610242247581482, 0.5009779930114746, 0.5316307544708252, -0.34674304723739624, -0.1617138683795929, 0.5370383858680725, -0.43992185592651367, 0.20256203413009644, 0.02997240424156189, -0.0922597199678421, -0.3322228193283081, 0.34245797991752625, 0.850525975227356, -0.1465587615966797, 0.24548743665218353, -0.13992448151111603, -0.14334754645824432, 0.8455655574798584, 0.4101276397705078, -1.1193522214889526, -0.5134591460227966, -0.28171223402023315, 0.062105730175971985, 0.3836020827293396, 0.23404258489608765, 0.7916979193687439, 0.9079307317733765, 0.4923971891403198, 0.8419100046157837, 0.21364696323871613, -0.00879448652267456, -1.3459155559539795, 0.4160989820957184, 0.6414791941642761, -0.25458240509033203, -0.9678725600242615, 0.07803598046302795, 0.532265305519104, -1.032174825668335, -0.8008978366851807, 0.25818365812301636, 0.45422857999801636, 0.10435996949672699, 0.6010710597038269, 0.3996149003505707, -0.4052494466304779, -0.24342788755893707, -0.020202085375785828, -1.378513216972351, 0.8588359355926514, -0.7083520293235779, -0.19448798894882202, 0.7699877023696899, 1.1101438999176025, 0.37186047434806824, 0.5183505415916443, -0.27332714200019836, -0.5027561187744141, 0.011202502995729446, -0.16257300972938538, 0.023765668272972107, -1.03634512424469, 0.0903192013502121, 0.3757071793079376, -0.7444166541099548, -0.56452476978302, 0.6637561917304993, -0.20810675621032715, -0.6620482206344604, 0.3807688355445862, -0.188426673412323, -0.5185731649398804, 0.012616433203220367, 0.843212366104126, -0.6210675239562988, -0.368583083152771, 0.5904543399810791, 0.041483815759420395, 0.1319473832845688, 0.4558955729007721, 0.31536367535591125, -0.09041084349155426, -0.2939686179161072, -0.130146786570549, 0.015598520636558533, -0.4862630367279053, 0.8126729130744934, -0.23003238439559937, 0.477424293756485, -0.0026653409004211426, 0.4017375707626343, -0.30640333890914917, -0.004425559192895889, 0.028408244252204895, 0.037062183022499084, -0.23955050110816956, -0.0015135854482650757, -0.059503223747015, -0.532334566116333, -0.03803466260433197, -0.25091272592544556, -0.9855427742004395, -0.6361819505691528, 0.2503422200679779, -0.12640275061130524, 0.037553317844867706, 0.6865237951278687, -0.8517855405807495, -0.2854560911655426, 1.3007742166519165, -0.5460042357444763, 0.3035416603088379, 0.9181758761405945, -0.1839943677186966, 0.5571103692054749, -0.2506279945373535, 0.5457409620285034, -0.4143323302268982, -0.32610371708869934, -1.0012035369873047, 0.5456304550170898, -0.023207880556583405, 0.7866176962852478, -0.6510930061340332, -0.7592753171920776, 0.7738873958587646, -0.36700353026390076, -0.7955207824707031, -0.046416305005550385, 0.33254769444465637, -0.018341518938541412, 0.7954043745994568, -0.23544490337371826, 0.39870473742485046, 0.3792450726032257, 0.22527505457401276, 0.28890448808670044, -0.7078229188919067, -0.7257093191146851, 0.13239535689353943, 1.0463895797729492, -0.13584542274475098, 0.47556230425834656, -0.35191810131073, -0.12912112474441528, 0.21969515085220337, 0.21531306207180023, 0.9988532066345215, 0.2939809262752533, 0.4469587802886963, 0.014175280928611755, 0.09894001483917236, -0.6517905592918396, 0.5256032347679138, 0.34888407588005066, -1.007314682006836, 0.3245511054992676, 0.26118895411491394, -1.8493404388427734, -0.21469832956790924, 0.4657120108604431, 1.3396819829940796, -1.038519024848938, -1.880774736404419, -0.4618298411369324, -1.2982860803604126, -0.6094486117362976, -1.0031119585037231, 0.9920470714569092, -0.17077535390853882, 0.22621417045593262, 0.05883896350860596, 0.4081602096557617, 0.08253012597560883, -0.15396404266357422, 0.2502714991569519, -0.20370781421661377, 0.2616540193557739, 0.08403923362493515, -0.7013542652130127, -0.14421428740024567, -0.45693981647491455, -0.3525978922843933, -0.5601159930229187, 0.1783474087715149, 0.8282248973846436, 0.4572295844554901, -0.21410752832889557, 0.4783684015274048, 0.027490749955177307, 0.8548067212104797, -0.18013355135917664, -1.4634945392608643, 0.33487340807914734, 0.5705845355987549, 0.09640941023826599, -0.10788267850875854, 0.37480711936950684, -0.20644669234752655, 0.1794741302728653, 1.1257156133651733, 0.36446040868759155, -0.28648239374160767, -0.34580379724502563, 0.3310939371585846, -0.4585098326206207, 0.08406198024749756, -0.12571245431900024, -0.3161194920539856, 0.12948490679264069, -0.35604530572891235, -0.08380590379238129, 0.6370394229888916, -0.12649865448474884, -0.0956459492444992, 0.34881895780563354, -0.1346760094165802, 0.857384204864502, 0.5473636984825134, -0.4574007987976074, 0.14326059818267822, -0.23212406039237976, 0.42583584785461426, 0.8198283314704895, 0.24816446006298065, -0.23933032155036926, 0.1003686785697937, 0.2264319360256195, 0.3387030065059662, -1.112030029296875, 1.4895167350769043, -0.6002962589263916, -0.5108840465545654, -0.4652741253376007, 1.313594937324524, -0.025284335017204285, -0.17773808538913727, 1.4705435037612915, -0.03121045231819153, 0.613803505897522, -0.18447597324848175, -0.17536406219005585, -0.10262218117713928, 0.52413010597229, -1.5945324897766113, -0.31809002161026, 0.4200713038444519, 0.015072051435709, 1.3141226768493652, 0.08445565402507782, -0.5116710662841797, -0.008806020021438599, -1.082666039466858, -0.030459925532341003, 0.09646815061569214, -0.3901498317718506, -0.019319377839565277, 1.0195424556732178, -0.045339297503232956, 4.419684410095215e-05, 0.4766201376914978, 0.5062703490257263, 0.27879276871681213, -0.09782207012176514, -1.1144320964813232, -1.3688886165618896, 0.9850181341171265, 0.07102049887180328, -0.1437574326992035, 0.6361362934112549, 0.01855386048555374, -0.7659485340118408, 0.7174509763717651, -0.5383057594299316, -0.053413428366184235, 0.042780108749866486, 0.8338913917541504, 0.4769856333732605, 0.803007960319519, -0.004285082221031189, -0.3993411362171173, 1.1545122861862183, 0.20573067665100098, 1.635200023651123, -0.45596545934677124, 0.02667096257209778, 0.4555508494377136, -0.20769737660884857, -0.7581297159194946, 0.6300312876701355, 0.9054320454597473, -0.21323749423027039, 0.11388175189495087, -0.15106722712516785, 0.05708959698677063, 0.05968587100505829, -0.1927778124809265, 0.6082191467285156, 0.1383221596479416, -0.8484735488891602, 0.3571664094924927, 0.2937043607234955, 0.3412974178791046, -0.39616382122039795, 0.520408034324646, 0.040460437536239624, -0.7541270852088928, 0.12263599038124084, 0.07682596147060394, -0.6082082986831665, -0.45474720001220703, -0.6831029057502747, -0.09843950718641281, -0.10778579115867615, 1.1649143695831299, -0.8092693090438843, 0.2953748404979706, 0.5294805765151978, 0.09302978217601776, -0.41970163583755493, -0.046343252062797546, 0.2442377656698227, 0.5653333067893982, 0.6693557500839233, 0.3377127945423126, -0.4521883726119995, 0.4263923466205597, -0.279693067073822, 0.29103052616119385, 0.4549216032028198, 0.0519997738301754, -0.272079735994339, -0.797416090965271, 0.10753251612186432, 0.0003309398889541626, -0.649528980255127, 0.8334336280822754, 0.47911524772644043, -0.26202392578125, -1.118293285369873, -0.4296376407146454, 0.6655025482177734, 0.5039054155349731, 0.2555999755859375, 1.1827120780944824, -0.7343178987503052, -0.5360293984413147, -0.9152728915214539, -0.13695895671844482, -0.4112270474433899, 0.186353862285614, -0.5720657706260681, 0.6172796487808228, -0.26822608709335327, 0.0201239176094532, -0.04355117678642273, -0.3238610625267029, 0.7161229252815247, 0.03687203675508499, -0.2680744230747223, 0.33872002363204956, 0.42729777097702026, -0.3692821264266968, 0.19269464910030365, 0.9233946204185486, 0.00443015992641449, -0.17358353734016418, -0.9292057752609253, -0.8872808814048767, -0.5024338960647583, 0.7199664115905762, -0.8556364178657532, 0.15793563425540924, -0.12997938692569733, -1.7492921352386475, 0.03145798295736313, -0.11053497344255447, 0.6892877221107483, -0.15088240802288055, 1.2101361751556396, -0.930793821811676, -0.24474480748176575, -0.6200026869773865, -1.604097604751587, -0.2153247445821762, 0.0729808583855629, 0.12817168235778809, -0.12198908627033234, 0.3810355067253113, 0.26228806376457214, -0.42868056893348694, -0.7406836152076721, 0.14704744517803192, -0.2619759142398834, -1.0258471965789795, -0.26117587089538574, -0.08214855194091797, -0.32731324434280396, -0.06980019062757492, -0.7569618821144104, 1.2414437532424927, -0.2815742492675781, 0.9059455394744873, 0.6587957143783569, 0.7109844088554382, -1.6745747327804565, 0.6290963888168335, 0.02116052806377411, 0.10683228075504303, 0.4530281126499176, 1.0099679231643677, -0.09457001090049744, 0.04982811212539673, -0.21659576892852783, -0.31152164936065674, -0.21511852741241455, -0.004111588001251221, -0.15232539176940918, -1.0348753929138184, -0.8017587065696716, -0.31414666771888733, -0.007066197693347931, 0.4074004888534546, 1.1062926054000854, 0.2123027890920639, -0.4398769736289978, 0.21041011810302734, 1.1827301979064941, 0.4411563575267792, -0.2615290582180023, -1.1874953508377075, 1.3925453424453735, -0.2288007140159607, 0.44675523042678833, -0.5156071186065674, -0.4418421685695648, 0.5494926571846008, 1.4516713619232178, -0.497292160987854, -0.143882617354393, 0.20984265208244324, -0.48577216267585754, 1.0410962104797363, -0.268934428691864, -0.25815314054489136, -0.6215166449546814, -0.3495209217071533, -0.011735036969184875, 0.6202811002731323, -0.3088752031326294, 0.5109761953353882, -0.10180380940437317, 0.4888511300086975, -0.6728417277336121, -0.3615540862083435, -0.5397417545318604]
# 姜 [768] [1.0106569528579712, -0.27137959003448486, 0.09393742680549622, 0.6953784227371216, 0.4734943211078644, -0.6130077242851257, -0.33104902505874634, -0.03615070879459381, -0.28247225284576416, 0.31788867712020874, -0.17650438845157623, -0.06455767899751663, -0.4088568687438965, 0.8131961822509766, -0.09444671869277954, 0.13819551467895508, 0.5051586627960205, -0.3483096957206726, 0.7101518511772156, 0.8226726055145264, -0.5989391803741455, 0.0778450220823288, -0.5069450736045837, 0.43287092447280884, -0.713090181350708, 0.8348826766014099, 0.010615795850753784, -1.064554214477539, -0.3733416199684143, 0.042520999908447266, -0.1731286346912384, -0.3677111268043518, 0.18560880422592163, 0.585864245891571, -0.053779784590005875, 0.13234886527061462, -0.3883933424949646, -0.5801894664764404, -0.45982861518859863, 0.0397505909204483, -0.41735291481018066, -0.018075719475746155, -0.27741631865501404, -0.17461684346199036, 0.6913106441497803, -0.5149487257003784, -0.528899610042572, -0.16717688739299774, 0.8328471183776855, -0.19275212287902832, 0.6121247410774231, 15.560067176818848, -0.051855623722076416, -0.2152201384305954, -0.3032488226890564, -0.35043492913246155, 0.4050554037094116, 0.21610766649246216, -0.7066866755485535, -0.3539537191390991, 1.0224692821502686, -0.7625547647476196, 0.6852949261665344, 0.9509583115577698, 1.0056840181350708, -0.41951441764831543, -0.22968338429927826, 0.5898982286453247, 0.20143015682697296, -0.1084325760602951, -0.21202638745307922, -0.9565489292144775, 0.024526625871658325, -0.9090474843978882, -0.09870332479476929, -0.39533179998397827, -0.23334531486034393, -0.22382520139217377, 1.25403892993927, 0.4754701554775238, -0.574294924736023, -0.5368213057518005, -0.5074710845947266, -0.2482823133468628, -1.1410056352615356, -0.18617479503154755, -0.15582191944122314, -0.7233618497848511, 0.2019628882408142, -0.17693068087100983, -0.30613428354263306, -0.14541751146316528, -0.057204719632864, 0.34010469913482666, -0.5445607304573059, 0.17515310645103455, 0.294074147939682, 0.7048047780990601, -0.4050421118736267, 0.3672322928905487, -0.5460731983184814, -0.9808655381202698, -0.6008406281471252, -0.8742020130157471, -0.23096267879009247, 1.2226409912109375, -0.8112392425537109, 0.442126989364624, -0.22831018269062042, -0.33399927616119385, -0.9376748204231262, -0.3336676061153412, 0.3842361867427826, 1.0054562091827393, 0.2549053132534027, 0.15865494310855865, -0.47453761100769043, 1.1897118091583252, -0.24472254514694214, 0.22657060623168945, 0.15227189660072327, 0.6727102994918823, 0.10422945022583008, -0.17226937413215637, -0.9654797911643982, -0.6647681593894958, 0.06862989068031311, 0.5283148884773254, -0.32867684960365295, -0.0762769877910614, -0.14115110039710999, 0.7530517578125, -0.16991493105888367, 0.7908857464790344, -0.37593936920166016, -0.6043486595153809, 0.6509555578231812, 0.03758719563484192, 0.2655574679374695, -0.318638414144516, 1.0554786920547485, 0.6238742470741272, 0.001530468463897705, 0.5724338293075562, -0.5276020765304565, -0.8272277116775513, -0.29036015272140503, 0.11291992664337158, 0.2716823220252991, 0.791230320930481, -0.4521922767162323, 0.7602934241294861, 0.5997920036315918, -0.03978124260902405, 0.1158510148525238, -0.4664846658706665, 0.1445721536874771, -0.6058518290519714, 0.22610777616500854, -0.060956552624702454, -0.0732792466878891, -0.9117758274078369, -0.6582678556442261, 1.0903699398040771, -0.25631436705589294, -0.19475001096725464, -0.6696800589561462, -0.0774887204170227, -0.47994107007980347, 0.43099698424339294, 0.5291703343391418, 1.3256275653839111, 0.34366950392723083, 0.23323246836662292, -0.46123945713043213, -1.0261671543121338, -1.0175960063934326, -0.14049872756004333, 0.3117375373840332, 0.12183813750743866, 0.24921253323554993, 0.2544766664505005, -0.27326536178588867, 0.7037964463233948, 0.6106562614440918, -0.4055634140968323, -0.09840890765190125, -0.3204032778739929, 0.33774787187576294, 0.07735437154769897, -0.854256272315979, 0.24553927779197693, 0.5348302125930786, -0.29185962677001953, 0.007019050419330597, 0.23220157623291016, 0.3078577518463135, -0.043269187211990356, 0.7260786890983582, 1.0989196300506592, -1.240097165107727, 0.19045642018318176, -0.8118463158607483, -1.0588949918746948, -0.6199281811714172, 0.32201454043388367, -0.211781308054924, -0.6937525272369385, -0.3605771064758301, -0.18622928857803345, -0.5481463670730591, 0.21481657028198242, -0.22832870483398438, 0.4097766876220703, -0.06354185938835144, -0.11515101790428162, -0.16366948187351227, 0.3543333411216736, -0.7168283462524414, -0.5669307112693787, 0.5771821141242981, 0.16646642982959747, 0.12319234013557434, -0.4651942849159241, -0.12520048022270203, 0.38621920347213745, -0.3299334645271301, 0.7876265048980713, 0.06191111356019974, -0.22460293769836426, 0.2500832676887512, -0.3397037386894226, -0.30196836590766907, -0.2406534105539322, 0.3063400387763977, 0.17494268715381622, -0.23449887335300446, -0.2775562107563019, -0.36744192242622375, 0.3241075277328491, -0.07495397329330444, -0.22829465568065643, -0.32646381855010986, -0.27674371004104614, -0.78630530834198, 0.9896001815795898, -0.5452889204025269, -1.0856599807739258, -1.1928751468658447, -1.0764753818511963, -0.11026786267757416, 0.5535271167755127, 0.2613922953605652, -0.6168026328086853, 0.3853183686733246, 0.15042687952518463, 0.1347229778766632, -0.9730783700942993, 0.42061829566955566, 0.2823726534843445, -0.05522940307855606, -1.269803762435913, -0.5731205344200134, -0.5964072346687317, 0.41444823145866394, 0.4502410888671875, 0.2897934913635254, -0.6401699185371399, 0.88671875, -0.22265173494815826, -0.2632809281349182, 0.7611514925956726, 0.0668049305677414, -0.291705459356308, -0.07833287119865417, 0.08969016373157501, -0.4683302938938141, 0.01415378600358963, -0.4915953278541565, -0.14371147751808167, -0.4027441442012787, -0.38698238134384155, 0.8170691728591919, 0.1779346913099289, -0.09561605751514435, 0.08469582349061966, 0.10585039854049683, -0.54559725522995, 0.5544789433479309, 0.1519535481929779, -0.08379606902599335, 0.01159009337425232, -0.04991556704044342, 0.8343212604522705, 0.9706562757492065, 0.08109811693429947, -0.4458504617214203, 0.08370769023895264, -0.07190727442502975, 0.05288213491439819, -0.554484486579895, 0.28568753600120544, 0.16374742984771729, 0.012240249663591385, -0.3731851875782013, -0.3430514335632324, 0.05027439072728157, 0.08784414827823639, 0.39549875259399414, -0.08864952623844147, 1.5751290321350098, -0.15538716316223145, -0.8910859823226929, 0.5350778102874756, 0.2625517249107361, 0.6452372074127197, -0.46887484192848206, 0.719342827796936, 0.9072881937026978, 0.04889947921037674, 0.11087726056575775, -0.14473506808280945, -0.322784423828125, 1.3353960514068604, 0.783949613571167, -0.3649306893348694, 0.16998867690563202, -0.8980803489685059, 0.36550596356391907, 0.01746043562889099, -0.045479290187358856, 0.06671877205371857, 0.2521043121814728, 0.16578473150730133, 0.5967051386833191, -0.21043968200683594, -0.519384503364563, 0.7211219668388367, 0.9290754795074463, -0.3668443560600281, -0.22232991456985474, -0.27287882566452026, 0.04513201117515564, -0.48123136162757874, -0.17931479215621948, 0.6876886487007141, -0.4231555759906769, -0.6000145673751831, -1.0014396905899048, -1.1892211437225342, -0.7147970795631409, 0.018822181969881058, -0.8145707249641418, -0.7688978910446167, 0.01249493658542633, 0.46709030866622925, 0.030754119157791138, 0.7604665756225586, -0.130562424659729, 0.25571608543395996, -0.3427865505218506, 0.4109957814216614, -0.9352792501449585, 0.494087815284729, 0.1351032555103302, 0.3602140247821808, 0.7514642477035522, 0.32587897777557373, 0.2756393253803253, 0.05268260836601257, 0.24442428350448608, -0.8469954133033752, -0.12747587263584137, 0.16464298963546753, -0.2622349262237549, -0.35266026854515076, 0.088682621717453, 0.14014941453933716, -0.8065412044525146, 0.2892509698867798, -0.6629637479782104, 0.038639411330223083, -0.055214449763298035, 0.25294870138168335, 0.9543139934539795, -0.07425785064697266, 0.1010567843914032, -0.9452214241027832, 0.7823441028594971, 0.06072046607732773, -0.08829200267791748, 0.30375805497169495, -0.8104556202888489, -0.4559635818004608, -0.5845915079116821, 1.5339879989624023, 0.6895607709884644, 0.20580518245697021, 0.3766555190086365, 0.7865481376647949, -0.2894113063812256, 0.42650872468948364, -0.7058194279670715, 1.0050302743911743, 1.177198886871338, -0.6446174383163452, 0.5711679458618164, -0.4994161128997803, 0.51649010181427, 0.46689411997795105, -0.3129280209541321, -0.4256724417209625, -0.17255690693855286, -0.1704544872045517, -0.11413444578647614, 0.3417927026748657, 0.43595218658447266, -0.47370052337646484, 0.19455236196517944, -0.07628151774406433, 0.0365319550037384, -0.004407122731208801, 0.12426771968603134, 0.5834029912948608, -0.039054930210113525, -0.5228404998779297, 0.3388969302177429, -0.5134310722351074, 0.16533809900283813, -0.23923102021217346, -0.15396009385585785, 0.041668932884931564, 1.0546163320541382, 1.0269169807434082, 0.17795014381408691, -0.2079671025276184, -0.18525385856628418, 0.6654438376426697, 0.8632418513298035, -0.4073604643344879, 0.13623487949371338, -0.475900262594223, 0.7027544975280762, 0.5120522379875183, -0.6987074017524719, 0.3874332010746002, -0.11856107413768768, 0.0351865291595459, -0.6770492792129517, -1.102729320526123, -0.2687925100326538, -0.45065462589263916, 0.8800620436668396, 0.9926012754440308, 0.08357404917478561, 0.43068641424179077, 0.24544689059257507, 0.1412651091814041, 0.10379765182733536, 0.0804566815495491, 0.39879152178764343, 1.2447710037231445, -0.23495563864707947, 0.18791592121124268, 0.6582162380218506, 0.4399683475494385, 0.12322833389043808, -0.674278736114502, -0.2707236409187317, -0.39800286293029785, -0.1682882010936737, -0.7041257619857788, 0.15428628027439117, 0.9745721220970154, -0.15351451933383942, 0.37905365228652954, -1.205926537513733, -0.29975050687789917, -0.5017616748809814, 0.4010814130306244, 0.5813636779785156, -0.06097850203514099, 0.31831273436546326, -0.24653910100460052, 0.3073461353778839, 0.45555755496025085, -0.6208304762840271, 0.6767346262931824, 0.4096854329109192, -0.33944642543792725, 0.6076157093048096, -0.13826149702072144, 0.33164262771606445, -0.9113804697990417, 0.5487406849861145, -0.35150280594825745, 1.9392324686050415, -0.3946129083633423, -0.26522451639175415, 0.3220922350883484, -0.23859746754169464, -0.8655949831008911, 0.17281734943389893, -0.8957681059837341, -0.2758970260620117, 0.9294942021369934, -0.10735750943422318, -0.5333803296089172, -0.9215904474258423, -0.4176746904850006, 0.37320971488952637, -0.8201680779457092, 0.3245187997817993, -0.23586151003837585, 0.13125377893447876, 0.7410202026367188, -0.6903454065322876, 0.1401752084493637, 0.6954556107521057, -0.6839625239372253, -0.849360466003418, 0.6618831157684326, -0.6875144243240356, 0.5101175308227539, -0.00428999587893486, -0.3091307282447815, 0.2887691855430603, 1.010500192642212, 0.2012331187725067, -0.5309796929359436, 1.1901605129241943, 0.9626589417457581, 1.1551021337509155, 0.43132781982421875, 0.10780759155750275, 0.3236645460128784, -0.34909841418266296, -0.0023592039942741394, 0.3017524182796478, 1.0583012104034424, -0.06276935338973999, -0.6511721014976501, 0.9633312225341797, -0.3383081257343292, 0.2428184449672699, -0.20986877381801605, 0.837676465511322, -0.37245166301727295, -0.7040591835975647, 0.3243277966976166, 1.0139319896697998, -0.805443286895752, -0.21892735362052917, -0.0831575095653534, 0.1774819940328598, -0.3376131057739258, -0.5670257806777954, -0.1636182963848114, 0.6493915319442749, -0.4890676736831665, 0.9170722365379333, 0.2721596956253052, -0.9819134473800659, -0.26335376501083374, -0.3771848678588867, -0.5403455495834351, 0.6064140200614929, -0.4921939969062805, -0.2746698260307312, 0.7518019080162048, 0.4652197062969208, -0.7965797185897827, 0.5166282057762146, -0.06622213125228882, 0.3194899559020996, -0.1467362344264984, -0.01290033757686615, -0.25878003239631653, 0.6012439727783203, -1.0059623718261719, -0.06939394772052765, -0.5356093049049377, 0.46654176712036133, -0.8258576989173889, 0.23100724816322327, 0.6930490732192993, 0.5483785271644592, -0.33032721281051636, -0.1971842646598816, 0.32857179641723633, 0.5121667981147766, -0.9511289000511169, -0.6999440789222717, 0.9958173036575317, 0.6298509836196899, 0.375819593667984, 0.14503201842308044, -0.06837476789951324, 0.039035700261592865, -0.42203599214553833, 0.09790699183940887, -0.5444461703300476, -0.26407456398010254, -0.6322538256645203, 0.11828494071960449, -0.6254180073738098, -0.9299921989440918, -0.5898528099060059, -0.3441736102104187, 0.26239028573036194, 0.07910572737455368, -0.9078372120857239, 0.018419401720166206, 0.18120691180229187, -0.3953382968902588, -0.5339053869247437, -0.8570364713668823, 1.1327601671218872, -0.12327650189399719, -0.5193181037902832, 0.2778783440589905, -0.9866445064544678, 0.19904033839702606, -0.027322620153427124, 0.007714379578828812, 0.5873473286628723, 0.5950506925582886, -0.708776593208313, 0.059111252427101135, -0.01289321482181549, -0.41321617364883423, -0.6081637144088745, 0.018483273684978485, -0.011856764554977417, -0.5727798938751221, 0.260545015335083, -0.12298623472452164, 0.8220200538635254, 0.2635458707809448, -0.658449649810791, -0.43768933415412903, 0.38090890645980835, 0.6252462863922119, -0.18057894706726074, -0.20106060802936554, -0.3400825560092926, -0.3169688582420349, 0.22122977674007416, 0.08213742822408676, 0.15857309103012085, 0.565809965133667, -0.44901522994041443, -0.09906734526157379, 0.26841825246810913, -0.327279657125473, 1.3978745937347412, 0.770933985710144, 0.032770127058029175, 0.35123658180236816, -0.3964875042438507, 0.6750889420509338, 0.18378916382789612, 0.9974991679191589, 0.293337345123291, 0.11685150116682053, -0.028982259333133698, 0.8045889139175415, 0.955053985118866, 0.06578364968299866, 0.6816713213920593, 0.5604342818260193, -0.8267966508865356, 0.9839953184127808, 0.8946499824523926, -0.5164777040481567, 0.5181025266647339, 0.3597002923488617, -0.48687928915023804, 0.43457159399986267, 0.0481274276971817, -0.7938475012779236, 0.29083913564682007, 0.48485231399536133, -0.5654752850532532, -0.06090119481086731, -0.04410354793071747, -1.0727158784866333, 0.4042057991027832, 0.5969193577766418, 0.9070255160331726, -0.4057219624519348, -0.3948343098163605, 0.3368903696537018, -0.2183629274368286, -0.43824994564056396, -1.0226335525512695, 0.2364140897989273, 0.9437463283538818, 0.5388559699058533, -0.32596123218536377, -0.3322448134422302, 1.3327902555465698, -0.28608959913253784, -0.7046443223953247, -0.06610044091939926, -0.475662499666214, 0.13142602145671844, -0.8154958486557007, 0.31403207778930664, 0.1204448714852333, -0.40247660875320435, -1.4161019325256348, 0.2609536647796631, -0.851134717464447, -0.3132208585739136, -0.04882436245679855, -0.2208118587732315, -0.11634807288646698, 0.11954177916049957, -0.2530675232410431, 0.008707642555236816, -0.0599001944065094, -0.034950897097587585, 0.1958865523338318, 0.16274085640907288, -0.641849935054779, -0.5339943766593933, -0.44205689430236816, 0.38625749945640564, -0.3544226288795471, -0.022702649235725403, 0.7092485427856445, 0.6356050968170166, 0.6080727577209473, -0.727171778678894, -0.21359848976135254, -0.3981005847454071, -0.18357057869434357, 0.4878550171852112, 0.6998398900032043, 0.07237705588340759, 0.4488148093223572, 0.38516345620155334, 1.6246497631072998, -0.42702528834342957, 0.005806773900985718, 0.035778120160102844, 0.8971848487854004, 0.7281110882759094, 1.9502613544464111, -0.9668819308280945, -0.2565195560455322, -0.15595346689224243, -0.21717022359371185, -0.22400468587875366, -0.3526044487953186, -0.853661835193634, -0.23256981372833252, 0.5181578993797302, -0.3182638883590698, 0.2673046886920929, -0.6060003638267517, 0.19739726185798645, -0.523084282875061, 0.3871862292289734, 0.7653819918632507, 0.3651330769062042, 0.32460862398147583]
# 机 [768] [0.06010199338197708, 0.24451978504657745, -0.5891311764717102, 0.11891326308250427, 1.3827686309814453, -0.02632889151573181, -0.5028846263885498, 0.519509494304657, -0.3986203670501709, 0.15344084799289703, -0.0691082701086998, 0.10058999061584473, 0.0649043619632721, -0.03721120208501816, -0.22049462795257568, -0.5938263535499573, 0.597602367401123, 0.7199863791465759, 0.8957920074462891, 1.4729554653167725, -0.5464328527450562, 0.1000714898109436, -0.5366384983062744, -0.16785427927970886, 0.3329857587814331, 0.11853432655334473, -0.21361079812049866, -1.3115923404693604, 0.23145431280136108, 0.2861739993095398, 0.18566612899303436, -0.24116933345794678, 1.4869163036346436, 0.2273845225572586, -0.5196429491043091, 0.4961903691291809, -1.5830020904541016, -0.7390942573547363, -0.05900222063064575, -1.666506290435791, 0.09090521931648254, -1.1691399812698364, 1.308651089668274, 0.6760890483856201, -0.22367875277996063, 0.0075526162981987, -0.3355269134044647, -1.1315757036209106, 2.177260160446167, 1.1903718709945679, -0.2666979432106018, 10.677083969116211, -0.3752991259098053, 0.7395467758178711, 0.2537824511528015, -1.163533091545105, 0.4186877906322479, -0.032997146248817444, 0.19523179531097412, 0.2047090232372284, 0.04334205389022827, 0.24725735187530518, -0.3704075515270233, 0.4714221656322479, 0.7919231653213501, -0.4111452102661133, 0.11320765316486359, 0.4229353666305542, 0.20250701904296875, 0.48623451590538025, 0.34673064947128296, 0.27985918521881104, -0.8004564642906189, 0.2261795699596405, 0.49212390184402466, -0.5544049739837646, -0.22184357047080994, -0.5168362855911255, 0.4916303753852844, 0.2435663342475891, -0.28936848044395447, 0.05426102876663208, -0.2542640268802643, 0.7103915810585022, -1.3097013235092163, -0.6812054514884949, -0.38137373328208923, 0.35757580399513245, 0.5599746704101562, -0.8894659280776978, -0.4999987781047821, 0.19511951506137848, -0.2536734938621521, 0.4336288571357727, -0.4179166555404663, 0.3782655596733093, -0.49700435996055603, 0.15618008375167847, -0.5666488409042358, 0.21525996923446655, 0.07949128746986389, 0.019041195511817932, -0.04141947627067566, 0.11145591735839844, 0.03574863076210022, 1.6114070415496826, 0.5000990629196167, -1.0955158472061157, -1.2668720483779907, 0.4358159005641937, -0.3549959361553192, -0.09019792824983597, -0.25050053000450134, -0.32153987884521484, 0.6069348454475403, -0.13890677690505981, 0.12717577815055847, 1.7183234691619873, 0.14844074845314026, 0.5427603125572205, 0.5536370873451233, 1.575773000717163, 0.9540340304374695, 0.09905087947845459, -0.410592645406723, -0.885555624961853, 0.08249820023775101, 0.20762822031974792, -0.5096715092658997, -0.5039941072463989, 1.2697030305862427, 0.8704719543457031, 1.2794504165649414, -0.6060962677001953, 0.08748915791511536, -0.778082013130188, -0.44052109122276306, -0.5006035566329956, -0.9283109903335571, -0.5675036907196045, 0.5223066210746765, 1.155895471572876, 0.14270132780075073, 0.9921962022781372, -0.9905741214752197, -0.3292789161205292, 0.1617697775363922, -0.8849731087684631, -0.14257600903511047, 0.17618943750858307, -1.2572804689407349, 0.46818727254867554, -0.2834770679473877, 0.1011388897895813, 0.104466512799263, 0.051777541637420654, 1.7501935958862305, -0.9912354946136475, 0.9172625541687012, 0.2792014479637146, 0.14738671481609344, 0.004317641258239746, -1.0981898307800293, 0.491294264793396, -0.5147110819816589, -0.21191845834255219, 1.1056764125823975, 0.1908450722694397, 0.7502333521842957, 0.8314027786254883, -0.2943481206893921, -0.06071850657463074, -0.36476945877075195, 0.8093426823616028, -0.22975406050682068, -0.07344982028007507, -0.5104179382324219, -0.1950806826353073, 0.31923991441726685, 0.6311241388320923, 0.3942614197731018, 0.9768105149269104, -0.6491969227790833, 0.6460438966751099, 0.45409873127937317, -1.1366928815841675, -0.400310218334198, 0.026917368173599243, 0.030899617820978165, -1.0171067714691162, 0.8068937063217163, 0.051458895206451416, 0.6306607723236084, 0.07325354963541031, -0.02779574692249298, -0.7782092690467834, -0.13810564577579498, -0.8472804427146912, 0.6482178568840027, 0.4343738853931427, 0.02709771692752838, 0.6197317838668823, 0.40377363562583923, 0.32891786098480225, 0.28032687306404114, -0.3728634715080261, 0.6113978624343872, -0.5838435292243958, 0.07036449015140533, -0.9232779741287231, -0.1716209053993225, 0.18794547021389008, 0.21134935319423676, 0.7441083788871765, -0.15072643756866455, -0.3314012587070465, 0.8386950492858887, 0.31759756803512573, -1.1539667844772339, -0.23354876041412354, 0.004865571856498718, -0.6814230680465698, 0.1396559625864029, -0.7512000799179077, 0.5360117554664612, -0.5626001358032227, -0.8710578083992004, 0.3943248987197876, -0.4605798125267029, 0.1916351318359375, 0.5186425447463989, 0.4920642673969269, 0.7940809726715088, 0.17801275849342346, -0.1692269742488861, -0.5595366358757019, -1.333336591720581, 0.6521267890930176, -1.2025609016418457, 0.46765005588531494, 0.6973038911819458, -0.8448268175125122, -0.38452714681625366, 0.38044315576553345, 0.11158636212348938, -0.2568868398666382, -0.7011480331420898, -0.47922635078430176, 0.8483399152755737, 0.01606065034866333, 0.503218948841095, 0.7936661243438721, -0.08617737889289856, -0.4550914466381073, 0.13926130533218384, 0.3841448128223419, 0.8877164125442505, -0.26270514726638794, -0.24086283147335052, -0.5306749939918518, -0.3050627112388611, -0.701528787612915, 0.10642820596694946, -1.2822301387786865, -0.4391228258609772, 0.039306264370679855, 1.2063424587249756, 0.057361457496881485, 1.097434639930725, 0.22745585441589355, -0.6274304389953613, -1.026311993598938, 0.14053557813167572, -0.05195605754852295, -0.9638622403144836, -0.3230445981025696, -0.01900370419025421, 1.4262382984161377, 0.649415135383606, -0.42175817489624023, -0.6776343584060669, 0.37521830201148987, -0.20172807574272156, 0.3863174319267273, -0.32300418615341187, -0.008129501715302467, -0.3294215202331543, 0.3791787326335907, -0.18606245517730713, 0.30991706252098083, 0.3327719271183014, -0.5626586675643921, 0.30327290296554565, 0.21221861243247986, 1.948738932609558, 0.3315269351005554, 0.2693924307823181, 0.4036996364593506, 0.19902408123016357, 0.8048022389411926, -0.0351838693022728, -0.5737357139587402, 0.6155307292938232, 1.1870872974395752, -0.2882426083087921, -1.0801044702529907, 0.26638513803482056, 0.5966808199882507, 0.9726555943489075, -0.1501065492630005, 0.9258439540863037, 1.2528265714645386, 1.2588248252868652, -0.806333065032959, -0.8805230259895325, -0.15087763965129852, -0.2847970724105835, 0.672758936882019, 0.26627612113952637, 1.1378295421600342, -0.619570791721344, -0.9002147912979126, -0.3571842908859253, 1.0100427865982056, 0.5378096103668213, 0.5114866495132446, 1.1594512462615967, -0.27746057510375977, 0.11041821539402008, 0.18010100722312927, -0.5645062923431396, -0.07544514536857605, -1.4434187412261963, 0.05500251054763794, -0.26769089698791504, -0.9936579465866089, 1.2443819046020508, 0.7977599501609802, -0.24335189163684845, -0.6539674997329712, 1.5583406686782837, -1.2546510696411133, -0.4349431097507477, 0.33049094676971436, -0.3763435482978821, -1.4328351020812988, 0.0416681170463562, 0.39224621653556824, 0.8423866033554077, -0.2756112217903137, -1.2752584218978882, 0.5106049180030823, 0.40484029054641724, -0.8905808925628662, -0.4331875443458557, 0.4016709327697754, 0.2866097092628479, 1.2761409282684326, -0.46098989248275757, -0.2015545666217804, -0.378663033246994, 0.5110960006713867, -0.2277693748474121, -0.24474219977855682, -0.07232805341482162, -0.5796211957931519, -0.10277930647134781, 0.2612836956977844, 0.38846689462661743, -1.4894943237304688, 0.6702402830123901, 0.5581533312797546, 0.09927672892808914, 0.23355862498283386, -1.0243487358093262, -0.9972022771835327, 0.22344738245010376, 0.8336789608001709, 0.3860499858856201, 0.8949747085571289, 0.0677570104598999, 0.09251850843429565, 0.6226048469543457, 0.18166570365428925, 0.9726380705833435, -0.3115488588809967, -0.3855094313621521, 0.3794298768043518, 0.8248649835586548, 0.0897994190454483, 0.10146042704582214, 1.1636674404144287, -0.11927694082260132, -0.3710288107395172, 1.3929755687713623, 0.5037785172462463, -1.1649837493896484, 0.4922938942909241, -0.5030602216720581, 0.5020602941513062, -0.22137252986431122, 0.633650541305542, -0.309434175491333, 0.3422635495662689, 1.6334331035614014, -1.0533831119537354, 0.44681310653686523, 2.067044973373413, 0.6485514640808105, -0.13126935064792633, 0.20722296833992004, 0.40203988552093506, -0.5506085753440857, -0.33008119463920593, 0.7456136345863342, 1.0645771026611328, 1.3177025318145752, -0.5473485589027405, 0.6771531701087952, -0.055791743099689484, -0.8640657663345337, 0.14461641013622284, 0.27330267429351807, -1.0750987529754639, 1.1683379411697388, -1.2023444175720215, -0.31937679648399353, 1.6147184371948242, -0.4784092307090759, -0.8045318126678467, -0.4362436532974243, -0.25589123368263245, 0.36014267802238464, 0.9487563371658325, -0.17910432815551758, 0.3987158238887787, 0.10952530801296234, 0.2764410376548767, -0.1560775339603424, -0.7290219068527222, -0.5428542494773865, -1.3265247344970703, 1.232373595237732, 0.4849308133125305, -0.14763978123664856, 0.31936413049697876, 1.2021582126617432, -0.05124080181121826, -0.09181465208530426, 0.2434772104024887, -0.06675949692726135, -0.28656554222106934, -0.8584275245666504, -0.5915392637252808, 0.023611634969711304, 0.49566495418548584, 0.33882710337638855, 1.3456487655639648, 0.4403266906738281, 1.4287985563278198, -0.8890992999076843, 1.4584672451019287, -0.4026137590408325, -0.5072425007820129, 0.738946795463562, -0.2318536341190338, 0.491513729095459, -0.5863957405090332, -0.791823148727417, -0.35420310497283936, 0.1283658742904663, -0.37278977036476135, -0.17611894011497498, 0.6541166305541992, -0.07941006124019623, 1.27907133102417, 0.0551513135433197, 0.8870424032211304, -2.3530263900756836, -0.33697670698165894, -0.3901437819004059, 1.379183053970337, 0.15988405048847198, -0.1737646907567978, -0.34959179162979126, -0.4075344204902649, 0.14333927631378174, -0.2616020441055298, -0.0987151563167572, 0.7011851072311401, -0.48126184940338135, -0.0994236171245575, 0.02522490918636322, -0.4694935977458954, -1.044831395149231, 0.4844616949558258, -0.004442721605300903, -0.9075477123260498, 0.31898772716522217, 0.0026455745100975037, 0.08563540875911713, -0.8046911954879761, 0.4876980781555176, -1.028488278388977, 0.3586440682411194, -0.07959270477294922, 0.6913782358169556, -0.6852188110351562, -0.16601085662841797, -0.3559313118457794, -0.39354950189590454, -0.8636708855628967, 0.11018887162208557, -0.998241126537323, -1.0408867597579956, 1.1771894693374634, -1.1550827026367188, 0.587679922580719, 0.6919980049133301, 0.7129180431365967, -1.2021740674972534, 0.5371319055557251, -0.11623954772949219, -0.3831631541252136, 0.2973766028881073, -1.205342173576355, 0.3178013563156128, -0.0761953592300415, 0.08907926082611084, -1.0805555582046509, 0.43527740240097046, 0.05048304796218872, 0.23441892862319946, 0.5573804974555969, 0.9216461181640625, 0.38475364446640015, -0.4530751407146454, -0.33623260259628296, 0.5640428066253662, 0.5869417190551758, 0.12259683758020401, -1.314158320426941, 0.02260752022266388, -0.27127426862716675, -0.08102712780237198, 0.03301972150802612, 0.3725551962852478, -0.5305841565132141, -0.32778576016426086, -0.38799959421157837, -1.3149333000183105, -0.33548927307128906, -0.6285329461097717, 0.1115797907114029, -0.09516239166259766, -0.704616129398346, 0.17601513862609863, -0.07645043730735779, 0.2963460683822632, -0.5200899839401245, 0.17364823818206787, 1.0268378257751465, -0.75385582447052, -0.15102365612983704, 0.4308429956436157, 0.08217695355415344, 0.30912864208221436, -1.095872402191162, -0.8110876083374023, 0.37473341822624207, 0.12615889310836792, -0.3828336298465729, 0.23824922740459442, 0.6354528665542603, -0.8818939924240112, 0.45322176814079285, -0.706051230430603, 0.025850504636764526, 0.021731048822402954, 0.6247569918632507, 0.7206968069076538, -0.20711341500282288, -0.49476462602615356, -1.3687688112258911, -1.0244396924972534, -0.6156498789787292, 0.2552332878112793, 0.46927791833877563, -0.059785306453704834, 0.5222265124320984, 0.8464916944503784, 0.015197984874248505, 0.1705404371023178, 0.4355364441871643, -1.2212941646575928, -1.302013874053955, 0.08277973532676697, -0.7401541471481323, -0.41292017698287964, -0.5697945356369019, -0.1085033118724823, 0.5168744325637817, -0.8689554333686829, 0.9440678358078003, 0.3631657063961029, 0.6930688619613647, -0.261049747467041, -0.645176887512207, -1.1692161560058594, 1.3376041650772095, 0.09641849994659424, -0.011782459914684296, -0.8615455031394958, -0.3578832447528839, 0.37833088636398315, 1.2329834699630737, -0.5374269485473633, 0.49623098969459534, 0.4680635631084442, -0.6706074476242065, -1.1152454614639282, -0.00640670582652092, -0.11111798882484436, 0.44099023938179016, -0.25768792629241943, 0.801510751247406, 0.902164101600647, -0.07952243089675903, -0.06378173828125, -0.03739956021308899, 0.10369212925434113, 0.3751007914543152, -0.4458857774734497, 0.7431509494781494, 1.1497440338134766, 0.2279253900051117, -0.8749423027038574, 0.5496058464050293, 1.429203748703003, -0.6189945340156555, 0.34244465827941895, -0.28553691506385803, -0.6924086809158325, 0.1343311071395874, -0.47138091921806335, 0.7011252045631409, -0.15529868006706238, 0.5402214527130127, -0.929444432258606, -0.5891609787940979, -1.2644169330596924, 0.040289267897605896, 0.19540908932685852, 0.5817223787307739, 1.0270366668701172, 0.229378804564476, 1.0627756118774414, 0.22391250729560852, 0.5628386735916138, 0.7624497413635254, 0.44640836119651794, 0.71442711353302, 0.6296993494033813, -0.8645405173301697, 0.13552527129650116, 0.35975080728530884, 0.024806298315525055, -1.0298489332199097, -0.396747350692749, -0.16690495610237122, 1.0138235092163086, -0.8116598725318909, 2.1493165493011475, -0.5407942533493042, -1.0526838302612305, 0.32752305269241333, 0.19563646614551544, -0.6309012174606323, 0.4760264456272125, -0.13770419359207153, -0.20295283198356628, -1.191309928894043, 0.5415747761726379, -0.5926333069801331, 0.9446982741355896, 0.03961604833602905, -0.013114012777805328, 0.6784154176712036, 0.3923458755016327, -0.27192309498786926, -0.30893027782440186, 0.44161373376846313, -0.9701354503631592, -0.7154232263565063, -1.3433420658111572, 4.591142654418945, -1.2300100326538086, 0.7728877663612366, -0.11938497424125671, -0.24254921078681946, -0.9527028799057007, -0.023920580744743347, -0.28122276067733765, 0.07608148455619812, -0.23159721493721008, -0.024871379137039185, -0.07860498130321503, 0.17278090119361877, -0.1119416356086731, 0.11623325943946838, -1.1602567434310913, 0.4567076861858368, -0.8268020153045654, 0.04684615135192871, -0.9242035150527954, 0.7812117338180542, -0.9980908632278442, -0.20734676718711853, 0.3976990580558777, -0.6943503618240356, 0.6651202440261841, -0.4428955018520355, -0.5895990133285522, -0.16190391778945923, -0.15441979467868805, -0.2637207806110382, -0.8220709562301636, -0.7759997844696045, -0.511989176273346, -0.6283292174339294, -0.5440883040428162, 0.5803619623184204, 0.9277993440628052, -0.3253106474876404, 0.7510417699813843, 1.7628846168518066, -0.21192312240600586, -0.6288543939590454, 0.053591907024383545, 0.499576210975647, -0.7931627631187439, 0.4697733521461487, -0.3008604943752289, -0.0366005003452301, -0.2817532420158386, -0.0666101723909378, 0.06220225989818573, 0.4505699872970581, -0.16136163473129272, 1.613295078277588, -0.729518711566925, -0.22327160835266113, 0.08287549018859863, -0.01638190448284149, 0.27997490763664246, -0.32266175746917725, 1.6958160400390625, 1.1313945055007935, 0.6225196123123169, -0.9410449266433716, 0.7336055040359497, 0.28890135884284973, 1.5285240411758423, -0.0661163255572319, -1.2093055248260498, 0.8478402495384216, -0.6935744881629944, 0.26136714220046997]
# 器 [768] [0.3271118402481079, 0.2398865669965744, -0.26556262373924255, -0.38872283697128296, 0.9435732364654541, -0.3661479353904724, -0.6954675912857056, 0.19333912432193756, -0.22752153873443604, 0.26810914278030396, -0.5432969927787781, -0.4094058871269226, 0.6032847762107849, -0.5610200762748718, -0.4453972280025482, -1.000609278678894, -0.06937005370855331, 0.6202160716056824, 0.4119313359260559, 0.4210115671157837, 0.12100037187337875, 0.3913929760456085, -0.08765214681625366, -0.9499040842056274, -0.8148966431617737, -0.11970411241054535, -0.30000609159469604, -0.5417401790618896, -0.25347262620925903, -0.524329662322998, -0.06674641370773315, -0.6281113624572754, 0.9840056896209717, -0.7947376370429993, 0.24148796498775482, 0.13187652826309204, -1.032694935798645, -0.00526544451713562, -0.17758840322494507, -0.3363928496837616, 0.4344666600227356, 0.16133065521717072, 0.6182820796966553, 0.4538533389568329, -0.02535724639892578, -0.4383530914783478, -0.5959160327911377, -0.7004311680793762, 0.8187060356140137, 0.5304467678070068, 0.0159761980175972, 10.522496223449707, -0.0018093883991241455, -0.07990603893995285, -0.19579525291919708, -0.7058683633804321, 0.41594165563583374, 0.012569710612297058, -0.24755242466926575, -0.3383980691432953, 0.012956827878952026, -0.08334898948669434, 0.42139720916748047, 0.030239351093769073, 0.1528605967760086, -0.2155143767595291, 0.19223807752132416, 0.12208801507949829, -0.5508213043212891, 0.1901569813489914, 0.22771307826042175, 0.601189374923706, -0.771701991558075, 0.3722255825996399, 0.9486677050590515, -0.3227282762527466, 0.4871130585670471, -0.47680991888046265, -0.3006134033203125, -1.3994803428649902, -0.7482055425643921, -0.10722532868385315, -0.6809541583061218, 0.20669299364089966, -0.3757933974266052, 0.592327356338501, -0.3437092900276184, -0.11102795600891113, -0.19540497660636902, -1.0187499523162842, 0.4516494572162628, 1.07876718044281, 0.12232829630374908, 0.8063575029373169, -0.3856174349784851, -0.08372308313846588, -0.9449412822723389, -0.4780502915382385, -0.3206540644168854, -0.03378314524888992, -0.7460082769393921, 0.6413986682891846, -0.052413761615753174, -0.02204720675945282, -0.28071045875549316, 1.5065038204193115, 0.732836127281189, 0.3552510142326355, -0.34116649627685547, -0.45585379004478455, -0.6105547547340393, -0.08750391006469727, -0.7657686471939087, 0.4989810585975647, 0.3558407723903656, 0.8562963604927063, 0.6423413753509521, 2.065176010131836, 0.37114885449409485, 0.22514650225639343, 0.30496957898139954, 0.9754883050918579, -0.05592459440231323, -0.4025263488292694, -0.4800476133823395, -0.8217689990997314, -0.5836721062660217, 0.5026370882987976, -0.1495783030986786, -0.4154338538646698, 0.2088952660560608, 0.11310335993766785, 0.37655144929885864, 0.40334799885749817, -0.11103767156600952, 0.027122654020786285, 0.3867420256137848, -0.15173105895519257, -1.0065363645553589, -0.5528773069381714, 0.13941136002540588, 0.35534176230430603, 0.07397922873497009, 0.12197071313858032, 0.04010164737701416, -0.8363338708877563, -0.4613051414489746, -0.19628113508224487, 0.5075901746749878, -0.07812410593032837, -0.5237783789634705, 0.3710453510284424, 0.44257891178131104, 0.22598230838775635, -0.8700827956199646, -0.17076057195663452, 0.13001811504364014, -0.6840368509292603, 1.480686902999878, 0.015991710126399994, 0.13776956498622894, -0.28921210765838623, -0.7988049983978271, -0.024952590465545654, -0.0004863142967224121, -0.8608806133270264, 0.040570393204689026, 0.7668197751045227, 0.7578950524330139, -0.4262399673461914, -0.5794854164123535, -0.08025449514389038, 0.09050670266151428, 0.3859277665615082, -0.7027846574783325, 0.24263055622577667, -0.7823705077171326, -0.336649090051651, 0.36104992032051086, 1.1047968864440918, -0.1284320056438446, 0.5659098029136658, 0.5243451595306396, -0.33733853697776794, 0.8196552395820618, -0.11885756254196167, -0.07634618878364563, -0.17617586255073547, 0.3333442211151123, -0.4189654588699341, 0.7709958553314209, 0.21778079867362976, 0.639013946056366, -0.3253941535949707, 0.3770740032196045, -0.6739015579223633, -0.1754390001296997, -0.20486487448215485, 0.13503088057041168, -0.3166104853153229, 0.06823118031024933, -0.34857895970344543, -0.36777883768081665, 0.19212888181209564, -0.2932841181755066, -0.07147061824798584, 0.10792813450098038, -0.6299639940261841, -0.2693709135055542, -0.15908755362033844, 0.6939390301704407, 0.16532060503959656, 0.751899778842926, 0.1503978818655014, -1.2919211387634277, 0.04261945188045502, 0.6073105335235596, 0.32440128922462463, -0.4783836603164673, -0.3875177502632141, 0.29179877042770386, 0.16566121578216553, -0.452995240688324, -0.15300068259239197, -0.4575681984424591, -0.056289270520210266, -0.46576592326164246, -0.001427873969078064, 0.021359354257583618, 0.04581841826438904, 0.61818528175354, 0.6884229779243469, -0.051963381469249725, -0.05906379222869873, -0.7444359064102173, -0.5868096947669983, -0.6280919909477234, -0.25793153047561646, -0.046454668045043945, 0.5608730316162109, 0.05432373285293579, -0.6654195189476013, -0.02401117980480194, -0.13490954041481018, -0.6136406660079956, 0.05974678695201874, -0.26347193121910095, -0.3302127718925476, -0.2850499153137207, -0.04146485775709152, -0.1713777631521225, 0.026493653655052185, 0.08996614068746567, -1.110485315322876, -0.31239986419677734, -0.175812765955925, 0.376038134098053, -0.20089080929756165, 0.2206980437040329, -0.3088287115097046, 0.12499800324440002, 0.17740318179130554, -0.37894266843795776, 0.074787437915802, 1.2970619201660156, -0.1769745945930481, 1.0074759721755981, -0.4648493230342865, 0.7401442527770996, 0.5193971395492554, -0.0946158766746521, 0.5752142667770386, 0.046241264790296555, -0.618910551071167, -1.3211315870285034, -0.4674948751926422, -0.2815861105918884, 1.315609097480774, -0.08441460132598877, -0.6256957650184631, 0.18379300832748413, -0.11530131101608276, 0.4894713759422302, 0.4665593206882477, 0.13699311017990112, -0.5902743935585022, -0.12454105913639069, 0.2688139081001282, 0.8842904567718506, 0.024550437927246094, 0.03558109700679779, -0.06794953346252441, -0.0627412348985672, 0.007284760475158691, 1.8998926877975464, 0.5116308331489563, -0.6253881454467773, -0.07682681083679199, 0.28092247247695923, 0.964269757270813, -0.44733306765556335, -0.42062151432037354, -0.031235694885253906, 0.9777795076370239, 0.07898062467575073, -0.1329210102558136, 0.45361822843551636, 0.5339779853820801, 0.038710832595825195, -0.026392623782157898, 0.046834588050842285, 0.10825245082378387, -0.8931022882461548, 0.15447849035263062, -0.8651176691055298, -0.3032534718513489, -0.9290450215339661, 0.258084774017334, 0.9488183259963989, 0.451992392539978, -0.5329271554946899, -0.16742613911628723, -0.2128605842590332, 0.3578305244445801, 0.620207667350769, 0.5691002011299133, 0.48645609617233276, -1.1376848220825195, 0.29179733991622925, 0.052847981452941895, 0.045639052987098694, 0.09848666191101074, -0.27597951889038086, 0.20132625102996826, -0.014316022396087646, -0.8463947176933289, 0.12408789992332458, 0.8780382871627808, -0.5971583724021912, -0.10175340622663498, 0.5997899770736694, -0.4155144691467285, 0.14958582818508148, -0.04424862563610077, -0.2913857400417328, 0.2040621042251587, -0.28553226590156555, 0.6423404216766357, 1.0892970561981201, -0.05319300293922424, -0.8824529647827148, -0.563022255897522, -0.45208078622817993, -1.1249130964279175, 0.029118657112121582, 0.42539602518081665, 1.0431973934173584, 1.0158262252807617, -0.325011670589447, -0.6989456415176392, -0.6276254653930664, 1.0117017030715942, -0.31940460205078125, -1.3612301349639893, -0.1316656768321991, -0.35878369212150574, -0.2381991446018219, 0.17211095988750458, 0.13761860132217407, -0.6800463199615479, 0.44687002897262573, 0.0349118709564209, 0.7409529685974121, -0.09928414970636368, -0.5217446088790894, -0.2388678640127182, -0.39473605155944824, 0.8076604604721069, -0.06677679717540741, 0.4392961859703064, -0.11348382383584976, 0.6623642444610596, 0.5387639999389648, 0.7077582478523254, 0.8468586206436157, 0.1072375476360321, 0.04910345375537872, -0.04207261651754379, 0.5496394634246826, -0.2395164668560028, -0.30253246426582336, 0.27775752544403076, -0.08223329484462738, -0.0410611629486084, 1.4050993919372559, 0.31755805015563965, 0.05937248468399048, 0.4617568850517273, -0.200197234749794, 0.4999473989009857, -1.0856341123580933, 0.333285391330719, -0.06586183607578278, 0.7542735934257507, 0.4141361713409424, -0.8817558884620667, 0.7312418818473816, 1.3922048807144165, 0.36981692910194397, 0.3104446530342102, -0.3066532611846924, 0.6123530864715576, -0.6576187610626221, 0.0486375093460083, -0.2271752953529358, 0.8344030976295471, 0.9492483139038086, -0.3496466875076294, 0.5019941329956055, -0.0018671900033950806, -0.526263952255249, -0.6632636785507202, -0.118105947971344, -0.28706127405166626, 0.8234825134277344, -0.27974486351013184, -0.312287300825119, 1.2370779514312744, 0.2658666968345642, 0.23743519186973572, 0.5217164754867554, 0.8754464387893677, -0.8510128855705261, 0.8291226625442505, -0.37806200981140137, -0.19135653972625732, -0.563336193561554, 0.7733801007270813, 0.530430793762207, -1.0721697807312012, -0.2859354615211487, 0.7670531868934631, 0.674965500831604, 0.42617547512054443, -0.07692287117242813, 0.9244350790977478, 0.9006996750831604, 0.0267258882522583, -0.026250628754496574, 0.6122151613235474, 0.3188105821609497, -0.6231327056884766, -0.2977389395236969, -0.3502053916454315, 0.3128226399421692, -0.5777525305747986, -0.2640935778617859, 1.3723808526992798, 0.21685023605823517, -0.23056340217590332, -1.1824980974197388, 0.7598018050193787, 0.058122873306274414, -0.38508105278015137, 0.27766913175582886, 0.37310048937797546, -0.8357014656066895, -0.476264625787735, -0.22602777183055878, -0.33937907218933105, -0.26999881863594055, -0.6225466728210449, 0.13800859451293945, 0.9453465342521667, 0.2860640287399292, 0.016493799164891243, 0.5143194198608398, 0.12777377665042877, -2.1392619609832764, -0.01673409342765808, -0.08492186665534973, 0.16602742671966553, 1.0147037506103516, -0.35844844579696655, 0.6940205693244934, -0.12351220846176147, -0.3386117219924927, 0.3107481300830841, -0.6312853097915649, 0.05704149603843689, 0.42574387788772583, -0.024379238486289978, -0.20096853375434875, 0.5067150592803955, -0.6117691993713379, 0.1211492121219635, 0.7877265810966492, 0.2815989851951599, 0.32696568965911865, -0.7455092668533325, 0.5626188516616821, -0.058070287108421326, -0.19919684529304504, -1.2425812482833862, -0.10496018826961517, 0.6140255928039551, -0.03563804179430008, -0.09912675619125366, -0.09116107225418091, -0.4725971221923828, -0.363994836807251, -0.8463783264160156, 0.03653223067522049, -1.223466396331787, 0.47182685136795044, 0.7361264228820801, 0.025047792121767998, 0.5523139238357544, -0.06283406168222427, 0.899376392364502, -1.166929006576538, 0.4127541780471802, -0.37254562973976135, -0.251674622297287, 0.2141081988811493, -0.21562393009662628, 0.4642828404903412, -0.16873320937156677, 0.18329505622386932, -0.7972169518470764, 1.6900509595870972, 0.7641552090644836, 1.023636817932129, 0.9052605628967285, -0.9581515789031982, 0.328560471534729, -0.9299558401107788, -0.9174761176109314, 0.5745185613632202, 0.38594600558280945, -0.05128300189971924, -1.1434943675994873, 0.5701208114624023, -0.4198416471481323, -0.2947249412536621, 0.47279566526412964, 0.13152530789375305, 0.09714499115943909, -0.2935739755630493, 0.14955195784568787, -0.5168606042861938, 0.09604512155056, -1.5767298936843872, -0.3891443610191345, -0.14503318071365356, -0.6339356899261475, 0.6842127442359924, 0.23537474870681763, 0.23914358019828796, -0.2792940139770508, 0.34133419394493103, 0.7319027185440063, -0.36885151267051697, -0.0972747653722763, 0.03204743564128876, 1.02753484249115, -0.00177803635597229, -0.8476541042327881, -0.22021445631980896, 0.27356916666030884, -0.017357468605041504, -0.4486820101737976, 0.3961375951766968, -0.08200153708457947, -0.4314427971839905, 0.6824147701263428, -1.4583771228790283, -0.19091826677322388, 0.4599168300628662, -0.372165322303772, 0.20153608918190002, 0.16964073479175568, -0.01575438678264618, -0.8068089485168457, -0.13008072972297668, -1.6336301565170288, 1.1947355270385742, 0.01888170838356018, 0.06030479073524475, -0.04281531274318695, 0.23285965621471405, -0.44996029138565063, 0.6904721260070801, 0.2867075204849243, -0.8642791509628296, 0.3528270721435547, 0.4116230309009552, 0.2909386456012726, 0.07793422788381577, -0.8654399514198303, -0.08702608942985535, 0.38782209157943726, 0.5474531650543213, -0.3799401819705963, 1.1628963947296143, 0.6848013401031494, 0.4013929069042206, 0.3740784525871277, -1.153745412826538, 0.4271526038646698, -0.0014039278030395508, -0.08261420577764511, -0.10496174544095993, 0.6577809453010559, -0.08970949053764343, 0.13260143995285034, 0.6350550651550293, 0.5989487767219543, 1.2619227170944214, -0.15962448716163635, -0.49833327531814575, -0.20972603559494019, -0.20676802098751068, 0.5453957319259644, 0.3336436152458191, 0.1518980860710144, 0.2697107195854187, -0.035666584968566895, 0.5280819535255432, -0.030844122171401978, -0.5740718245506287, -0.05253838747739792, -0.1028929278254509, -0.32131755352020264, 0.8663873672485352, 0.1711731255054474, 0.38178277015686035, 0.7068312168121338, 0.3486272096633911, 0.286386638879776, 0.007424905896186829, -0.06252631545066833, -0.4250168800354004, 0.5850660800933838, -0.31713786721229553, 0.2530931830406189, -0.12535175681114197, -0.15886425971984863, -0.19718994200229645, -0.5385422706604004, -0.13422363996505737, 0.8806891441345215, -0.1607273668050766, -0.2587206959724426, 1.1161143779754639, -0.28844714164733887, 1.4745609760284424, 0.6576626300811768, 0.6837910413742065, -0.06848273426294327, 0.5790087580680847, 1.2112653255462646, -0.32088643312454224, 0.038744598627090454, -0.6866986751556396, -0.653823733329773, 0.11934200674295425, -0.5365331172943115, -0.06001271307468414, -0.07706001400947571, 0.7905871272087097, -0.24879688024520874, 1.7306722402572632, 0.7608837485313416, -1.0936836004257202, -0.04977685213088989, -0.16149954497814178, -0.14416824281215668, 1.033026099205017, -0.02459883689880371, 0.24764883518218994, -0.5844156742095947, 0.4510768949985504, -0.32717421650886536, 0.3681490421295166, 0.17862367630004883, 0.22569552063941956, -0.08211812376976013, 0.06384297460317612, 0.5121382474899292, -0.23144862055778503, 0.3685431480407715, -0.7736953496932983, -0.3942034840583801, -0.407838374376297, 5.95603084564209, 0.6394795775413513, -0.3032582700252533, 0.6517899036407471, -0.12587353587150574, -0.8916573524475098, 0.08764195442199707, 0.023333795368671417, 0.264376699924469, -1.4119831323623657, 0.13214126229286194, -0.40981513261795044, 0.6759250164031982, -0.34610986709594727, 0.41956180334091187, -0.5828118920326233, 0.32867351174354553, -0.8105259537696838, 0.6413087844848633, 0.05105811357498169, 0.296119749546051, -0.9144022464752197, 0.18195289373397827, -0.5877746939659119, -0.45317378640174866, 0.511062741279602, -1.2207585573196411, -0.7903684377670288, 0.5686142444610596, 0.5583428740501404, 0.6013209819793701, -0.41930997371673584, -0.6664741039276123, -0.9942090511322021, -0.0761297345161438, 0.22103513777256012, 0.04493473470211029, 0.4838815927505493, 0.6327858567237854, 0.3677760064601898, 0.19292563199996948, -0.8724125027656555, -0.47280019521713257, 0.7851178050041199, 0.6771436929702759, 0.5169581174850464, 0.16998490691184998, -0.3868885040283203, 0.6680024266242981, -0.2681344747543335, -0.7201371192932129, -0.4177223742008209, 0.2260323464870453, 0.28738346695899963, 1.9850044250488281, -0.2886892557144165, 0.3519212305545807, -0.5045930743217468, 0.04052524268627167, 0.40773794054985046, -0.6109652519226074, 1.8357938528060913, 0.7263497114181519, 0.6930569410324097, -0.194664865732193, 0.8395650386810303, -0.38293248414993286, 0.09116001427173615, 1.1147868633270264, -0.11913329362869263, 0.40922969579696655, 0.21586789190769196, -0.056883543729782104]
# 人 [768] [0.28108522295951843, 0.07525806128978729, 0.34229356050491333, 0.05783651024103165, 0.15294507145881653, -0.5328042507171631, -0.6923714876174927, 0.6324507594108582, -0.19637152552604675, 0.621239423751831, -0.18979576230049133, -1.4416723251342773, -0.5282493233680725, 0.14964699745178223, 0.5647559762001038, 0.7093667387962341, 0.35276854038238525, 0.2540609538555145, 1.0417835712432861, 0.17702028155326843, -0.2127196192741394, 0.13350613415241241, 0.7829400300979614, -0.07452761381864548, 0.041157662868499756, -0.2610462009906769, 0.3677729368209839, -1.004981279373169, 0.17429125308990479, -0.3832709789276123, -0.0765601322054863, 0.21026620268821716, 0.09452462196350098, -0.0347372442483902, 0.008736878633499146, -0.24195481836795807, -0.6913324594497681, 0.45660340785980225, 0.28900861740112305, 0.3698764741420746, 0.09640347957611084, 0.24376536905765533, 0.5111780166625977, 0.4632512927055359, 0.2256012111902237, -0.38602858781814575, -1.2221267223358154, -1.06699800491333, 0.8323937058448792, 0.6332876682281494, 0.9847374558448792, 11.431238174438477, 0.08030705153942108, -0.5634109973907471, 0.16656994819641113, 0.024258464574813843, 0.7124134302139282, 0.36049678921699524, -0.2579343914985657, -0.4839024543762207, -0.2797757387161255, 0.19234338402748108, -0.25664493441581726, 0.472922682762146, 0.5196115374565125, -0.7703583240509033, 0.24810610711574554, 0.4290614724159241, -0.21951138973236084, -0.4147152304649353, 0.8018250465393066, 0.5077885389328003, -0.9355421662330627, 0.07942992448806763, 0.0076829493045806885, -0.9560081362724304, 0.030546069145202637, -0.8363357782363892, -0.2917442321777344, -0.8632226586341858, -0.5942226648330688, 0.29339462518692017, -1.280080795288086, -0.3848802447319031, -0.649321436882019, 0.3960466682910919, -0.5446368455886841, -0.5080733895301819, 0.20997753739356995, 0.05554210767149925, -0.4556169807910919, -0.08602336049079895, 0.09583023190498352, 0.2242724895477295, -0.38566938042640686, -0.33203959465026855, -1.0535087585449219, -2.1986281871795654, -0.30312293767929077, -0.9996970891952515, -0.6665645241737366, -0.20975446701049805, 0.1741030514240265, -0.7940362691879272, -0.17459028959274292, 0.5206230878829956, -0.18285183608531952, 0.134397953748703, -0.964256763458252, -0.4436376392841339, -0.36404067277908325, 0.40125012397766113, 0.8932784795761108, 0.5221062898635864, 0.3605510890483856, 0.1881365031003952, 0.433641254901886, 1.5821797847747803, -0.2167215347290039, 0.6520259380340576, 0.2035215049982071, 0.48246681690216064, -0.31714242696762085, 0.24047553539276123, -0.3073540925979614, -1.332682490348816, -0.02192789316177368, 0.2924443185329437, -0.3183808922767639, 0.4149169325828552, 0.2792930603027344, -0.07717074453830719, 1.6913739442825317, 0.40769097208976746, -0.21851569414138794, -1.0361289978027344, 0.25582218170166016, 0.07622536271810532, -0.7013002038002014, -1.1194427013397217, -0.32200413942337036, 0.3157781660556793, -0.2570304572582245, 0.3225705325603485, 0.027198493480682373, -0.045928969979286194, 0.11507914215326309, -0.18471083045005798, 0.3756325840950012, 0.20622816681861877, -0.06681306660175323, 0.37322914600372314, -0.2451012134552002, -0.09255921840667725, 0.5255596041679382, -0.6726043224334717, 0.7722852230072021, -0.38137227296829224, 0.23092079162597656, 0.27568528056144714, -0.5586730241775513, -0.6687871217727661, 0.5974999666213989, 0.48781919479370117, -1.084350347518921, -0.867990255355835, -0.037532635033130646, 0.6138334274291992, -0.678606390953064, 0.34824317693710327, -0.4540911316871643, 1.0499348640441895, -0.2353997677564621, 0.9208742380142212, -0.2697390615940094, 0.13512560725212097, 0.3641614317893982, -0.6389724612236023, -0.018521040678024292, 0.12756434082984924, -0.8465473651885986, 0.8494376540184021, 0.39105042815208435, -0.3030470907688141, 0.7874483466148376, -0.07773005962371826, -1.16628098487854, -0.7837293744087219, 0.020190995186567307, -0.36815816164016724, 0.5226561427116394, 0.47973936796188354, 0.7692646980285645, 0.16637322306632996, 0.7497234344482422, -0.026766173541545868, 0.18283288180828094, -0.02385161817073822, 1.0828688144683838, 1.2347161769866943, -0.45180240273475647, 0.9516382217407227, -1.1259615421295166, -0.6977179050445557, -0.28335338830947876, -0.647135317325592, 0.050059810280799866, 0.30070942640304565, -1.0126899480819702, -0.9098637104034424, -0.3300381898880005, 0.026791177690029144, -0.4970797300338745, 0.9868761897087097, -0.5021417737007141, 0.7074781656265259, 0.8118839263916016, 0.04431711509823799, -0.36382347345352173, -0.31104859709739685, 0.4724418818950653, -0.5748935341835022, 0.48150062561035156, -0.6332160234451294, -0.30460500717163086, -0.5641674399375916, -0.012548506259918213, -0.00731012225151062, -0.7169691920280457, 0.6093289852142334, 1.2401046752929688, 0.5484278798103333, 0.1880423128604889, 0.6743768453598022, -0.35841676592826843, -0.5137398838996887, -0.5356705188751221, -0.47788694500923157, 0.3975571393966675, 1.0298876762390137, 0.41724422574043274, -0.7107229232788086, -0.4332242012023926, -0.4760019779205322, 0.6768208742141724, 0.7439957857131958, -1.0927815437316895, -0.37591639161109924, 0.09445008635520935, -0.28407540917396545, 0.30114638805389404, 0.507445216178894, -0.487079381942749, -1.1768375635147095, -0.4888578951358795, 0.26253074407577515, 0.227372407913208, 0.05801285058259964, 0.5581492781639099, 0.22256463766098022, -0.2113775759935379, 0.19626766443252563, 0.1382644772529602, -0.580208420753479, -0.3378647565841675, 1.317029356956482, 0.5082446336746216, -0.0630715936422348, 1.3643625974655151, 0.9202199578285217, 0.5100959539413452, 0.05297465622425079, -0.025808066129684448, -0.6524631381034851, -0.36489012837409973, 0.10142546892166138, 0.35605472326278687, -0.07559911906719208, -0.2280806303024292, -0.5485916137695312, -0.16622516512870789, -0.39007970690727234, 0.16344422101974487, 0.021607376635074615, 0.08632391691207886, -0.07672465592622757, -0.29617029428482056, -0.4800143241882324, 0.6299178600311279, -0.5910313725471497, -0.47786688804626465, -0.15932023525238037, 0.2699885070323944, 1.0010144710540771, 1.398381233215332, 0.48540163040161133, 0.8248687982559204, 0.11499759554862976, 0.2175804227590561, 0.16512703895568848, -0.26460978388786316, 0.5919218063354492, 0.35540908575057983, 1.2493376731872559, -0.6733993887901306, -1.5229355096817017, -0.3858407139778137, -0.15753577649593353, 0.9159916639328003, 0.16799980401992798, 0.08602195978164673, 0.13046550750732422, -0.8671307563781738, 0.3058842122554779, -0.007864505052566528, -0.2583087682723999, -0.49985045194625854, 0.4270499646663666, 0.45934534072875977, 0.5278910994529724, -0.6915650367736816, -0.3083575367927551, 0.5203567147254944, 0.6536919474601746, 0.38156062364578247, -0.22059598565101624, 0.6329066753387451, 0.4724007248878479, 1.204546332359314, 0.16288715600967407, -0.9625966548919678, 0.29497745633125305, 0.13620437681674957, -0.9360912442207336, 0.4187471568584442, -0.7088292837142944, 0.5852095484733582, 0.042019009590148926, -0.312846839427948, -0.9673712253570557, 0.7892986536026001, -0.16793571412563324, 1.5470167398452759, -0.006085693836212158, 0.28463536500930786, 0.08699864149093628, -0.7249490022659302, 0.4027385115623474, 0.3514575660228729, 0.9299172163009644, -0.7005883455276489, -0.6253969669342041, -0.7735584378242493, -0.6645752191543579, 0.1253260225057602, 0.6146134734153748, 0.18931996822357178, 0.9959069490432739, -0.23826837539672852, 0.3163895010948181, -0.6269236207008362, 1.1038569211959839, 0.4512460231781006, -0.4627431035041809, -0.17514261603355408, 1.3926979303359985, 1.4053974151611328, 1.0668531656265259, 0.4711841940879822, 0.007147669792175293, -0.24540716409683228, -0.15866339206695557, -0.07432417571544647, -0.4709646999835968, -0.8947425484657288, -0.12493917346000671, -0.9748060703277588, 0.2617295980453491, -0.4923323392868042, 0.7558703422546387, -0.9519919157028198, 0.12248905003070831, 0.6390618681907654, 0.4544575810432434, 0.49281829595565796, 0.07484062016010284, -0.6852470636367798, -0.5589478015899658, 0.6358621716499329, -0.028068561106920242, -0.7567849159240723, 0.07280340045690536, -0.27851369976997375, 0.6086700558662415, 0.23492062091827393, 1.3582042455673218, 1.1851227283477783, 0.045340389013290405, -0.43118900060653687, -0.21300557255744934, -0.2659217119216919, -0.19216537475585938, 0.5518698692321777, -0.2682148516178131, 0.07898132503032684, 0.4862161874771118, 1.1268335580825806, 0.9506916999816895, 0.40161168575286865, -0.4820600748062134, -1.0196205377578735, 0.5901697874069214, -0.27962642908096313, 0.4282345771789551, 0.8741825819015503, -0.9065404534339905, 0.009087741374969482, -1.1456217765808105, 0.4648221433162689, -0.3048638105392456, -0.258190393447876, -0.5901477336883545, 0.05959416925907135, -0.01432850956916809, 0.480956107378006, -1.123537540435791, -0.7006004452705383, -0.25955674052238464, 0.2014838308095932, 0.3935987055301666, -0.21675917506217957, -0.3563383221626282, -0.16978676617145538, 0.7433251738548279, 0.03609675168991089, -0.4338158071041107, -0.5230586528778076, 0.9432349801063538, 1.0264705419540405, -0.9023046493530273, 0.3990858793258667, -0.22863343358039856, 0.9669562578201294, 1.1427991390228271, -0.2956192195415497, 1.0563254356384277, 0.20050093531608582, -0.06434722244739532, -1.0024150609970093, 0.3906024098396301, 0.7229664325714111, -0.0683877244591713, -0.16206929087638855, -0.1779208779335022, -0.04689864069223404, -0.028605520725250244, 0.6858898997306824, 0.4588325321674347, 0.08140063285827637, -0.02094019204378128, -0.5130025148391724, 0.968084990978241, -0.7606285810470581, 0.3156224489212036, 0.24476706981658936, -0.6486234664916992, -0.042870789766311646, 0.4018765687942505, -0.5456869006156921, -1.005544662475586, -0.4365498423576355, -0.6738587617874146, -0.7766924500465393, 0.4299832582473755, 0.2953527867794037, -0.06874313205480576, 0.5615730285644531, 0.007271513342857361, -1.9436200857162476, -0.5436697006225586, -0.3317640423774719, -0.6787194609642029, 0.9107304811477661, -0.5209242105484009, 1.1341089010238647, -0.2518253028392792, 0.3831675350666046, 0.7817698121070862, -0.5082913041114807, -0.9997636675834656, 0.42983269691467285, 0.4253394305706024, 0.5819712281227112, 0.5729283094406128, -0.4485454559326172, -0.1444162130355835, 1.1335445642471313, -0.7743730545043945, 1.0642435550689697, -0.8372003436088562, -1.0781490802764893, -0.035149186849594116, 0.7884140014648438, -1.7954645156860352, 0.4252958595752716, 0.27425137162208557, -0.5292301177978516, -0.6369231343269348, -0.5172454118728638, -1.0221149921417236, 0.07875265181064606, -1.9048714637756348, 1.3843308687210083, -0.7896119952201843, 1.454120397567749, 0.18114641308784485, 0.2322617471218109, 0.21504628658294678, 0.37215375900268555, 0.2309897243976593, -0.8482460975646973, -0.25587332248687744, 0.45821502804756165, -0.14082114398479462, -0.3184017837047577, -0.21636025607585907, -0.027850136160850525, 1.1241552829742432, 0.5378018021583557, -0.5794115662574768, 0.68360835313797, 0.23626086115837097, 0.36386165022850037, 0.3263673782348633, -0.18783308565616608, 1.2779960632324219, 0.28541669249534607, 0.10526332259178162, 1.3551355600357056, 0.4754694700241089, 0.8549709320068359, -0.6447423696517944, 0.8116903901100159, -0.7522605657577515, 0.08122831583023071, 0.03087592124938965, 0.25211119651794434, 0.17558220028877258, -0.16951514780521393, -0.20504415035247803, -0.2771436274051666, 0.3274550139904022, -0.6832670569419861, 0.5515527725219727, -0.35877686738967896, 0.14275528490543365, 1.1217827796936035, 0.12752383947372437, 1.3343981504440308, -0.08574433624744415, 0.08846855163574219, 1.0230815410614014, -0.3558346927165985, -1.45158052444458, 0.09940803050994873, -0.012613222002983093, 0.24512231349945068, -0.14982019364833832, -0.05269235372543335, 0.16438573598861694, 0.5397610664367676, -0.06241209805011749, -0.07527853548526764, -0.628042459487915, -0.8419065475463867, 0.700725793838501, -0.9587698578834534, -0.5621129870414734, -0.27966007590293884, -0.001993652433156967, 0.23767909407615662, 0.08179860562086105, 0.5415405631065369, -0.6283141374588013, -0.08505114912986755, -0.5580505132675171, -0.21975819766521454, 0.1681319922208786, -0.06034635007381439, -0.09070851653814316, 0.4814365804195404, -0.5012644529342651, -0.10324060916900635, 0.8146148920059204, -0.8633264303207397, 0.6490021347999573, 0.2998219132423401, 0.28368672728538513, -0.7413442134857178, -0.3426099121570587, 0.22272473573684692, 0.16776901483535767, -1.2885158061981201, -0.21574197709560394, 0.7896901369094849, 0.20114701986312866, 0.44636890292167664, 0.3115299940109253, -1.808199167251587, -0.7723904848098755, 0.4453801214694977, 0.15675094723701477, -0.07854360342025757, 0.8360058069229126, -0.14075148105621338, 0.09621592611074448, -0.08577032387256622, 0.8651070594787598, 0.057581961154937744, 0.3947123885154724, -0.04525327682495117, -1.4788851737976074, 0.04964812099933624, 0.24584385752677917, -0.34141236543655396, -0.7010796070098877, 0.840027928352356, 0.1250232458114624, 0.3176131844520569, -0.3161690831184387, -0.2660531997680664, -0.4074324369430542, 0.2655455768108368, 0.12493354827165604, 0.6610196232795715, -0.587098240852356, -0.06804588437080383, 0.8181726932525635, 1.2985219955444336, 0.22714351117610931, 0.1588362753391266, -0.2535708248615265, 0.5701658129692078, 0.10263493657112122, 0.6945198774337769, -0.10248363018035889, -0.022897519171237946, 0.3979124128818512, 0.42789655923843384, -0.7434776425361633, 0.1516924500465393, 0.308511346578598, -0.7296313047409058, 0.28577736020088196, 0.9101690649986267, 0.2323765903711319, 1.321987271308899, 0.04303670674562454, 0.9383267164230347, 0.4096088111400604, -0.7670027017593384, 0.8688296675682068, 0.32690107822418213, -0.2095387876033783, 0.27993044257164, -0.3022419810295105, -0.928147554397583, -0.3575488328933716, -0.6413609385490417, 0.8875417709350586, 1.1883846521377563, 0.20309555530548096, 1.3109630346298218, 0.6666368246078491, 0.2066890001296997, 0.24713444709777832, -0.22446145117282867, -0.7276344299316406, 0.16104359924793243, -0.46251893043518066, 0.016789734363555908, -0.45391330122947693, 0.4753105342388153, 0.5377498269081116, 0.37633639574050903, 0.9078729152679443, 0.33157020807266235, -0.12352254986763, -0.32915812730789185, -0.31304511427879333, -0.873308539390564, 0.3432989716529846, -0.5346798896789551, -0.4434301257133484, -1.0972915887832642, 6.916627883911133, -0.2012026309967041, -0.15300226211547852, 0.002494990825653076, -0.19505488872528076, -0.7140925526618958, -0.4602805972099304, -0.21588234603405, -0.5870425701141357, -1.0983211994171143, -0.11263798177242279, 0.8770760297775269, 0.8023574352264404, -0.8967949748039246, -0.06319377571344376, 0.09613165259361267, -0.2029941976070404, -0.8426550030708313, 0.783276379108429, -0.16846996545791626, 0.42215001583099365, -0.822402834892273, -0.16568735241889954, -0.7966278791427612, 0.5913491249084473, 0.1505463421344757, -1.6566513776779175, -0.460368275642395, 1.364917278289795, 0.07665318250656128, 0.06200528144836426, -0.23606693744659424, -0.5874737501144409, 0.3392089009284973, -1.2721292972564697, -0.35901397466659546, -0.03767058998346329, 0.4058035612106323, 0.300561785697937, 0.04920349270105362, 0.5631176233291626, 0.16302452981472015, -1.3095970153808594, 0.749226450920105, 0.30034226179122925, 0.4131329655647278, 0.35358041524887085, 0.6983541250228882, 0.7048249840736389, -1.0908550024032593, -0.25499311089515686, -0.1473558247089386, 0.7779489755630493, -0.554087221622467, 2.0329513549804688, -0.6348397731781006, -0.731803297996521, -0.4677788019180298, -0.6030069589614868, 0.7644795179367065, -0.4247218370437622, 2.3036043643951416, 0.3739843964576721, 0.3980151414871216, 0.06927774846553802, 0.25455498695373535, 0.5328711271286011, 1.1793732643127441, -0.22031080722808838, -0.5864792466163635, 0.6192903518676758, 0.4964943826198578, -0.23144733905792236]
# 是 [768] [0.6684560179710388, -0.33169132471084595, -0.41387438774108887, -0.09412416070699692, 0.7884924411773682, 0.09874678403139114, -0.23025500774383545, 0.12183864414691925, -0.07348713278770447, -0.036947935819625854, -0.681850790977478, -0.4284735918045044, 0.2708970010280609, 0.24353739619255066, 0.29330646991729736, -0.004978835582733154, 0.6074370741844177, 0.6925705075263977, 0.6705710887908936, 0.12662458419799805, -0.7175693511962891, 0.31292882561683655, -1.0404303073883057, 0.06154990941286087, 0.6086941957473755, -0.025496572256088257, -0.2794712781906128, -0.7008131742477417, 0.33307552337646484, -0.9286636114120483, -0.37285512685775757, 0.32409748435020447, 0.02896888554096222, -0.5901965498924255, -0.08769495785236359, 0.6423203349113464, -0.6917992234230042, 0.6853329539299011, -0.2074795961380005, 0.022674560546875, 0.3060094118118286, -0.1492457538843155, 0.7393616437911987, 0.1928616762161255, 0.0956222265958786, -0.04406728968024254, -0.3882971704006195, 0.19331392645835876, 1.3796874284744263, 0.8993518352508545, -1.0333311557769775, 9.17457103729248, 0.20066989958286285, -0.17938905954360962, -0.5079652667045593, 0.5059559345245361, -0.2430855631828308, -0.54859459400177, 0.12468921393156052, 0.015157237648963928, -0.6244661808013916, -0.14238712191581726, -1.0426901578903198, 0.1271950602531433, 0.12597018480300903, 0.1878701150417328, 0.967449426651001, -0.36727645993232727, 0.33141446113586426, -0.18666571378707886, -0.14723044633865356, -0.27703723311424255, -0.06401956081390381, 0.3985801041126251, -0.22655513882637024, -0.38113832473754883, -0.5223829746246338, -0.21977227926254272, 0.14050514996051788, -0.09245175123214722, -0.44616079330444336, -0.5689082741737366, -0.8827780485153198, 0.7136531472206116, -0.5548841953277588, -0.12594595551490784, 0.1004030704498291, 0.4440677762031555, 0.22039565443992615, -0.2990657091140747, 0.1877627670764923, 0.10963575541973114, -0.023522015661001205, -0.46581128239631653, -0.02508947253227234, -0.4405706226825714, -0.0338742733001709, 0.06406593322753906, 0.10548558831214905, 0.5861644148826599, -0.6777303814888, 0.6211680769920349, -0.04668509215116501, -0.12575966119766235, -0.2611504793167114, -0.7717639207839966, 0.4616939425468445, 0.1349155753850937, -0.7752302885055542, 0.23730683326721191, -0.21795083582401276, -0.7194672226905823, 0.1509615182876587, 0.16718927025794983, 0.20745930075645447, 0.6214895844459534, -0.19018153846263885, 0.98725825548172, -0.7262275218963623, -0.3533015251159668, 0.2825601100921631, 0.10827892273664474, 0.8180553913116455, -0.2848609983921051, 0.29030683636665344, -1.4141507148742676, -0.4960048794746399, 0.4198833405971527, -0.2051088511943817, 0.11909633874893188, 0.34517574310302734, -0.4657187759876251, 1.5604569911956787, 0.6090659499168396, -0.21855659782886505, -0.6699791550636292, 0.33482372760772705, -0.9197052121162415, -0.33076247572898865, 0.07601374387741089, -0.5828544497489929, -0.4237452447414398, -0.5026441812515259, 0.008616581559181213, 0.005151316523551941, 0.0073480140417814255, 0.17332959175109863, -0.453710675239563, 0.7070804834365845, 0.1741814762353897, -0.43924206495285034, -0.15265551209449768, 0.34197407960891724, 0.08816259354352951, -0.07100722193717957, -0.34140631556510925, 0.26631492376327515, -0.5785279870033264, 0.18889978528022766, -0.7416577339172363, -0.08259511739015579, -0.005673084408044815, -0.25511056184768677, 0.11834931373596191, 0.044982701539993286, -1.1972242593765259, -0.38524651527404785, 0.08114765584468842, -1.2849290370941162, 0.530408501625061, 0.6789170503616333, 0.147842139005661, 0.07842755317687988, 0.37975096702575684, -0.6034027934074402, 0.45204126834869385, -0.8541531562805176, -0.5881185531616211, 0.7822500467300415, -0.08825193345546722, -0.34973374009132385, -0.044461190700531006, 0.13673561811447144, 0.17155079543590546, 0.5291622281074524, 0.24574437737464905, 0.7370692491531372, 0.012369371950626373, 0.2614108920097351, -1.398860216140747, 0.5910286903381348, 0.9794294834136963, -0.5597520470619202, -0.40019071102142334, -0.7261726260185242, -0.3129539489746094, -0.15829400718212128, 0.3313293755054474, 0.5405492782592773, 0.6848540306091309, -0.11545723676681519, 0.14110741019248962, 0.36492183804512024, 0.3006981611251831, -0.4068663716316223, 0.174556702375412, 0.5611867904663086, 0.16600221395492554, -0.7539838552474976, 0.005777567625045776, -0.2743668556213379, -0.32118141651153564, 0.5023791193962097, 0.6593701243400574, -0.11738274991512299, 0.3357222080230713, 0.29795756936073303, -0.3097960948944092, 0.016433507204055786, 0.044032640755176544, -0.23672333359718323, 0.1409110128879547, -0.31686219573020935, -0.5901281833648682, -0.08009257912635803, -0.4544464349746704, 0.47696438431739807, 0.42351192235946655, -0.22357973456382751, 0.5530175566673279, 0.6995561718940735, 0.3637547492980957, -0.09725842624902725, 0.7207871675491333, 0.34770509600639343, -0.22815191745758057, -0.02039790153503418, 0.06424269080162048, 0.3743416965007782, 0.2242303490638733, -0.16514895856380463, -0.11767677962779999, -0.09998707473278046, -0.18192584812641144, -0.39444249868392944, 0.5143401026725769, -0.5836191177368164, -0.3098021447658539, -0.32747361063957214, -0.37062379717826843, 0.053882092237472534, 0.46333983540534973, -0.6338024139404297, -0.4650881886482239, -0.25394147634506226, -0.2624989449977875, 0.5316097736358643, 0.004329174757003784, 0.15308788418769836, 0.35226911306381226, -0.15247806906700134, -0.09172269701957703, 0.015513181686401367, 0.14788079261779785, 0.75458824634552, -0.2486429661512375, 0.41649168729782104, -0.6062334775924683, 0.6164923906326294, 0.07799142599105835, -0.4878540337085724, 0.4486966133117676, -0.6039038300514221, 0.4572044610977173, -0.43032020330429077, 0.4799115061759949, 0.7201073169708252, 0.3172287940979004, -0.22752830386161804, -0.41837185621261597, 0.014129847288131714, 0.2368493378162384, 0.34991195797920227, -0.5054149627685547, 0.08131388574838638, -0.5507604479789734, 0.2907135784626007, 0.7169100642204285, 0.5415640473365784, -0.17693713307380676, -0.17472527921199799, -0.7253131866455078, -0.6824750900268555, 0.8609102964401245, 0.8690441250801086, 0.5939093232154846, 0.2330169975757599, 0.042082250118255615, -0.19226357340812683, -0.06710846722126007, -0.2463623285293579, -0.1182013526558876, 0.9406259655952454, 0.053851425647735596, -0.27363401651382446, -0.33191272616386414, -0.15295788645744324, 0.2084091752767563, -0.2383365035057068, -0.07380829006433487, 0.4753405451774597, 0.5244184732437134, -0.5934848189353943, 0.10424087941646576, 0.08364692330360413, 0.3067219853401184, 0.3618943691253662, -0.29165494441986084, -0.5780394077301025, -0.3670395016670227, 0.4039883613586426, -0.6693159341812134, 0.3712315559387207, 0.1591218113899231, 0.8155200481414795, -0.31886422634124756, 0.33846399188041687, 0.14156681299209595, 0.8340169191360474, 0.11860153079032898, 1.1218712329864502, 0.11304525285959244, -0.712580680847168, 0.057736292481422424, 0.35935837030410767, -0.38903313875198364, -0.062347352504730225, 0.31433552503585815, 0.9705435037612915, -0.5797437429428101, 1.1164422035217285, 0.4125722646713257, 1.2324042320251465, -0.6313959956169128, 0.14345800876617432, 0.5576525330543518, -0.2909916043281555, -0.7519806027412415, -0.3418438136577606, 0.5738468170166016, -0.5448225736618042, 0.38355937600135803, 0.6274429559707642, -0.5429369211196899, 0.11247999966144562, -0.5911401510238647, 0.46914583444595337, 0.5990194082260132, -0.307685911655426, -0.6488500833511353, 0.31123220920562744, 0.05125151947140694, 0.3324853181838989, -0.5420437455177307, -0.2011936604976654, 0.7989938259124756, 0.2821463346481323, -0.030935900285840034, 0.5868398547172546, -0.6764362454414368, 0.013454146683216095, 0.05567067861557007, 0.4397386312484741, 0.22712281346321106, -0.3934468626976013, -0.10796700417995453, -0.5957210063934326, -0.09485949575901031, -0.10159097611904144, 0.23560377955436707, -0.9414000511169434, 0.4507223069667816, 0.27521786093711853, 0.09947116672992706, 1.1124413013458252, -0.22723765671253204, -0.019718626514077187, -0.729894757270813, 0.07487964630126953, 0.17027607560157776, 0.02425825595855713, 0.6102129817008972, 0.47575679421424866, -0.21706941723823547, 1.9402225017547607, 0.5203300714492798, -0.19311800599098206, 0.2879120707511902, -0.45912468433380127, -0.19929462671279907, -0.7148516774177551, -0.11564791202545166, 0.3049641251564026, 0.32535696029663086, -0.27250704169273376, -0.8983342051506042, 0.4990638494491577, -0.5605944395065308, 0.83388352394104, -0.6062812805175781, -0.25206661224365234, 0.8250856995582581, 0.10610438883304596, -0.18386849761009216, 0.4623434543609619, 0.5106471180915833, 1.125878095626831, -1.307244062423706, 0.6635127067565918, -0.5756757259368896, 0.41807669401168823, -0.15470144152641296, -0.33352208137512207, -0.495783269405365, -0.27711108326911926, -0.41242802143096924, -0.045106157660484314, 0.38520348072052, 0.9771279692649841, 0.0884757786989212, -0.2819666862487793, -0.1699105054140091, -0.48288530111312866, 0.3660409152507782, 0.10328339040279388, 0.16731244325637817, -0.35319286584854126, 0.7969875931739807, 0.48265495896339417, -0.29315605759620667, 0.20914149284362793, -0.016487494111061096, 0.6580121517181396, 0.9721380472183228, 0.2571924924850464, -0.0908365398645401, 0.5972540974617004, 0.18122410774230957, 0.7143101096153259, -0.05927744507789612, 0.3673820495605469, -0.2101183533668518, -0.18464745581150055, -0.3508561849594116, -0.20300741493701935, -0.2858966588973999, -0.3595173954963684, 1.2294429540634155, -0.4340077042579651, 1.275246262550354, 0.8705623745918274, 0.9162770509719849, 0.04606108367443085, 0.6435858607292175, 0.3237227499485016, -0.16068534553050995, -0.15385912358760834, 0.6260562539100647, -0.4004408121109009, -0.18474145233631134, -0.8934780955314636, 0.8079441785812378, -0.02073642611503601, 0.6487800478935242, -0.055886223912239075, -0.1640745997428894, 0.01872142404317856, -0.013197600841522217, -1.6192108392715454, -0.824325680732727, 0.28258657455444336, -0.27081236243247986, 0.8293284177780151, -0.13756664097309113, 0.707830548286438, -1.3434243202209473, -0.261222779750824, 0.16073185205459595, -0.3222574293613434, -0.34459564089775085, 0.47410231828689575, -0.31790655851364136, 0.4686253070831299, -0.08922514319419861, -0.46011966466903687, 0.13475234806537628, 0.590481698513031, -0.5946826934814453, 0.31586819887161255, 0.3544941842556, 0.029626287519931793, -0.2424701452255249, 0.3713826537132263, -0.29117900133132935, 0.1909523606300354, 0.21697255969047546, -0.02882358431816101, -0.028499096632003784, -0.9126157760620117, 0.15380340814590454, 0.3816186785697937, -1.1291399002075195, 0.6367415189743042, -0.6601109504699707, -0.3420668840408325, 0.25383543968200684, -0.05357234925031662, 0.744705319404602, 0.8449477553367615, -0.4991207420825958, -0.24240756034851074, -0.06970061361789703, -0.13498720526695251, 0.28084224462509155, 0.5488789081573486, 0.6202411651611328, 0.22814956307411194, 0.3197135627269745, 0.4853993356227875, -0.14694809913635254, 0.9024748802185059, 0.7683961987495422, 0.1587648093700409, 0.04064684733748436, 0.6062800884246826, 1.0404775142669678, 0.18198487162590027, -0.6126792430877686, -0.06396055221557617, 0.6579878926277161, 0.2945146858692169, -0.9688469171524048, 0.5488153696060181, -0.2568711042404175, -0.007428169250488281, -0.19860835373401642, -0.4482831060886383, 0.017119556665420532, 0.270761102437973, 0.5899369716644287, -0.23873938620090485, 0.05373844504356384, -0.4625496566295624, 0.4462043046951294, -0.028759412467479706, -0.7484786510467529, 0.4447493553161621, -0.653465747833252, 0.5003061294555664, -0.12518924474716187, 0.1376289427280426, 0.5973895788192749, 0.19596175849437714, -0.4816449284553528, 0.332200288772583, 0.026260554790496826, -0.29816293716430664, 0.09906341135501862, 0.5485701560974121, 0.44124457240104675, -0.21068237721920013, 0.07562080025672913, 0.0007222592830657959, -0.31211137771606445, -0.9867672920227051, 0.6102649569511414, -0.35465627908706665, 0.5702913999557495, 0.4970616102218628, -0.3205620348453522, 1.0803351402282715, -0.21705397963523865, 0.5942695140838623, -0.1626163274049759, -0.5389445424079895, 0.09161047637462616, 0.49482518434524536, 0.7515841722488403, 0.5840412378311157, 0.020884379744529724, 0.01954296976327896, 0.31148597598075867, 0.7707768082618713, -0.6655620336532593, -0.16534298658370972, 0.36116358637809753, 0.24461528658866882, 0.5297942757606506, 0.5531665086746216, -0.2589206397533417, -0.12427300214767456, -0.16976210474967957, -0.6115097999572754, -0.4241354763507843, 0.36963406205177307, 0.13562336564064026, 0.01888224482536316, 0.30801302194595337, 0.37955379486083984, -0.3332422971725464, 0.08447572588920593, 0.3038073778152466, 0.3105769157409668, 0.07086643576622009, -0.7533248662948608, -0.26011574268341064, 0.6888476610183716, -0.7625483870506287, -0.11849731206893921, -0.5969105958938599, 0.12463158369064331, -0.18258672952651978, -0.13833144307136536, -0.5511607527732849, 0.47075068950653076, 0.04672813415527344, 0.6100583076477051, -0.2325122356414795, 0.5750032663345337, 0.5841600894927979, 0.29367077350616455, 0.04920968413352966, -0.36251047253608704, -0.2279801070690155, 0.01664353534579277, 0.07644255459308624, 0.0007894374430179596, 0.463082492351532, 0.7823829650878906, -0.24107663333415985, 0.49808090925216675, -0.8146156072616577, -0.49082279205322266, 0.8292584419250488, 0.6746388077735901, 0.23291252553462982, 0.09995636343955994, -0.4836944341659546, -0.12838894128799438, -0.5354310870170593, -0.3824752867221832, 0.3316330313682556, 0.03338999301195145, -0.08793523907661438, -0.1162073016166687, -0.4998394250869751, 0.28489044308662415, -0.768195390701294, 0.7754523754119873, -0.3479273319244385, -0.3151857852935791, 0.4293598532676697, 0.7188718318939209, -0.34822535514831543, -0.528740644454956, 0.6075844764709473, -0.04947860538959503, 0.04523199796676636, -0.18298184871673584, 1.3736801147460938, 0.5576896667480469, 0.49343544244766235, 1.3520476818084717, 0.46364855766296387, -0.6969159841537476, 0.09218621253967285, -0.5357199311256409, -0.7500334978103638, 0.16273581981658936, -0.6695243120193481, 0.02126885950565338, -0.041088659316301346, 0.22330200672149658, -0.29469776153564453, -0.43537041544914246, 0.2868357300758362, 0.27949002385139465, 0.2761550545692444, -0.01695159077644348, 0.16655093431472778, 0.3271752595901489, 0.1201564371585846, 0.4877004623413086, -0.1915494203567505, -0.9527513980865479, 5.123804092407227, -0.4258057177066803, -0.07416445016860962, -0.12113955616950989, -0.461933434009552, -0.6172006130218506, 0.08914779126644135, -0.44147366285324097, -0.04198189824819565, -0.9192903637886047, -0.722781240940094, 0.9502031803131104, 0.5584102869033813, -0.5608005523681641, 0.6594235301017761, -0.40011683106422424, 0.4325005114078522, -0.2398884892463684, -0.09486853331327438, -0.07316318154335022, 0.7827663421630859, -0.6589670181274414, -0.22104264795780182, 0.6643581390380859, 0.6429380774497986, 0.3168640732765198, -1.4135217666625977, 0.10647138953208923, 0.6350848078727722, -0.2772437334060669, 0.03466317057609558, -0.15147554874420166, -0.5191932916641235, -0.03010665625333786, -1.0021458864212036, 0.06883695721626282, -0.27738118171691895, 0.06079399585723877, 0.2523379921913147, -0.3409234285354614, 0.06342659890651703, -0.05060213804244995, -0.4952635169029236, 0.5294839143753052, -0.16343745589256287, 0.14876435697078705, 0.04837970435619354, -0.1767071932554245, 0.37168431282043457, -0.08901529014110565, -0.21535560488700867, 0.3815264105796814, -0.12641075253486633, -0.12941937148571014, 1.3525986671447754, 0.1758808046579361, -0.5979491472244263, -0.023775726556777954, -0.448835551738739, -0.01905718445777893, -0.6479077339172363, 2.242414951324463, -0.42209380865097046, 0.2991746962070465, -0.25872528553009033, 0.16046003997325897, 0.12330260127782822, -0.09308792650699615, 0.4887714982032776, -0.7766726613044739, 0.316396564245224, -0.04702822491526604, 0.057256702333688736]
# 什 [768] [0.610087513923645, 0.07367798686027527, 0.03686648607254028, -0.09820616245269775, 0.3561285138130188, 0.06903386116027832, 0.4831465482711792, 0.09776104986667633, -0.31109872460365295, 0.012299776077270508, -0.5015261173248291, -0.08592095971107483, -0.11345747113227844, 0.83360755443573, 0.22186484932899475, -0.33255672454833984, 0.24448446929454803, 0.8220185041427612, 1.1164048910140991, 0.05844595283269882, -0.7223643660545349, 0.013409197330474854, -0.7045155167579651, -0.1435956060886383, 0.005019091069698334, -0.17320787906646729, 0.14000359177589417, -0.7297375202178955, 0.49595656991004944, -0.682273268699646, -0.8140532374382019, 0.765084981918335, -0.12918975949287415, -0.34112754464149475, 0.5686982870101929, 0.039098918437957764, -0.5222541093826294, 0.3925600051879883, -0.39044997096061707, 0.37141817808151245, 0.054604217410087585, -0.6768045425415039, 0.49274444580078125, 0.2607245445251465, -0.3712679445743561, 0.29473045468330383, -0.7819209694862366, 0.22447454929351807, 0.7497434020042419, 1.062977910041809, -0.9438020586967468, 7.801692962646484, -0.06669275462627411, -0.1325172483921051, -0.8770049214363098, 0.8153178691864014, -0.3113579750061035, -0.6199833154678345, 0.46055349707603455, 1.1380486488342285, -0.1091882586479187, -0.3368587791919708, -0.14878861606121063, 0.4734199643135071, 0.03977537900209427, -0.5071614384651184, 0.10110148787498474, -0.21320459246635437, 0.48282384872436523, 0.30105656385421753, -0.11481666564941406, -0.08402982354164124, -0.03728961944580078, 0.607737123966217, 0.22691035270690918, 0.12925300002098083, -0.16439944505691528, 0.7147590517997742, 0.3441995680332184, -0.08452773094177246, -1.3883910179138184, -0.03288377448916435, -1.115821361541748, -0.10208788514137268, -0.7337247729301453, 0.03372839093208313, -0.27295780181884766, 0.02476489543914795, -0.012606710195541382, 0.23856809735298157, 0.2124267816543579, -0.20503219962120056, -0.6203407645225525, -0.6529158353805542, 0.18368655443191528, 0.07606898248195648, -0.025906533002853394, 0.2406892329454422, 0.6934109926223755, -0.2613314986228943, -0.21081240475177765, 0.45936939120292664, -0.14716660976409912, -0.5164130926132202, -1.1588542461395264, 0.19717752933502197, 1.3852527141571045, 0.5063064098358154, -0.5546462535858154, 0.8858264684677124, -0.6111099123954773, 0.07047446817159653, -0.12900665402412415, 0.13038425147533417, 0.22714391350746155, -0.26363635063171387, 0.026654869318008423, 0.7564759850502014, 0.0755472183227539, 0.02125929296016693, 0.5502920150756836, -0.10452783107757568, 0.8980419635772705, 0.7538228034973145, -0.08394446223974228, -0.9458280205726624, -0.2835943102836609, 0.37271440029144287, -0.2747539281845093, -0.49442124366760254, 0.17311757802963257, -0.40400251746177673, 1.826780080795288, 0.08880136907100677, 0.5502626299858093, -1.0661506652832031, -0.3253471851348877, -0.7641564607620239, -0.8619971871376038, -0.263869047164917, -0.4623507559299469, -0.527944028377533, -0.2575671970844269, -0.21344824135303497, 0.8584307432174683, -0.10715468227863312, 0.18193933367729187, -0.684409499168396, 0.08809207379817963, 0.4201449751853943, -0.9583234190940857, -0.23173296451568604, 0.5375028848648071, 0.5242314338684082, 0.34316694736480713, 0.3696024417877197, -0.0030536949634552, 0.028714865446090698, -0.13649636507034302, 0.10246451199054718, 0.12630680203437805, 0.2971683442592621, -0.4011407792568207, 1.055884599685669, 0.05030124634504318, -0.9283785820007324, -0.6110543012619019, 1.127368450164795, -0.701802134513855, 0.6893001198768616, -0.018065810203552246, 0.45801201462745667, 0.15081588923931122, 1.0278018712997437, -0.49919480085372925, 0.8036881685256958, -0.831572949886322, -0.8806653618812561, 0.18173739314079285, -0.2259092479944229, 0.3562823534011841, 0.0742461085319519, 0.2645607590675354, -0.07754842191934586, -0.043138086795806885, -0.07086700201034546, 1.416656255722046, -0.9909332990646362, 0.3695644438266754, -0.826681911945343, 0.3831124007701874, 0.37601718306541443, 0.004545807838439941, -0.3091261684894562, -0.7358840703964233, 0.21509557962417603, 0.322140634059906, 0.030718103051185608, 0.6476468443870544, 0.2950925827026367, -0.35979610681533813, -0.061344608664512634, -0.10470923781394958, -0.022539258003234863, -0.615999698638916, 0.12994566559791565, 0.21620139479637146, 0.03836837410926819, -1.082641839981079, 0.5399024486541748, -0.5407829284667969, 0.23351985216140747, 0.7720979452133179, 0.6043746471405029, -0.1685502827167511, 0.7405954599380493, 0.2487068772315979, 0.5862454771995544, -0.08093816041946411, -0.09787330031394958, -0.5200527906417847, -0.22607704997062683, -0.03770233690738678, -0.4833466708660126, -0.1349099576473236, -0.723037600517273, -0.22916585206985474, -0.43664392828941345, 0.024096816778182983, 0.13472077250480652, 0.26729023456573486, -0.18494996428489685, 0.13133203983306885, -0.08466006070375443, 0.14197304844856262, -0.37608954310417175, -0.32694631814956665, -0.3052278161048889, 0.22248515486717224, -0.12389785051345825, 0.010327806696295738, -0.7773369550704956, -1.0404071807861328, -0.28066790103912354, 0.34035468101501465, 1.0064537525177002, -0.5573639273643494, -0.2663387656211853, -0.09883064031600952, -0.43827304244041443, 0.3085068464279175, 0.4452308714389801, -0.595737636089325, -0.46883103251457214, -0.4080660939216614, 0.07197725027799606, 0.16051502525806427, -0.23875169456005096, 0.32688722014427185, 0.2779751420021057, -0.21534554660320282, -0.14754439890384674, -0.4029892086982727, 0.6241132020950317, 1.3715554475784302, -0.24367907643318176, 0.34132400155067444, -0.9469305872917175, 0.8975843191146851, 0.6534984111785889, -0.05965134873986244, 0.2544507384300232, -0.10132747888565063, 0.9862204790115356, -0.032384518533945084, -0.05489455163478851, -0.38691920042037964, 0.6468276977539062, 0.041370734572410583, -0.8098716735839844, 0.12740540504455566, 0.4152486324310303, 0.8175151348114014, -1.2089537382125854, -0.5271873474121094, -1.0745580196380615, 0.5732206106185913, 0.419254869222641, 0.7068226933479309, -0.4870631694793701, -0.47075986862182617, 0.05173921585083008, -1.0109186172485352, 0.3705570101737976, 0.7943596243858337, 0.9166219830513, 0.20088571310043335, -0.25503838062286377, 0.41915565729141235, 0.06936889886856079, -0.1990729421377182, 0.4993957281112671, 0.7853764295578003, 0.21667742729187012, 0.1985129863023758, -1.6503920555114746, -0.4011302888393402, 0.21831992268562317, -0.24486702680587769, -0.025483474135398865, -0.09778782725334167, -0.4555642604827881, -1.0673058032989502, -0.5972573161125183, 0.49310871958732605, -0.03894677758216858, 0.0926046073436737, -0.2261001318693161, -0.8567808270454407, -0.416646808385849, 0.06864789128303528, -0.550174355506897, -0.025014538317918777, 0.6127279996871948, 0.19672705233097076, -0.390365332365036, 1.1463836431503296, 0.23777836561203003, 0.7282683849334717, -0.6936053037643433, 1.024413824081421, -0.4160346984863281, -0.24094563722610474, -0.29412615299224854, 0.5561536550521851, 0.0869206115603447, -0.6229977011680603, 0.20147407054901123, 1.0767408609390259, -0.5846302509307861, 1.0926215648651123, -0.05545493960380554, 0.20027384161949158, 0.3877289593219757, 0.59708172082901, 0.5446285009384155, 0.4400465488433838, -0.2658078074455261, -0.017027676105499268, 0.9741688966751099, -0.7960740327835083, -0.15451523661613464, -0.14357642829418182, -1.206634283065796, -0.6254118084907532, -0.034058116376399994, 0.545015811920166, 0.5611483454704285, 0.04288776218891144, -0.28312310576438904, 0.2196008563041687, 0.7195225954055786, 0.3444422483444214, -0.5617861747741699, 0.3805921673774719, 0.6817749738693237, 0.7180278301239014, 0.4276049733161926, 0.6111260652542114, -0.4456882178783417, -0.49527719616889954, 0.3493814766407013, 0.25454968214035034, -0.022159690037369728, -0.11362958699464798, 0.22313664853572845, -0.01429380476474762, 0.03189854323863983, -0.17195022106170654, -0.3110632598400116, -0.8287770748138428, 0.528594434261322, 0.26141536235809326, -0.2889901101589203, 0.9431152939796448, -1.1319258213043213, -0.8648284673690796, -0.6561157703399658, 0.7856495380401611, 0.10810502618551254, -0.7672404646873474, -0.9362287521362305, 0.5010453462600708, -0.3180866837501526, 0.6335680484771729, 0.43489885330200195, -0.04005549103021622, -0.23171447217464447, -0.41411763429641724, -0.21262848377227783, -1.0937963724136353, -0.6145161390304565, 0.5419262647628784, -0.17564913630485535, -0.17009450495243073, -0.48083752393722534, 0.6382341384887695, -0.7544177770614624, 0.596499502658844, -0.07835578918457031, -0.07514361292123795, 0.015480346977710724, -0.19851884245872498, 0.12365467846393585, 0.20017080008983612, 0.6951838135719299, 1.667724370956421, -1.0382754802703857, -0.07299338281154633, -0.4852527678012848, -0.14146727323532104, -0.02382040023803711, -0.6024141311645508, -1.149329423904419, -0.15022745728492737, -0.25610437989234924, 0.06174347177147865, -0.4313928186893463, -0.1354471743106842, 0.7488906383514404, -0.41039007902145386, 0.2836074233055115, -0.10585585236549377, 0.6726769804954529, -0.9208170771598816, -0.20471006631851196, 0.7084536552429199, 0.98772132396698, 0.03837031126022339, 0.0785270631313324, 0.40447747707366943, 0.009226471185684204, 0.12010329961776733, 1.1075100898742676, -0.6940155029296875, -0.24487732350826263, 0.8177139163017273, 0.2993711829185486, 0.07266406714916229, -0.3990727365016937, 0.1828533411026001, 0.496063768863678, -0.5160890817642212, -1.0869475603103638, 0.22611162066459656, -0.07079445570707321, -0.1759883165359497, 0.9785181283950806, -0.19470399618148804, 0.5733892321586609, 0.5946138501167297, 1.1175627708435059, 0.4783228039741516, 0.7095596790313721, 0.571488082408905, 0.24157097935676575, -0.10533960908651352, 0.4009588062763214, -0.24201622605323792, -0.27084195613861084, -1.2138663530349731, 0.8205574750900269, -0.004401296377182007, 0.6900777220726013, -0.5470153093338013, -0.03968067467212677, 0.9031376838684082, 0.0993996262550354, -1.7098671197891235, -1.0314034223556519, 0.28864577412605286, -1.0304453372955322, 1.1908175945281982, -0.4696180820465088, 0.8898493051528931, -0.35147690773010254, -0.08671492338180542, -0.3459935784339905, -0.47933608293533325, 0.0022634565830230713, 0.6380870342254639, -0.5022072196006775, 0.5053412914276123, -0.008001595735549927, 0.4516963064670563, 0.5274847149848938, 1.1783902645111084, -0.7662733793258667, 0.5949568152427673, 0.22097156941890717, -0.5296849608421326, -0.5884636044502258, -0.40003812313079834, -0.894368052482605, 0.5500295162200928, -0.0019104965031147003, 0.10593241453170776, 0.22766518592834473, 0.13338637351989746, 0.0006745532155036926, 0.7815490961074829, -1.3325685262680054, 0.22453774511814117, -0.4811839759349823, -0.015154510736465454, -0.8577737808227539, 0.5180641412734985, 0.7837992310523987, 0.4401930570602417, -0.8584908843040466, 0.5638682842254639, 0.12147758901119232, -0.45949944853782654, 0.24078282713890076, -0.09876863658428192, 0.4863225817680359, 0.3533288538455963, -0.3513032793998718, 0.21257618069648743, 0.27923572063446045, 0.8551266193389893, 0.2463759183883667, 0.32753217220306396, 0.14678184688091278, -0.16864895820617676, 1.113124132156372, -0.13452821969985962, -0.7612205743789673, -0.051204126328229904, 0.6437901258468628, 0.3997644782066345, -0.06623941659927368, 0.4828665852546692, -0.834620475769043, 0.5364843606948853, -0.9594792127609253, -0.2371496558189392, 0.27780580520629883, -0.5277581810951233, 0.8576986193656921, -0.09295278787612915, 0.5137285590171814, -0.7769683003425598, 0.4738468527793884, -0.47840678691864014, -0.721049964427948, 0.7764997482299805, 0.35297995805740356, 0.3855472207069397, 0.14310897886753082, -0.3865242004394531, 1.0971219539642334, -0.13887549936771393, -0.4224548041820526, 0.4186144471168518, 0.7889084219932556, -0.18028390407562256, 0.21135056018829346, 0.6092536449432373, 0.5862737894058228, -0.7117081880569458, -0.20963801443576813, 0.2951911389827728, -0.5812575221061707, -1.0384244918823242, 0.28612348437309265, -0.3801553249359131, 0.19742202758789062, 0.5710645318031311, 0.7879466414451599, 0.6786067485809326, -0.14838972687721252, 0.848820686340332, -0.05400694161653519, 0.08735096454620361, -0.19878798723220825, 0.5691787600517273, 0.22734606266021729, 0.6814233064651489, -0.42117393016815186, -0.05547252297401428, -0.024817608296871185, 0.0421418696641922, -0.5650094747543335, 0.4957408905029297, -0.3620666265487671, 0.539759635925293, 0.45824480056762695, 0.318195104598999, 0.6951895356178284, 0.020277559757232666, 0.383453369140625, 0.3939361572265625, -0.20021316409111023, 0.7540725469589233, 0.26899150013923645, -0.17647531628608704, 1.1464226245880127, 0.201732337474823, -0.7337368726730347, 0.5478332042694092, -0.2809557318687439, -0.22781668603420258, -0.5807318091392517, -1.2866671085357666, -0.15589159727096558, 1.0417366027832031, -0.20201075077056885, 0.6258964538574219, -0.2067868709564209, -0.22064223885536194, 1.0786988735198975, -0.32850736379623413, -0.7767907977104187, 0.47824105620384216, 0.1609157770872116, 0.7377140522003174, -0.11972135305404663, 0.44423696398735046, 0.10928237438201904, -0.07682587206363678, -0.02592618390917778, -0.011613793671131134, 0.0707702785730362, 0.2243017852306366, -0.7416883707046509, -0.4564369022846222, 0.6889600157737732, 0.47797971963882446, -0.5905221700668335, 0.10168736428022385, -0.8556668162345886, -1.2243196964263916, 0.6267394423484802, 0.24545350670814514, -0.0248984694480896, -0.38350850343704224, 0.3226756453514099, 0.22668372094631195, -0.916502833366394, -0.3371250629425049, 0.16739420592784882, -0.142753466963768, -0.11460255086421967, -0.07670032232999802, 0.011714175343513489, 0.1271139681339264, -0.27091220021247864, 1.012985110282898, -0.10967094451189041, -0.5039076209068298, 0.12584833800792694, 0.5249104499816895, 0.3055488169193268, 0.05918031930923462, 1.3211877346038818, -0.15065903961658478, 0.22650474309921265, 0.2578613758087158, 1.205517053604126, -0.05091487616300583, 0.12481513619422913, 0.6366272568702698, 0.3132120668888092, 0.09056932479143143, 0.1800099015235901, 0.46435272693634033, -0.47668591141700745, 0.4905467927455902, -0.15429264307022095, 0.4344690442085266, 0.11154775321483612, -0.6044459342956543, 0.26927125453948975, 0.027898043394088745, 0.5760975480079651, 0.32988500595092773, 0.15771085023880005, -0.3368016481399536, -0.11557139456272125, 0.24361586570739746, -0.15296116471290588, 0.4593965411186218, -0.35730117559432983, -1.1507214307785034, 6.233524799346924, -0.026586323976516724, -0.1166180968284607, 0.006892301142215729, 0.5611467361450195, -0.0615992546081543, 0.8525279760360718, -0.4323451817035675, 0.4601830840110779, -0.4237684905529022, -0.7188645005226135, 0.6682401895523071, 0.9144630432128906, -0.7403331995010376, 0.2549721598625183, -0.09449122846126556, -0.06531351804733276, 0.2644273638725281, -0.4879191815853119, -0.1715242713689804, 0.7130026817321777, -0.9716745615005493, -0.2550252676010132, 0.0910986065864563, 0.4842733144760132, 0.7520424723625183, -0.9190478920936584, -0.5576626062393188, 0.6740415692329407, -0.06459452956914902, 0.2855386435985565, -0.6101546287536621, -0.41688913106918335, 0.2952573895454407, -0.9582384824752808, 0.1642645001411438, -0.08104312419891357, 0.13559353351593018, -0.2863675653934479, -0.45837998390197754, 1.2332278490066528, -0.24351637065410614, -0.5110270380973816, 0.7470264434814453, 0.06197521090507507, 0.20071347057819366, -0.09306132793426514, 0.1566910743713379, 0.3064931631088257, -0.09408547729253769, -0.07462199032306671, 0.09255049377679825, -0.42577528953552246, 0.08079613745212555, 1.924070119857788, 0.4437294602394104, -0.2161051481962204, -0.038194648921489716, -0.93721604347229, -0.439211368560791, -0.12380218505859375, 2.4778780937194824, -0.5199522376060486, -0.4356548488140106, 0.14615212380886078, 0.21821030974388123, -0.4186950922012329, 0.1708553582429886, 0.1925639659166336, -0.4638340473175049, 0.24731308221817017, 0.0848052054643631, 0.22332923114299774]
# 么 [768] [0.479425311088562, -0.21743836998939514, 0.21906085312366486, -0.26941758394241333, 0.808943510055542, -0.3285209536552429, 0.5027217268943787, 0.20768430829048157, 0.08959127962589264, 0.6208274960517883, -0.09284886717796326, -0.422267347574234, 0.0016909390687942505, 0.68845534324646, 0.6676317453384399, -0.504363477230072, -0.053649917244911194, 0.11132489889860153, 0.8258427381515503, 0.13134688138961792, -0.5406067371368408, -0.1286320984363556, -0.3448764979839325, -0.13492274284362793, 0.2248375415802002, -0.18791623413562775, 0.8079423308372498, -0.8193484544754028, -0.3971264660358429, -0.2854906916618347, -0.7153406739234924, 0.8543367981910706, -0.3729216456413269, -0.34542110562324524, 0.0414864644408226, -0.27858084440231323, -0.5507262945175171, 0.27234262228012085, 0.42092734575271606, 0.24320179224014282, -0.44439274072647095, -0.4371001720428467, -0.38604119420051575, -0.010032299906015396, -0.608254611492157, 0.3581634759902954, 0.019959568977355957, 0.6307848691940308, 1.1726123094558716, 0.7263168692588806, -0.4195379912853241, 8.286048889160156, 0.6673344373703003, -0.06776748597621918, -0.2657110393047333, 0.6960573792457581, -0.14559593796730042, 0.12404683232307434, 0.40879011154174805, 0.7163876891136169, -0.659123420715332, -0.6424567699432373, 0.0519241988658905, 0.6361371278762817, 0.3883151710033417, 0.20493917167186737, 0.20115230977535248, 0.06852586567401886, 0.42147061228752136, 0.6556898355484009, -0.08701974153518677, 0.09103292226791382, -0.21325474977493286, 0.5119857788085938, 0.41619718074798584, 0.516607403755188, -0.3877332806587219, 0.5790795087814331, 0.03262477368116379, -0.16298478841781616, -1.0005016326904297, -0.25646719336509705, -1.2966907024383545, -0.008723169565200806, -0.7890228033065796, -0.014398530125617981, -0.38688039779663086, -0.057160139083862305, -0.09874539822340012, -0.41997605562210083, 0.13223864138126373, -0.4108325242996216, -0.45034390687942505, 0.24136358499526978, -0.2102271020412445, 0.4744115471839905, 0.12021994590759277, 0.3072029948234558, 0.6870790719985962, -0.5225993394851685, -0.21685154736042023, 0.05079302936792374, 0.2950134575366974, -0.7026339769363403, -1.1170375347137451, 0.39424049854278564, 1.2904380559921265, 0.26549822092056274, -0.3666689097881317, 0.2338627129793167, -0.13087496161460876, -0.5045107007026672, -0.14142999053001404, -0.0077100396156311035, 0.24346297979354858, 0.36841803789138794, 0.29127007722854614, 0.6478841304779053, 0.014973729848861694, 0.4740232527256012, 0.43969056010246277, -0.22154703736305237, -0.2023662030696869, -0.43886515498161316, -0.549902617931366, -0.9149943590164185, -0.5983200073242188, 0.22499524056911469, -0.37641412019729614, -0.4522693157196045, -0.8169198036193848, -0.13186612725257874, 1.2254638671875, -0.28994476795196533, 0.3203229308128357, -0.7537904977798462, -0.050622448325157166, -0.9139159321784973, -0.8462916612625122, 0.19990482926368713, -0.017754752188920975, -0.7999259233474731, 0.23678094148635864, 0.6926184892654419, 0.8799360990524292, 0.2099224179983139, -0.12837769091129303, -0.15942075848579407, 0.15502241253852844, -0.39168620109558105, -1.075984239578247, -0.12351623177528381, 0.3562958836555481, -0.18006934225559235, 0.17419543862342834, 0.37980931997299194, -0.10295362025499344, -0.0011651664972305298, 0.21639005839824677, 0.6258468627929688, 0.37161675095558167, -0.02545905113220215, -0.4193010628223419, 0.4769909977912903, -0.48013731837272644, -1.1603214740753174, -0.29515761137008667, 0.9835391044616699, -0.18737836182117462, 0.03253279626369476, 0.23580598831176758, -0.10387123376131058, 0.400998592376709, 1.056300401687622, -0.7553017139434814, 0.03216835856437683, -0.9189103841781616, -0.289654403924942, -0.009397223591804504, -0.5409183502197266, -0.08285549283027649, -0.021125763654708862, 0.326612651348114, 0.3119034171104431, 0.03767618536949158, 0.5728733539581299, 0.6798312664031982, -0.12304863333702087, 0.4655956029891968, -1.521216630935669, 0.2299288511276245, 0.4145544469356537, 0.6922399997711182, -0.5508285164833069, -0.47019025683403015, 0.5664581656455994, 0.24691292643547058, -0.029368631541728973, 0.6925520896911621, 0.5947799682617188, -0.10231448709964752, 0.6639223098754883, 0.43747371435165405, -0.2760816514492035, -0.02788134664297104, 0.5987541675567627, 0.293809175491333, -0.049414604902267456, -0.8372877240180969, 0.34901106357574463, -0.5231413245201111, -0.028459101915359497, 1.0353161096572876, 0.8567962050437927, -0.6540616750717163, 0.5974107980728149, 0.1690668761730194, -0.034653499722480774, 0.1448601633310318, -0.4126826524734497, 0.18369218707084656, -0.12589991092681885, 0.2620683014392853, 0.030558627098798752, -0.16092050075531006, -0.2496226280927658, -0.11559735238552094, 0.2864268720149994, -0.8653615117073059, -0.5116178393363953, 0.4627090096473694, -0.24412229657173157, -0.19740790128707886, -0.2778204679489136, 0.19964246451854706, -0.3890896439552307, 0.13979609310626984, -0.1348617523908615, -0.3124423623085022, 0.6696311235427856, -0.1331615447998047, -0.6257018446922302, -0.36535733938217163, 0.280191034078598, -0.061643123626708984, 0.9638658761978149, -0.22813618183135986, -0.21136218309402466, -0.40388137102127075, -0.537179708480835, -0.37477678060531616, 0.14571237564086914, -0.7605032920837402, -1.1555477380752563, 0.18750426173210144, -0.3303537368774414, -0.20945879817008972, -0.40937232971191406, -0.005762338638305664, -0.47803428769111633, -0.2708907127380371, -0.15876851975917816, 0.22460204362869263, -0.38678985834121704, 1.7212975025177002, 0.11699791997671127, -0.10118651390075684, -0.6521636843681335, 1.3531590700149536, 0.13198328018188477, -0.2766968905925751, 0.5463396310806274, -0.13544854521751404, 1.244325876235962, -0.08856232464313507, -0.323559045791626, 0.2708086371421814, 0.12994787096977234, 0.18310309946537018, -0.4620029926300049, 0.4743824303150177, 0.7473577857017517, 0.20590469241142273, -0.8027917146682739, -0.2368384599685669, -0.630733847618103, 0.31071338057518005, 0.11362707614898682, 0.2270137369632721, 0.15598797798156738, -0.4100598096847534, -0.2529919743537903, -0.49579986929893494, 0.978856086730957, 0.8128916025161743, 0.8220309019088745, -0.21601757407188416, 0.2328980714082718, 0.7816899418830872, -0.3796803057193756, -0.017036937177181244, 0.1737801432609558, 0.9331514835357666, 0.7230650186538696, 0.07792066037654877, -1.489646315574646, -0.25351136922836304, 0.6710591316223145, -0.12005937099456787, 0.3445795178413391, 0.4892179071903229, 0.028149396181106567, -1.0235834121704102, -0.5586628913879395, 0.01452714204788208, -0.3846067786216736, -0.23707810044288635, 0.19792449474334717, -0.8537394404411316, -0.46496862173080444, -0.24402877688407898, 0.0021429210901260376, 0.4527624845504761, 0.18516385555267334, 0.7391631007194519, -0.19128921627998352, 0.8459265232086182, 0.025514692068099976, 0.5881197452545166, 0.46796226501464844, 0.9282383918762207, 0.21982073783874512, -0.23220297694206238, -0.2908830940723419, -0.037534892559051514, 0.09602466225624084, -0.2741026282310486, -0.31786611676216125, 0.9353168606758118, -0.8764125108718872, 0.900424599647522, 0.054984286427497864, 0.11278562247753143, 0.1436716914176941, 0.15453007817268372, 0.597065269947052, 0.1957450807094574, -0.4419347643852234, 0.5790833830833435, 0.5220481157302856, -1.1997637748718262, -0.0924074798822403, -0.39416423439979553, -0.16736361384391785, -0.3279040455818176, -0.19294512271881104, 0.3230856955051422, 0.27392467856407166, -0.4261438250541687, -0.612708568572998, 0.5478832125663757, 0.35198765993118286, 0.013373300433158875, -0.14819394052028656, 0.21638669073581696, 0.40054622292518616, 0.7322556972503662, 0.2437155693769455, 0.4087621569633484, -0.5188037157058716, -0.49063536524772644, -0.060988783836364746, 0.17685666680335999, -0.26893290877342224, -0.009455233812332153, -0.29196277260780334, -0.23417215049266815, 0.040535300970077515, -0.7805452346801758, -0.4313272535800934, -1.3318763971328735, 0.3738180696964264, 0.0012530498206615448, 0.14140655100345612, 1.1156151294708252, -0.42822831869125366, 0.1941685825586319, -0.6990193724632263, 1.1015632152557373, 0.08484911918640137, -0.6622504591941833, -0.12024044245481491, -0.07268382608890533, -0.00626334547996521, 0.6495921015739441, 0.5831336975097656, 0.029723867774009705, -0.5680199861526489, -0.04832608997821808, -0.6577984094619751, -0.9420212507247925, -1.0339117050170898, 0.1018228679895401, -0.3774499297142029, 0.03848591446876526, -0.6607754826545715, 0.47270476818084717, -0.30986207723617554, 0.796796977519989, 0.09795403480529785, -0.12382375448942184, -0.11622881144285202, -0.21021297574043274, 0.1557278335094452, 0.05352102965116501, 0.7424298524856567, 1.0843223333358765, -0.7781502604484558, 0.5440189242362976, -0.0013998597860336304, 0.15846486389636993, 0.16127464175224304, -0.7337713837623596, -0.9823863506317139, 0.5836036205291748, -0.9009160399436951, 0.21533101797103882, 0.36038678884506226, 0.12494203448295593, 0.9748457670211792, -0.3849332928657532, 0.7911579608917236, -0.20955368876457214, 0.31499791145324707, -0.6267969608306885, -0.05807870626449585, 0.1211947500705719, 0.9773260354995728, 0.24249021708965302, 0.34994959831237793, 0.40449321269989014, 0.1653747856616974, -0.1536940187215805, 1.534902811050415, -0.07931950688362122, -0.10529372096061707, 0.22927607595920563, -0.14199334383010864, -0.023596584796905518, 0.06521777808666229, 0.13127964735031128, 0.0678214430809021, 0.1777161955833435, -0.6255118250846863, -0.14174148440361023, 0.4371277987957001, -0.4970710873603821, 1.1723639965057373, 0.28093501925468445, 0.7081422805786133, 0.5514228343963623, 0.558463990688324, 0.4625056982040405, 0.40494194626808167, 0.5052529573440552, 0.5229693651199341, -0.23191162943840027, 0.03839040547609329, -0.03957890719175339, -0.7772951126098633, -0.7407745122909546, 0.7948856353759766, 0.10720393061637878, 0.3400574326515198, -0.09279842674732208, -0.03488630801439285, 0.14094913005828857, -0.2394828200340271, -2.128350019454956, -0.5523282885551453, 0.6240553855895996, -0.6354714035987854, 0.6507786512374878, -0.5998716354370117, 0.4547441005706787, 0.02222469449043274, 0.13411015272140503, 0.49172794818878174, -0.3867533802986145, -0.20004649460315704, 0.3652448356151581, -0.10181386768817902, 0.7960706353187561, -0.6668103933334351, -0.5735165476799011, 0.38017672300338745, 0.6849772334098816, -0.6069072484970093, 0.45540639758110046, 0.45469099283218384, -0.6791089773178101, -0.5567224621772766, -0.6313404440879822, -1.045687198638916, -0.40601271390914917, 0.07899582386016846, -0.051897674798965454, 0.2336702048778534, -0.40964365005493164, -0.5484744310379028, 0.127872034907341, -1.3688181638717651, -0.06422099471092224, -0.5355016589164734, -0.32427263259887695, -0.17501775920391083, 0.06845838576555252, 0.5933454036712646, 0.6162275075912476, -0.5813829898834229, 0.06715988367795944, 0.1442343294620514, -0.08933651447296143, 0.3631747364997864, 0.3037019371986389, 0.5113598704338074, 0.4143405258655548, -0.27418750524520874, 0.014577627182006836, -0.0013434737920761108, 0.8962478637695312, 0.14919650554656982, -0.058499306440353394, 0.22671937942504883, 0.03235974907875061, 1.0286189317703247, 0.3117801547050476, -1.353703260421753, 0.324384480714798, 0.3265713155269623, -0.5095002055168152, -0.640260636806488, 0.13745707273483276, -0.661643385887146, 0.17174884676933289, -0.3129904866218567, 0.06174911558628082, 0.2356497347354889, -0.35489577054977417, 0.33731746673583984, -0.41805779933929443, 0.654503345489502, -1.3175021409988403, 0.16208912432193756, -0.07606185972690582, -0.7662422060966492, 0.38494235277175903, 0.37520474195480347, 0.19820243120193481, -0.24920378625392914, -0.2907436788082123, 1.0789918899536133, -0.34753549098968506, -0.5813256502151489, -0.17091421782970428, 0.6981253623962402, 0.2864435315132141, 0.20038717985153198, 0.7892646789550781, 0.46228018403053284, -0.3023677468299866, -0.19194838404655457, 0.5475102663040161, -0.04491354897618294, -1.074061632156372, -0.06389772146940231, -0.6163609623908997, 0.16280785202980042, 0.7724074721336365, -0.11787958443164825, 0.7301343679428101, -0.19496610760688782, -0.06827084720134735, 0.28124409914016724, 0.13148777186870575, -0.05548246204853058, 0.5726913213729858, -0.16225692629814148, 0.3301793932914734, -0.14172589778900146, 0.21507257223129272, 0.7364141941070557, 0.2894383668899536, 0.11883336305618286, -0.30923324823379517, -0.433230459690094, 0.0960514172911644, 0.04535415768623352, 0.9605646729469299, 0.312030553817749, -0.1042296290397644, 0.047515369951725006, 0.781013548374176, 0.17602086067199707, 0.8085147142410278, 0.3907155990600586, 0.7020117044448853, 0.9494624137878418, 0.3400237560272217, -0.5693843364715576, 0.09629712998867035, 0.2629142999649048, -0.2483046054840088, -0.13189685344696045, -0.5642341375350952, 0.5996227264404297, 0.7744150757789612, -0.37249046564102173, 0.31671804189682007, -0.3165472149848938, 0.33928990364074707, -0.08274596929550171, -0.8525958061218262, 0.13818150758743286, 0.8439638614654541, -0.19167084991931915, 0.7816905975341797, -0.5027483105659485, 0.4552561640739441, -0.3754695951938629, -0.19863778352737427, 0.20986762642860413, -0.41011086106300354, -0.009897619485855103, 0.050372738391160965, -0.6501613855361938, -0.5347476005554199, 0.9110556840896606, 0.712287425994873, -0.8955316543579102, 0.6660191416740417, -0.08702492713928223, -0.6282411813735962, 0.08669993281364441, 0.20559218525886536, -0.35194629430770874, -0.36546099185943604, 0.10445189476013184, 0.08605290949344635, -0.4918503165245056, -0.16890022158622742, 0.4462954103946686, 0.09982958436012268, -0.338712215423584, 0.4786493182182312, -0.3710223436355591, 0.5800060033798218, -0.3483783006668091, 0.6536818742752075, -0.17662644386291504, -0.2676582336425781, 0.8046479225158691, 0.9187052249908447, -0.06808280944824219, 0.053333401679992676, 0.9835844039916992, -0.6174826622009277, 0.6311856508255005, -0.253024160861969, 1.3633143901824951, 0.17134563624858856, 0.5358671545982361, 1.1897186040878296, 0.545200765132904, -0.2685844600200653, 0.4236922264099121, -0.6140195727348328, -0.03618711978197098, 0.7543458938598633, 0.1905621737241745, 0.214035764336586, -0.04514400288462639, 0.013890504837036133, -0.3183703124523163, 0.3193379044532776, 0.16196438670158386, -0.10268332064151764, 0.3656634986400604, -0.08057312667369843, 0.15836429595947266, 0.46785855293273926, 0.1523062288761139, 0.30158552527427673, -0.24638815224170685, -0.9449981451034546, 2.8452563285827637, 0.3023282289505005, 0.2045462727546692, -0.29877012968063354, -0.0005810558795928955, -0.3431110084056854, 0.9609583616256714, -0.38310760259628296, 0.18947865068912506, -0.1689952313899994, -0.4581809937953949, 0.5361334681510925, 1.1680312156677246, -0.7098076343536377, 0.04369072616100311, -0.30570468306541443, 0.6634310483932495, -0.30058568716049194, -0.3365076780319214, 0.23897862434387207, 1.0445961952209473, -0.9569485187530518, 0.10198013484477997, -0.13095492124557495, 0.3898738920688629, 0.6828009486198425, -1.0093961954116821, -0.18984287977218628, 0.5343483090400696, -0.14235201478004456, 0.5847890377044678, -0.6429189443588257, -0.13225379586219788, -0.1071835458278656, -0.7681943774223328, -0.13388793170452118, -0.7007235288619995, -0.19160374999046326, 0.08484604954719543, -0.28115689754486084, 0.5097828507423401, 0.4096224904060364, 0.09985432028770447, 0.0725201964378357, -0.26169443130493164, 0.37233856320381165, 0.12839066982269287, 0.2962058186531067, 0.5249413251876831, -0.7888382077217102, -0.6563863158226013, 0.17484979331493378, -0.8393516540527344, 0.324668824672699, 0.4572140574455261, -0.08427658677101135, -0.6024408340454102, 1.3651952743530273, -0.3258633017539978, 0.22589392960071564, -0.285655677318573, 1.5971711874008179, -0.3255947530269623, -0.5788667798042297, 0.023545309901237488, -0.11503919959068298, -0.03160466253757477, 0.4303063452243805, 0.08789190649986267, -0.7267572283744812, 0.13888251781463623, 0.5512789487838745, 0.08756645023822784]
# [SEP] [768] [0.6132994890213013, -0.24844421446323395, 0.4813007712364197, -0.033369600772857666, -0.058943867683410645, 0.10331422090530396, 0.7942080497741699, 0.670520544052124, -1.30814790725708, 0.34959515929222107, -0.5714254379272461, 0.5160351991653442, 0.45535123348236084, -0.2961934804916382, -0.15137416124343872, -0.36058109998703003, -0.12629294395446777, -0.21564573049545288, 0.432038277387619, -0.06877940148115158, -0.13750872015953064, -0.2419036328792572, -1.27971613407135, -0.713691234588623, -0.3595232665538788, 0.2337438464164734, -0.6585404276847839, 0.010250484570860863, -0.5869852900505066, -0.15198670327663422, -0.21790170669555664, -0.5982065200805664, -0.01271328330039978, 0.10933561623096466, 0.2115839421749115, 0.5204920768737793, -0.8705633282661438, 0.5076922178268433, 0.10929891467094421, -0.3825151026248932, -0.568508505821228, -0.6556599140167236, -0.23542430996894836, 0.48471468687057495, -0.38509219884872437, 0.32511666417121887, -0.2932083010673523, -0.4434695839881897, -1.0102696418762207, 1.516425371170044, -0.3066645562648773, 4.842358589172363, 0.21008342504501343, 0.38550829887390137, -0.2896564304828644, -0.07417206466197968, 0.04364585876464844, 0.08853016793727875, 0.5602689981460571, -0.20113368332386017, 0.5830589532852173, -1.439095139503479, 0.5872414112091064, 0.030696317553520203, 0.9481043219566345, -0.19927768409252167, -0.5931260585784912, -0.6113477349281311, -1.1207489967346191, 0.653133749961853, -0.15834841132164001, -0.04974766820669174, 0.10626912117004395, 0.7420788407325745, -0.3052014112472534, -0.11642096191644669, -0.6581622362136841, 0.737149715423584, 0.15039773285388947, -0.8755049705505371, -0.18951022624969482, -0.020911723375320435, -1.2762434482574463, -0.011237621307373047, -1.1195497512817383, 0.22497498989105225, 0.3089446425437927, -1.1827400922775269, 0.08156734704971313, -0.22336947917938232, -0.392307311296463, -0.3434869647026062, -0.26746290922164917, 0.7512896060943604, -1.1607680320739746, -0.5089085698127747, -0.8395124077796936, -0.01815534383058548, 0.10881048440933228, -0.8013051748275757, 0.670390248298645, -0.13142091035842896, 0.2351459562778473, -0.2631656229496002, 0.44011223316192627, 0.2820248007774353, 0.21060779690742493, -0.46573421359062195, -0.5503321290016174, 0.15434019267559052, -0.1043747067451477, -0.4841141700744629, -0.08879505097866058, 1.262444019317627, 0.4760212004184723, -0.633092999458313, -0.3069542646408081, 1.063773512840271, -0.7447455525398254, 0.11260897666215897, 0.833873450756073, 0.06256043165922165, -1.382439136505127, -0.6893336772918701, -0.758093535900116, -0.04543858766555786, -0.06377565860748291, 0.7037124633789062, -0.3683728277683258, -0.11359784752130508, 1.0261894464492798, 0.6597989797592163, 0.5149080157279968, -0.287433385848999, 0.28341561555862427, -0.35006871819496155, 0.6897448897361755, -0.31815630197525024, -0.5173536539077759, -0.028316736221313477, -0.11619247496128082, -0.17020481824874878, -0.16953358054161072, -0.6703485250473022, 0.12162169814109802, -0.5127832889556885, -0.5329175591468811, -0.2913203239440918, 0.9006732106208801, 0.03423842787742615, -0.6857517957687378, -0.27736133337020874, -0.22682607173919678, -0.06812648475170135, -0.5536119341850281, -0.7675877809524536, 0.6976498365402222, -0.8978599309921265, -0.5628985166549683, -0.169549822807312, 0.08024312555789948, 0.4028271734714508, -0.8585132956504822, -0.1911211907863617, -0.5997481346130371, -0.09232591092586517, -0.3291813135147095, 0.09529797732830048, 0.370572566986084, 0.07746190577745438, -0.2616596519947052, 0.8870151042938232, -0.08185495436191559, 0.12616664171218872, -0.45046937465667725, -0.9999448657035828, 0.33053165674209595, 0.21439027786254883, -0.3834727108478546, -0.13952970504760742, 0.19852782785892487, 0.5792974233627319, -1.0897345542907715, 0.05580167472362518, 0.5212750434875488, -0.25708866119384766, -0.8642084002494812, 0.014523923397064209, -0.2943044602870941, -0.2870948314666748, 0.2805054783821106, 0.543908417224884, -1.5695116519927979, -0.6158971190452576, -0.10188284516334534, 0.564464807510376, -1.3439339399337769, -0.45758795738220215, -0.7984118461608887, 1.1634081602096558, -0.19832193851470947, -0.6213709115982056, 0.3126901090145111, 0.2803053557872772, 0.5609810948371887, 0.407858669757843, -1.0492279529571533, -0.41762733459472656, -0.09549112617969513, 0.21189528703689575, -0.7021201848983765, -1.911512851715088, 0.13025835156440735, -0.6464464664459229, -0.3382817208766937, 0.4875839948654175, -0.4371591806411743, 0.17569422721862793, -0.8699796795845032, -0.816620945930481, 0.5528818368911743, 1.1274100542068481, -0.6332846879959106, -1.4060677289962769, -0.8397383689880371, 0.28254684805870056, -0.9760139584541321, 0.10685604810714722, 0.7464667558670044, 0.24609017372131348, -0.6224397420883179, 0.09236009418964386, -0.0198829248547554, -1.0442451238632202, -0.884579598903656, -0.37565481662750244, -0.3814859092235565, -0.8526304960250854, -0.1498868763446808, 0.4975522458553314, -0.19102507829666138, -0.3441160023212433, -0.766552209854126, -0.2955986559391022, -0.7632914781570435, 0.8735895156860352, -0.3111790418624878, -0.1044582724571228, -0.20861001312732697, -0.7188543081283569, -0.020366430282592773, 0.9956230521202087, -0.18819406628608704, -1.326981544494629, 0.5397154688835144, -0.5692976117134094, 1.0624027252197266, -0.42140528559684753, -0.2421233057975769, -0.5501478314399719, 0.252921998500824, -0.4804975092411041, -0.11158290505409241, 0.40163108706474304, -0.018132418394088745, 1.0768446922302246, 1.947619080543518, -1.4569119215011597, 0.054213181138038635, 0.4061790108680725, 0.6093915700912476, 0.7454372644424438, 0.41230031847953796, -0.5347564220428467, -0.17126265168190002, -0.4819813370704651, 0.5622429251670837, 0.8115852475166321, -0.05775576829910278, -0.5823003649711609, -0.12972958385944366, 0.20261192321777344, 0.3993527591228485, 0.09292128682136536, -0.13695818185806274, 0.3980538845062256, 0.8167474269866943, 0.08387812972068787, 0.4295119345188141, -0.2748852074146271, -0.3343026041984558, 0.3574368357658386, 0.11234267055988312, 0.7412310838699341, 14.8656005859375, -0.594961404800415, 0.48582208156585693, 0.4497680068016052, 1.4567316770553589, 0.430555135011673, 0.48015832901000977, -0.25975388288497925, -0.3488611578941345, 1.4213697910308838, -0.19660241901874542, -0.06956219673156738, -0.16813674569129944, -0.5542120337486267, -1.084112524986267, 0.5261085629463196, 0.4855799376964569, 1.2036137580871582, 0.5439582467079163, 0.08194470405578613, 0.08521750569343567, -0.3439655303955078, 0.15144546329975128, -0.054620034992694855, 0.5808935165405273, 0.6028804779052734, -0.3203928768634796, -0.34127703309059143, 0.837232768535614, 1.140022873878479, 0.2187265157699585, -0.14937204122543335, 0.9922772645950317, -0.3958583474159241, -0.017731353640556335, 1.0287824869155884, 0.5453051328659058, 0.17267492413520813, -0.13068003952503204, -0.31128719449043274, 0.10176858305931091, -0.5209980010986328, -0.07744798064231873, 0.22153715789318085, 0.5045759677886963, -0.19371286034584045, 1.4105390310287476, -0.1279146820306778, 0.3007313311100006, 0.28724056482315063, 0.7570598125457764, -0.06505115330219269, -0.11150996387004852, -0.26597505807876587, 0.4599452614784241, 0.1621500551700592, -1.010772943496704, -0.4081391990184784, -0.6115609407424927, 0.8744516372680664, -0.5314987897872925, 0.7128462791442871, 0.5344306826591492, 0.8924034833908081, 0.03190106898546219, -0.10018658638000488, -0.8226401805877686, 1.0232951641082764, -0.9467943906784058, -0.9710255861282349, 0.5701547861099243, 0.23298496007919312, 0.3696291446685791, 0.5187316536903381, 0.5433115363121033, -0.29515114426612854, -0.08038559556007385, 0.2670711278915405, 0.9602323770523071, -0.5979721546173096, 0.06949882209300995, -0.006455682218074799, -0.5564695000648499, 0.9933463335037231, 0.49321043491363525, -0.1647258698940277, -0.04807943105697632, -0.11422072350978851, 0.5615835785865784, -1.1612964868545532, 0.4343310296535492, -0.34418708086013794, 0.013667479157447815, 0.12934592366218567, 0.66257244348526, -0.5964339375495911, -0.7144793272018433, 0.5518357753753662, -0.17436397075653076, -0.6487197875976562, 0.41483765840530396, 0.8750195503234863, 0.25318244099617004, 0.1169324517250061, -0.007389336824417114, -0.26891911029815674, 0.5026417970657349, 0.09807278215885162, -0.0034384727478027344, -0.23115497827529907, 0.1474035680294037, -0.5420050621032715, 1.221367359161377, 0.9600163698196411, 0.31160134077072144, 0.2960410714149475, -0.6968088150024414, -0.34065568447113037, 0.3557378053665161, -0.24565008282661438, 0.022243350744247437, 0.22144654393196106, 0.7384370565414429, -0.3108023405075073, 0.8741224408149719, -0.49571657180786133, 0.5709522366523743, -0.31051167845726013, -1.321481704711914, 0.32526886463165283, 1.2174923419952393, -0.549229621887207, 0.4277633726596832, -0.05729991942644119, 0.27057307958602905, 0.0697900652885437, 0.5394091010093689, 0.3959709703922272, -0.7071380615234375, 0.0630316510796547, -0.13066920638084412, 0.22473850846290588, -0.5926640629768372, -0.0907837375998497, -0.4253511428833008, -0.46378639340400696, -0.20364588499069214, -0.5486412048339844, 0.7621446847915649, 1.2789448499679565, 0.7930097579956055, 0.6048036217689514, 0.3513868749141693, -0.2271181046962738, -0.4826171398162842, -0.19040828943252563, 0.5884449481964111, 0.3336378335952759, -0.46784043312072754, -0.8947547674179077, 0.48118963837623596, 0.11890649795532227, -0.31245100498199463, 0.9721456170082092, -0.5508612990379333, 1.0448801517486572, 0.14603887498378754, 0.46909499168395996, -0.12901386618614197, -0.32194775342941284, 1.2423884868621826, -0.019345760345458984, 0.5161972045898438, -0.7374123334884644, -0.18366843461990356, 1.061742901802063, -1.1442219018936157, -0.5421412587165833, -0.07626509666442871, 0.36317959427833557, 0.08938125520944595, -0.40196195244789124, -0.29880446195602417, -0.5456704497337341, -0.6010328531265259, -1.1308190822601318, -0.03120821714401245, -0.034523606300354004, 1.3391640186309814, -0.30142638087272644, 0.08253135532140732, 0.0707375630736351, -1.1974085569381714, 0.7756150364875793, 0.07806399464607239, 0.08537030220031738, 0.16305527091026306, 0.2319243848323822, -0.17693278193473816, -0.9409387111663818, -0.9152044057846069, 0.6617499589920044, 0.06469225883483887, -1.1467604637145996, 0.26162007451057434, -0.35150474309921265, 0.3981757164001465, -1.0698364973068237, 0.6738657355308533, 0.15242168307304382, 0.3142722547054291, -0.2702473998069763, -0.5521812438964844, -0.3721489906311035, -0.558000922203064, -1.0239543914794922, 0.4203864336013794, 0.050230324268341064, 0.7936234474182129, -0.7041963934898376, 0.15407295525074005, -0.0206567645072937, -0.6968936920166016, 0.4556088149547577, -0.7326948046684265, 0.33119213581085205, -0.42238354682922363, 0.2564896047115326, -0.023171786218881607, -0.27545619010925293, -0.8497406840324402, -1.65725576877594, 0.3994784951210022, 0.1749776303768158, 0.3087218403816223, -0.9338999390602112, 0.2407253086566925, -0.515414834022522, 0.45183950662612915, -0.1568685919046402, -0.35936981439590454, 0.9391710758209229, 0.381924033164978, -1.0622210502624512, 0.16699433326721191, -0.27783554792404175, 0.24983254075050354, -0.6392960548400879, 0.10927534103393555, 0.17213107645511627, 0.5686562061309814, -0.6653749346733093, 0.28584998846054077, 0.18297120928764343, -0.37783169746398926, 0.3073505461215973, -0.7673163414001465, 0.5224564075469971, -0.6159696578979492, 0.8615347146987915, -1.4109050035476685, 0.43380865454673767, -0.7996044754981995, -0.4222235679626465, 0.5397876501083374, -0.20802435278892517, 0.31187310814857483, -0.03070063889026642, -0.05211475491523743, -0.4686814844608307, -0.6858760118484497, -0.5296874642372131, 0.35162967443466187, -0.5566670298576355, 0.2050258070230484, 0.16744740307331085, -0.15059131383895874, -0.043289005756378174, 0.015622630715370178, 0.7753648161888123, -0.2999345362186432, 0.2400340586900711, -0.47965875267982483, -0.12923994660377502, 0.4034363925457001, 0.04126453399658203, 0.08123219758272171, 0.1358366459608078, -0.3403080701828003, -1.127793550491333, -0.31666240096092224, -0.8529108166694641, 0.22763392329216003, -0.07447715103626251, 0.12208858132362366, -0.5813857316970825, 0.6918404698371887, 0.25126832723617554, -0.42307648062705994, 0.35375332832336426, -0.5264137983322144, 1.0260653495788574, -0.8345520496368408, -0.40807008743286133, -0.8623520135879517, -0.038757771253585815, -0.8002436757087708, -0.08836065232753754, 0.7082077264785767, -0.09523290395736694, 2.226301670074463, -0.1276836097240448, 0.30685949325561523, 0.6580010056495667, -0.13965502381324768, 0.33333098888397217, -0.48179662227630615, -0.2458103597164154, 0.14482265710830688, 0.8049143552780151, 1.3138386011123657, 1.1841480731964111, 0.4694259464740753, -0.2785814702510834, 0.5418655276298523, 0.24912218749523163, 0.17878714203834534, -0.10273264348506927, -0.2611052989959717, 0.6845497488975525, 0.4687749147415161, 0.0173123050481081, 1.571108341217041, -0.45439016819000244, -0.2769099175930023, 0.8694016933441162, -0.21153825521469116, 0.7728332281112671, -0.3016048073768616, 0.3648200035095215, 1.4431655406951904, 0.22569569945335388, -0.19617682695388794, 0.9996469616889954, -0.11498621106147766, -0.7450618743896484, 0.961172878742218, 0.24070397019386292, -0.4985012412071228, -0.23021350800991058, 0.9806320667266846, -1.0675959587097168, 0.11270543932914734, 0.073881596326828, 0.7137928009033203, -0.5890072584152222, 0.9419488310813904, 0.1578826755285263, 0.7229974865913391, -0.049805447459220886, 0.7751532196998596, 0.23778197169303894, 0.6586291790008545, -0.2195659875869751, -0.5008025765419006, -0.7428720593452454, 0.7497714757919312, -0.18676763772964478, 0.8340473175048828, -0.25409454107284546, -0.4744546413421631, -0.7173629999160767, 0.12971249222755432, -0.8665938973426819, -0.8012356162071228, -0.5951037406921387, 1.3407785892486572, -0.6530038118362427, 0.8258619904518127, 0.4953996539115906, -0.8851323127746582, -0.012827500700950623, 1.1381608247756958, 0.03541174530982971, -0.07641417533159256, -0.4609633982181549, -0.6598407626152039, -1.4730738401412964, 0.7355350852012634, -0.10814585536718369, 0.13536088168621063, -0.7147923707962036, -0.8860681653022766, -0.9624638557434082, 0.2953041195869446, 0.23123082518577576, 0.08424177765846252, -0.3063070774078369, -0.2469802051782608, -0.2798580527305603, -1.1017000675201416, 5.234522819519043, -0.30444979667663574, 0.6766939163208008, -0.2564811110496521, -0.6237413287162781, 1.0296475887298584, 0.8078457117080688, 0.11485086381435394, -0.4182020127773285, -0.39151471853256226, 0.32149797677993774, -0.8965021967887878, 0.35991498827934265, -0.3316801190376282, -0.4482725262641907, -0.5659970641136169, -0.34144654870033264, -0.3934059739112854, -0.5167178511619568, -0.10607379674911499, 0.8881195783615112, 0.6360120177268982, -0.295132577419281, -1.0785942077636719, 0.4108785390853882, 1.0697243213653564, -0.21363794803619385, 0.4505394697189331, 1.0171903371810913, -0.2147991955280304, 0.04472225904464722, -0.8488333225250244, -0.6040114164352417, 0.6300105452537537, -0.8120002150535583, -0.8351748585700989, 0.17342381179332733, -0.055390894412994385, 0.01671832799911499, -0.31661272048950195, 0.7717354893684387, 0.44348108768463135, 0.16662143170833588, 0.2120363712310791, -0.053394317626953125, -0.23782318830490112, 0.13878460228443146, -1.028709888458252, 0.44579607248306274, -0.795896589756012, 0.6455755829811096, 0.13688752055168152, 0.011605992913246155, 0.3911620080471039, 0.9670004844665527, -0.7552154660224915, -0.08244706690311432, 0.8598371148109436, 0.050932079553604126, 0.462717205286026, 0.3560883700847626, 1.0741355419158936, -0.25476962327957153, -0.551042377948761, -0.012054741382598877, 0.766149640083313, -0.13875660300254822, 0.9747268557548523, -0.9302296042442322, 0.13980427384376526, 0.36906546354293823, -0.2913077175617218, -0.36266642808914185]
# bert: [[0.6306526660288537, 0.3746190070731338, -0.6496761440581098, 0.08958756177721602, 0.5497715472625277, -0.03632658719653214, 0.08682402967538437, 0.586905181349238, -0.47451853747391043, 0.41081863637630706, -0.30161446329915376, -0.08245318382153907, -0.19952209291847095, 0.8027286528738287, -0.16374564169199946, -0.5668019055753388, 0.2545919716103593, 0.49604052300261153, 0.8567279576398521, 0.7600247859194809, -0.9083977340743519, -0.6157692074159926, -0.515315949865308, -0.1655371934009954, 0.057464562350725557, -0.07802289723569747, 0.5397913455423343, -0.5983467101452434, 0.1559152304970275, -0.5320642589990702, 0.47233283515021546, -0.5325314402047729, 0.8761982916909447, 0.07608173041774964, -0.6771453618326151, -0.1865711509994856, -1.1267948149507971, -0.23972532150732323, -0.07891625165150168, -0.6784279345787636, -0.657316088610721, -0.41231748457600154, 0.7349357604245533, -0.11325503139555392, 0.3396317064422484, -0.29459115859900464, -0.5613461732303033, -0.13909369705716607, 0.8690489529694305, 0.7712998985472902, -0.27765142914856544, 19.350620267840327, -0.17601215837625864, 0.28022530672132134, -0.4478674530535104, -0.6495089530295315, 0.4692372381217927, -0.6964136361379392, 0.255285114024383, 0.17501929400601185, 0.6381330489474172, -0.17124022541717926, 0.0613570325015223, 0.2614971399045754, 0.9533716439247434, 0.3093365430522573, 0.3020793199237105, -0.029461748895083153, 0.180179700237376, -0.11040958016006729, -0.425050675826483, -0.41989177461239924, -0.8620399235817037, -0.6892638801839117, 0.5295963286823919, -0.21323782203449287, -0.3404573797839169, -0.17358383534602967, 0.10535743831534622, 0.07599624990656968, -0.34680700298655953, 0.14986009894302943, 0.33416587110992446, 0.3762381672482954, -0.7581336497502364, -0.24970102307683653, 0.19458855686626045, 0.41221767659833514, 0.3110540806936108, -0.9035001992275821, -0.13727888463554885, 0.4829467534535974, 0.42993336911670516, 0.23731420931827144, -0.6785467862404339, -0.052651617670754505, -0.24095314738725113, 0.17550863323840768, -0.2985870241820248, 0.07398155330871818, 0.014141649006383076, 0.17074087260446216, -0.6333214043937602, 0.14476782082063674, 0.7364118098476234, -0.04032950102879634, 0.09973394869760717, -0.4027093946531037, -0.3961689173779093, 0.6746689676563795, -0.2996644973455218, -0.2941179275218577, 0.20468662677148539, 0.3897557258216201, 0.2173617630979614, -0.5875810980209233, 0.08069323002485151, 0.9947155713040319, 0.0600114762723039, 0.4519280194784278, 0.6084412931787494, 0.5464289783885028, 0.5454699396541627, -0.047249048943563056, -0.7533235549173434, -1.0305123328132084, 0.6547825931847964, 0.7952549456754794, -0.48929455871457456, -0.20302191374655876, 0.8560128211119085, 0.27003753182571844, 0.9303492902779062, -0.2536320388063476, -0.1583033203920371, -0.5893669127828601, -0.10494965313815616, -0.3481703996310155, -0.6564546226798684, -0.378303229770977, 0.547796726172027, 0.4961388706664811, -0.24462983009753103, 0.45544433589195554, -1.1424793003847145, -0.7886708974049585, 0.1505621075479626, -0.3545129298809305, -0.04589547961491347, 0.19876451788345148, -0.8803983925892673, -0.01044853031530799, -0.5179698466736669, 0.6529698371234237, 0.398086637218721, 0.4209825396116798, 0.9252882598905339, -0.7742250560939947, 0.546974658911367, 0.749486088677798, 0.01552255824053034, 0.041418530042797996, -0.5258542894791224, 0.5218966006710769, -0.3961237668594965, -0.25490146872832453, 0.2645166814062723, -0.3742636441810185, 0.40362739558952004, 0.533313155120924, 0.31234931942677285, -0.1769360899748296, 0.0679463446072343, 0.5375190972744341, -0.2682217359274625, -0.25480967757537965, -0.7499064802373567, -0.5096233486619588, 0.4183275699197151, 0.10073798148816762, 0.2096390872984102, 0.5536777376574923, -0.4229152202183286, 0.923355340865306, -0.038815084840946146, -1.336723923549494, -0.792407572190199, -0.2983457445799982, 0.37771177288093, -0.40129607911865334, -0.04543194174312221, 0.6007425188417507, 0.3753281831366005, -0.5683281421093048, 0.08757197856027356, -0.5541877746027843, 0.08410357683055983, -0.9881380199397909, -0.02354864030840945, 0.7716079353514586, -0.052929490799379295, 0.07649426906536007, 0.31480106708239625, -0.12461680917685793, 0.32127922770148415, 0.6134973167759611, 0.3431465029373345, -0.0850225686941955, -0.525812745041718, -0.7522732018672165, -0.5061609744519474, -0.057370789343342055, -0.40534555907964365, 0.70034277432114, -0.05888596176512276, -0.39736008640130405, 0.36634010072859424, 0.39277261491662485, -0.6550390123665945, -0.6340379118285334, 0.4746735989572781, -0.42083391542994725, 0.05550198256414432, -0.7921302317780867, 0.5211235284284175, -0.12946067749159343, -1.039283990756057, 0.2080265581399792, -0.07423394172641373, 0.2656548022958222, 0.1160395741346668, -0.592529058397168, 0.47230687732741833, 0.5247147678804204, 0.14889508484305117, -0.29375421997947465, -0.5278251766630683, 0.9793400763485992, -0.7134119271518644, 0.239502742862593, -0.07753466068922987, -1.2142924069143983, -0.012478321789447359, 0.28109955784847696, 0.04507044702317621, 0.12475326656047694, -0.15020783244061428, -0.8671512602892615, -0.6826823353084712, -0.27987509963097856, -0.45993065829446106, 0.14978057144574583, 0.5429900288038858, -0.7859765290428012, -0.22541469333301883, 0.30612897869863515, 0.6566796898185178, 0.15746085344170477, 0.21248042581340773, -0.49717837567125994, -0.4173994659960103, -0.2738975286209867, -1.304616212714387, -1.2519400118529553, -0.21707811949466488, -0.11831353603610413, 1.5084242819231322, -0.0876403599889853, 1.0673756598358894, -0.053837262088637115, -0.24577629563734862, -0.32281914350142477, 0.24873660502330597, 0.18757051227601224, -0.11690303682111915, -0.10590990631713347, -0.5542140602511276, 0.8782381414488888, -0.5875433682807842, -0.001549732871198653, -0.06851203738957977, -0.02521789073691913, 0.27980545160356546, -0.06835047154935163, 0.11716064809581261, 0.03366292267701167, -0.009598478673928762, 0.1907078176546124, 0.30920869108922683, -0.5711708664322933, 0.17034314571107695, 0.012157902120328095, -0.3299352824358022, 0.3181459903398895, 0.2730965614045751, -0.14626899360147722, -0.33298140760906636, -0.14376403389923595, 0.28096491095594284, -0.138027295456435, -0.20737986264539207, -0.09455066918381276, 0.16080614922822786, 0.0982434749505028, 0.11342573164759297, -0.4842654466144763, 0.20767429468939186, 0.1440525352810812, 0.9801909326526828, -0.3096403777289694, 0.7776625155624926, 0.44931507106102553, 0.6137907504421609, 0.5137087702237451, -0.19011178610807927, 0.44963866467747876, -0.54709666961921, 0.8837630151818568, 0.04654179512989019, 0.35308977958009324, -0.3143602609320039, -0.6175444721558053, -0.4325044750734793, 0.817685961641559, 0.025770355013416082, 0.018303543327408536, 0.1451391428563891, -0.3312309384014777, 0.6500570177381865, 0.4397580623186951, -0.044243231411324274, -0.1256297826641338, 0.37402218576505747, -0.6808236836706261, -0.09826962648839539, -0.27564325925931615, 0.8515565394503668, 0.06322145461403918, -0.024291120467141047, -0.47716349358555393, 0.8932030200065049, -0.43456333871310493, -0.48824536795502066, 0.152983725055655, -0.4411605298077974, 0.034337669607543406, -0.14094170926591987, 0.16322001813210024, 0.6954740285177939, -0.39862936731166904, -0.9514524935724573, 0.0385821610650581, -0.19353994725199306, -0.5199088453726612, -0.4418335556542114, 0.36879512663967995, 0.3916288911904666, 0.12908741830488607, -0.2568394541483578, -0.3345807790421645, 0.47712144250866906, 0.4087583720275293, -0.37433353062701064, 0.43552467222626867, -0.27347874638683667, 0.660244524412888, 0.6962032317419031, 0.07173644005534924, 0.7627076505851977, 0.00793291628281419, 0.8588978051280385, 0.23177407679624246, 0.24891483781232776, 0.28828859326340744, -0.6761640309611312, -0.7521336077891665, -0.20729212460829147, 0.8658699988452978, -0.34208124872601525, 0.5094920396295317, -0.3722693323716781, 0.12484254686776096, 0.3192453384080169, 0.18445999918523595, 0.6357386111577397, -0.27072572705422626, -0.17143151162340556, -0.4210552572782985, 1.0496314762973196, -0.17923560736771182, 0.36338230963887846, 0.7160731553315299, -0.04388396441497653, -0.3810636698818613, 0.36740601059100597, 0.057484060520145756, -0.5671348571210209, 0.3772912025074369, -0.8322036265494701, 0.668071925573299, 0.05826081707491008, 0.04276432841588577, -0.3697907328235861, 0.314197510449461, 0.9187251328503272, -0.6464202999422244, 0.3113736211942197, 0.44188618655554285, 0.42487409706635354, 0.04739161580327094, 0.4854775070658626, 0.37551599737226893, -1.2069820164427174, -0.05486005544113875, 0.3121619224236178, 0.9826198815316819, 0.30169457194172383, -0.635430097516413, 0.30996268984556014, -0.14952649174625493, -0.17568108437688684, 0.35002976652459783, -0.3448984026563976, 0.13267526029213714, 0.3213638364947343, -0.1819912791070145, 0.14946772156651228, 0.7323971389991785, -0.1623047143058597, -0.19856798646848547, 0.06230998783680565, 0.24570739266799518, 0.09874285011496169, 0.43483281131210755, -0.17730252442971084, 0.36733961101673285, 0.12426072357842476, 0.05789160727875674, 0.08827309309553517, -0.6317251920068347, -0.00628868304130133, -0.5074117779224339, 0.25323426720947884, 0.5101101397957908, -0.16245779393478876, 0.31628522273715504, 0.12658020852730476, -0.13960443435703412, -0.02043110504542126, 0.04178767650901627, -0.45393502707710404, -0.04647864028346668, -0.1404846310475055, -0.09912095962963716, -0.626590371069238, 0.4327986239954164, -0.31904062625555624, 0.5147157310924798, -0.027515560385813508, 0.8144619464059806, 0.3302216231492746, 1.3214893339742964, 0.2218289226071735, -0.0900830179362813, 0.22738218305221294, -0.06650459765722894, -0.07094223051553837, -0.06291668116417189, -0.775943279188763, 0.32711696621484687, -0.15921384094553492, 0.1375618576865917, -0.603704452454278, 0.6387802361803236, -0.15176597236069314, 0.3476013838897241, -0.15890784560044985, 0.5436623095922402, -1.4193722008239442, 0.032165475186469276, -0.5548100470941771, 0.7172274588821347, -0.0047330260272061405, -0.4785244464395743, -0.483325064133949, 0.1279392838350149, -0.09484766422753763, 0.25050142404912284, 0.25165757534371547, 1.3810386656333804, 0.3012371957000856, 0.23889213798041375, -0.20149801669489995, -0.23245084283411577, -0.29425668713488096, 0.887437701136537, 0.6642152666381378, -0.9867643712964347, 0.4328394233747611, 0.31778126951854535, 0.6174364089348384, 0.11267478017872352, 0.40354615445869935, -0.7745115756214014, -0.08863573520489298, 0.7508816718304294, 0.5931748747232448, -0.2806225418763872, -0.4358469843428594, -0.1927260160253441, -0.021922955287290775, -1.1405953167728422, 0.11694165318034914, -0.23776267466551665, -0.4972788393000188, 0.592477858007311, -0.574982166232785, 0.23954167959678863, 0.7133891581775624, 0.46818333859530203, -0.5731054543875747, 0.45874208207311384, 0.6138339042049741, 0.05652263760001485, -0.012420818208406051, -1.1665375231529995, 0.4930713772280671, 0.19040077922824386, -0.48241606349889277, -0.7850733994652549, 0.5122188329184436, 0.024191766974891005, 1.0655137299425819, 0.11576686053310487, 0.7753105758845356, -0.16412380336073912, -0.14383952318183643, -0.09240663050681158, 0.6814962028775596, 0.2688901424139069, -0.6885172127988851, -0.6384639143305323, -0.25581377742116546, 0.0800931006589905, 0.6115119456633361, 0.5667107104688416, 0.3658409118286503, -0.9042972325374389, 0.1341029703482993, 0.19639387724819812, -0.12785200773391128, -0.35469770427971575, -0.10340277849593871, -0.0017232820389931685, -0.17688953874726465, -0.12582607566052073, 0.25396889445626203, 0.4972740709284373, -0.05373089014946547, -0.14903390406071917, 0.3879106938451048, 1.0107775925579188, -0.43192803855391415, 0.0263187959763911, -0.26048305628079066, -0.08843228220055313, 0.10098989306870503, -0.39070010181334697, -0.8197115658894033, -0.5753985642811442, 0.4738180636885801, -1.199191093324905, -0.31724601980851586, 0.3449849486006028, -0.6193803548193486, 0.5641028880508895, -0.2957195937337795, -0.05238696559739764, 0.36578288670696724, -0.6054455637326378, -0.0563061162773093, -0.0779225975197117, -0.3600379228231881, -0.6483795046157956, -0.2780840992649467, -0.11889258770945856, 0.14801374076316798, -0.2589623629787882, 0.7710352539245139, 0.09354778378266411, 1.4047462938811317, 0.025004848835351992, 0.17783376572737958, 0.5516481995030932, 0.05849239974629081, -0.9809936284037927, 0.2400841712711576, -0.4202473759230937, 0.20667645333130685, 0.15535554288264256, 0.16784873603095987, -0.1850029229932795, -0.11954740433689551, -0.032592773434240725, 0.44512397046406305, 0.4523606895948091, 0.2322830557590898, -1.1121829747041503, -0.02558117732149851, 0.9128457306902706, 0.5033814906570593, -0.544602572863478, -0.727762937473, -0.6572413443861802, 0.49865317339678994, 0.547905027811573, 0.023255337027369975, 0.24598585066719675, -0.3069388270071174, -0.5315648316805471, -0.26797971126737624, -0.37094941731558145, -0.3633933961028056, -0.4774981736659343, -0.17666316030643037, 0.2717643379893336, 0.5946053861977111, -0.18561136720708585, -0.10143223403870016, 0.043682135637206645, -0.1700977682897224, -0.08753666280824768, -0.9132027625124395, 0.49473285670101497, 0.13347299395657, 0.28758609292015497, -0.6140625476223096, 0.03722870349511746, 0.888671576887909, -1.030151843921643, -0.03175431489626915, -0.2592756449916963, -0.42233547564097873, -0.32220610972997116, -0.3735819458587905, 0.2414529025313204, 0.20765319464514348, 0.1115174293406549, -0.3442982136858918, 0.018863439558050178, -0.09828518330068022, -0.009483113883977531, 0.050791256124662544, 0.1894357651282656, 0.31602573391615135, 0.5032234191391308, 0.9536163805961667, -0.35892570015179054, 0.22689862547035974, -0.03246439247998797, 0.5833472012890164, 0.052884370083288834, 1.5387468336473948, -1.091284036527224, -0.10146543382583673, 0.2077142298013874, -0.23488515613114405, 0.010188698767596852, -0.7108926176313949, -0.026084121314062958, 0.8767777084427483, -0.6342701911291999, 0.7626209258270582, -0.0993431508441764, -0.9476521014219584, 0.43203383679837987, 0.6022625564926607, -0.4998182057834532, -0.2664181589813843, -0.5641704201134132, -0.24419260022582487, -0.7398847936844039, 0.5309208034938134, -0.10964091121054012, 0.4174488186418794, -0.3131428062602659, -0.10016175358485915, 0.46978431935380893, 0.2433155029768815, -0.4275586008598015, -0.08418849109761448, 0.5456860064914519, -0.3827338218306231, 0.028185240921539845, -0.6779584287919148, -0.7362285255649574, -0.6870286464004134, 0.48430156702920657, -0.2843299507810458, 0.03858663141341581, -0.6711872815414628, -0.27759069201554537, 0.19673961399018322, 0.19274833796481025, -0.28647205230709194, -0.19459478555163884, 0.11263997851675876, -0.3239593505535416, 0.29629501697438354, 0.5434969663076498, -0.5418423413688505, -0.010050237177797466, -0.37255942817777093, -0.3920629322136776, -0.7736825942219482, 0.9160444735564668, -0.3855381905647024, -0.24512580034665746, 0.039987117048079536, 0.0023105889556481523, -0.008350491522907627, 0.12186954914304833, -0.2859630882454058, -0.5824805497540688, 0.17072537539682212, -0.37524050470414466, -0.6623861192994536, -1.0753924845573777, -0.1807441711245037, -1.062588453186588, -0.45628574485984325, -0.023208271709743915, 1.0931034087041662, 0.24394050238077258, 0.49655324215691815, 0.6397269963578412, -0.07223997264378079, -0.0954866707229495, 0.20401087401257315, 0.006146766244750466, -0.3658036887279918, 0.3079345822026355, -0.3102233707594592, 0.3729524016007358, -0.6661531328488816, 0.32162523266437065, 0.5729576348685466, 0.23430354890864513, 0.22858202455142157, 0.4998266398406881, -0.9291718005204861, -0.8554716109374021, 0.048855125899197736, 0.09706948696596292, -0.08105197548055752, -0.11186292021348031, 0.03570240735650666, 0.1373468637329084, 0.5150644778690258, -0.3556829392554321, 0.4928233921035039, 0.18298985062199796, 0.176290675980105, -0.19125913081640722, -0.71059012405919, 0.17524778841173547, -1.0162193774160782, -0.19700393078741324]]
# [ 6.30652666e-01  3.74619007e-01 -6.49676144e-01  8.95875618e-02
#   5.49771547e-01 -3.63265872e-02  8.68240297e-02  5.86905181e-01
#  -4.74518537e-01  4.10818636e-01 -3.01614463e-01 -8.24531838e-02
#  -1.99522093e-01  8.02728653e-01 -1.63745642e-01 -5.66801906e-01
#   2.54591972e-01  4.96040523e-01  8.56727958e-01  7.60024786e-01
#  -9.08397734e-01 -6.15769207e-01 -5.15315950e-01 -1.65537193e-01
#   5.74645624e-02 -7.80228972e-02  5.39791346e-01 -5.98346710e-01
#   1.55915230e-01 -5.32064259e-01  4.72332835e-01 -5.32531440e-01
#   8.76198292e-01  7.60817304e-02 -6.77145362e-01 -1.86571151e-01
#  -1.12679481e+00 -2.39725322e-01 -7.89162517e-02 -6.78427935e-01
#  -6.57316089e-01 -4.12317485e-01  7.34935760e-01 -1.13255031e-01
#   3.39631706e-01 -2.94591159e-01 -5.61346173e-01 -1.39093697e-01
#   8.69048953e-01  7.71299899e-01 -2.77651429e-01  1.93506203e+01
#  -1.76012158e-01  2.80225307e-01 -4.47867453e-01 -6.49508953e-01
#   4.69237238e-01 -6.96413636e-01  2.55285114e-01  1.75019294e-01
#   6.38133049e-01 -1.71240225e-01  6.13570325e-02  2.61497140e-01
#   9.53371644e-01  3.09336543e-01  3.02079320e-01 -2.94617489e-02
#   1.80179700e-01 -1.10409580e-01 -4.25050676e-01 -4.19891775e-01
#  -8.62039924e-01 -6.89263880e-01  5.29596329e-01 -2.13237822e-01
#  -3.40457380e-01 -1.73583835e-01  1.05357438e-01  7.59962499e-02
#  -3.46807003e-01  1.49860099e-01  3.34165871e-01  3.76238167e-01
#  -7.58133650e-01 -2.49701023e-01  1.94588557e-01  4.12217677e-01
#   3.11054081e-01 -9.03500199e-01 -1.37278885e-01  4.82946753e-01
#   4.29933369e-01  2.37314209e-01 -6.78546786e-01 -5.26516177e-02
#  -2.40953147e-01  1.75508633e-01 -2.98587024e-01  7.39815533e-02
#   1.41416490e-02  1.70740873e-01 -6.33321404e-01  1.44767821e-01
#   7.36411810e-01 -4.03295010e-02  9.97339487e-02 -4.02709395e-01
#  -3.96168917e-01  6.74668968e-01 -2.99664497e-01 -2.94117928e-01
#   2.04686627e-01  3.89755726e-01  2.17361763e-01 -5.87581098e-01
#   8.06932300e-02  9.94715571e-01  6.00114763e-02  4.51928019e-01
#   6.08441293e-01  5.46428978e-01  5.45469940e-01 -4.72490489e-02
#  -7.53323555e-01 -1.03051233e+00  6.54782593e-01  7.95254946e-01
#  -4.89294559e-01 -2.03021914e-01  8.56012821e-01  2.70037532e-01
#   9.30349290e-01 -2.53632039e-01 -1.58303320e-01 -5.89366913e-01
#  -1.04949653e-01 -3.48170400e-01 -6.56454623e-01 -3.78303230e-01
#   5.47796726e-01  4.96138871e-01 -2.44629830e-01  4.55444336e-01
#  -1.14247930e+00 -7.88670897e-01  1.50562108e-01 -3.54512930e-01
#  -4.58954796e-02  1.98764518e-01 -8.80398393e-01 -1.04485303e-02
#  -5.17969847e-01  6.52969837e-01  3.98086637e-01  4.20982540e-01
#   9.25288260e-01 -7.74225056e-01  5.46974659e-01  7.49486089e-01
#   1.55225582e-02  4.14185300e-02 -5.25854289e-01  5.21896601e-01
#  -3.96123767e-01 -2.54901469e-01  2.64516681e-01 -3.74263644e-01
#   4.03627396e-01  5.33313155e-01  3.12349319e-01 -1.76936090e-01
#   6.79463446e-02  5.37519097e-01 -2.68221736e-01 -2.54809678e-01
#  -7.49906480e-01 -5.09623349e-01  4.18327570e-01  1.00737981e-01
#   2.09639087e-01  5.53677738e-01 -4.22915220e-01  9.23355341e-01
#  -3.88150848e-02 -1.33672392e+00 -7.92407572e-01 -2.98345745e-01
#   3.77711773e-01 -4.01296079e-01 -4.54319417e-02  6.00742519e-01
#   3.75328183e-01 -5.68328142e-01  8.75719786e-02 -5.54187775e-01
#   8.41035768e-02 -9.88138020e-01 -2.35486403e-02  7.71607935e-01
#  -5.29294908e-02  7.64942691e-02  3.14801067e-01 -1.24616809e-01
#   3.21279228e-01  6.13497317e-01  3.43146503e-01 -8.50225687e-02
#  -5.25812745e-01 -7.52273202e-01 -5.06160974e-01 -5.73707893e-02
#  -4.05345559e-01  7.00342774e-01 -5.88859618e-02 -3.97360086e-01
#   3.66340101e-01  3.92772615e-01 -6.55039012e-01 -6.34037912e-01
#   4.74673599e-01 -4.20833915e-01  5.55019826e-02 -7.92130232e-01
#   5.21123528e-01 -1.29460677e-01 -1.03928399e+00  2.08026558e-01
#  -7.42339417e-02  2.65654802e-01  1.16039574e-01 -5.92529058e-01
#   4.72306877e-01  5.24714768e-01  1.48895085e-01 -2.93754220e-01
#  -5.27825177e-01  9.79340076e-01 -7.13411927e-01  2.39502743e-01
#  -7.75346607e-02 -1.21429241e+00 -1.24783218e-02  2.81099558e-01
#   4.50704470e-02  1.24753267e-01 -1.50207832e-01 -8.67151260e-01
#  -6.82682335e-01 -2.79875100e-01 -4.59930658e-01  1.49780571e-01
#   5.42990029e-01 -7.85976529e-01 -2.25414693e-01  3.06128979e-01
#   6.56679690e-01  1.57460853e-01  2.12480426e-01 -4.97178376e-01
#  -4.17399466e-01 -2.73897529e-01 -1.30461621e+00 -1.25194001e+00
#  -2.17078119e-01 -1.18313536e-01  1.50842428e+00 -8.76403600e-02
#   1.06737566e+00 -5.38372621e-02 -2.45776296e-01 -3.22819144e-01
#   2.48736605e-01  1.87570512e-01 -1.16903037e-01 -1.05909906e-01
#  -5.54214060e-01  8.78238141e-01 -5.87543368e-01 -1.54973287e-03
#  -6.85120374e-02 -2.52178907e-02  2.79805452e-01 -6.83504715e-02
#   1.17160648e-01  3.36629227e-02 -9.59847867e-03  1.90707818e-01
#   3.09208691e-01 -5.71170866e-01  1.70343146e-01  1.21579021e-02
#  -3.29935282e-01  3.18145990e-01  2.73096561e-01 -1.46268994e-01
#  -3.32981408e-01 -1.43764034e-01  2.80964911e-01 -1.38027295e-01
#  -2.07379863e-01 -9.45506692e-02  1.60806149e-01  9.82434750e-02
#   1.13425732e-01 -4.84265447e-01  2.07674295e-01  1.44052535e-01
#   9.80190933e-01 -3.09640378e-01  7.77662516e-01  4.49315071e-01
#   6.13790750e-01  5.13708770e-01 -1.90111786e-01  4.49638665e-01
#  -5.47096670e-01  8.83763015e-01  4.65417951e-02  3.53089780e-01
#  -3.14360261e-01 -6.17544472e-01 -4.32504475e-01  8.17685962e-01
#   2.57703550e-02  1.83035433e-02  1.45139143e-01 -3.31230938e-01
#   6.50057018e-01  4.39758062e-01 -4.42432314e-02 -1.25629783e-01
#   3.74022186e-01 -6.80823684e-01 -9.82696265e-02 -2.75643259e-01
#   8.51556539e-01  6.32214546e-02 -2.42911205e-02 -4.77163494e-01
#   8.93203020e-01 -4.34563339e-01 -4.88245368e-01  1.52983725e-01
#  -4.41160530e-01  3.43376696e-02 -1.40941709e-01  1.63220018e-01
#   6.95474029e-01 -3.98629367e-01 -9.51452494e-01  3.85821611e-02
#  -1.93539947e-01 -5.19908845e-01 -4.41833556e-01  3.68795127e-01
#   3.91628891e-01  1.29087418e-01 -2.56839454e-01 -3.34580779e-01
#   4.77121443e-01  4.08758372e-01 -3.74333531e-01  4.35524672e-01
#  -2.73478746e-01  6.60244524e-01  6.96203232e-01  7.17364401e-02
#   7.62707651e-01  7.93291628e-03  8.58897805e-01  2.31774077e-01
#   2.48914838e-01  2.88288593e-01 -6.76164031e-01 -7.52133608e-01
#  -2.07292125e-01  8.65869999e-01 -3.42081249e-01  5.09492040e-01
#  -3.72269332e-01  1.24842547e-01  3.19245338e-01  1.84459999e-01
#   6.35738611e-01 -2.70725727e-01 -1.71431512e-01 -4.21055257e-01
#   1.04963148e+00 -1.79235607e-01  3.63382310e-01  7.16073155e-01
#  -4.38839644e-02 -3.81063670e-01  3.67406011e-01  5.74840605e-02
#  -5.67134857e-01  3.77291203e-01 -8.32203627e-01  6.68071926e-01
#   5.82608171e-02  4.27643284e-02 -3.69790733e-01  3.14197510e-01
#   9.18725133e-01 -6.46420300e-01  3.11373621e-01  4.41886187e-01
#   4.24874097e-01  4.73916158e-02  4.85477507e-01  3.75515997e-01
#  -1.20698202e+00 -5.48600554e-02  3.12161922e-01  9.82619882e-01
#   3.01694572e-01 -6.35430098e-01  3.09962690e-01 -1.49526492e-01
#  -1.75681084e-01  3.50029767e-01 -3.44898403e-01  1.32675260e-01
#   3.21363836e-01 -1.81991279e-01  1.49467722e-01  7.32397139e-01
#  -1.62304714e-01 -1.98567986e-01  6.23099878e-02  2.45707393e-01
#   9.87428501e-02  4.34832811e-01 -1.77302524e-01  3.67339611e-01
#   1.24260724e-01  5.78916073e-02  8.82730931e-02 -6.31725192e-01
#  -6.28868304e-03 -5.07411778e-01  2.53234267e-01  5.10110140e-01
#  -1.62457794e-01  3.16285223e-01  1.26580209e-01 -1.39604434e-01
#  -2.04311050e-02  4.17876765e-02 -4.53935027e-01 -4.64786403e-02
#  -1.40484631e-01 -9.91209596e-02 -6.26590371e-01  4.32798624e-01
#  -3.19040626e-01  5.14715731e-01 -2.75155604e-02  8.14461946e-01
#   3.30221623e-01  1.32148933e+00  2.21828923e-01 -9.00830179e-02
#   2.27382183e-01 -6.65045977e-02 -7.09422305e-02 -6.29166812e-02
#  -7.75943279e-01  3.27116966e-01 -1.59213841e-01  1.37561858e-01
#  -6.03704452e-01  6.38780236e-01 -1.51765972e-01  3.47601384e-01
#  -1.58907846e-01  5.43662310e-01 -1.41937220e+00  3.21654752e-02
#  -5.54810047e-01  7.17227459e-01 -4.73302603e-03 -4.78524446e-01
#  -4.83325064e-01  1.27939284e-01 -9.48476642e-02  2.50501424e-01
#   2.51657575e-01  1.38103867e+00  3.01237196e-01  2.38892138e-01
#  -2.01498017e-01 -2.32450843e-01 -2.94256687e-01  8.87437701e-01
#   6.64215267e-01 -9.86764371e-01  4.32839423e-01  3.17781270e-01
#   6.17436409e-01  1.12674780e-01  4.03546154e-01 -7.74511576e-01
#  -8.86357352e-02  7.50881672e-01  5.93174875e-01 -2.80622542e-01
#  -4.35846984e-01 -1.92726016e-01 -2.19229553e-02 -1.14059532e+00
#   1.16941653e-01 -2.37762675e-01 -4.97278839e-01  5.92477858e-01
#  -5.74982166e-01  2.39541680e-01  7.13389158e-01  4.68183339e-01
#  -5.73105454e-01  4.58742082e-01  6.13833904e-01  5.65226376e-02
#  -1.24208182e-02 -1.16653752e+00  4.93071377e-01  1.90400779e-01
#  -4.82416063e-01 -7.85073399e-01  5.12218833e-01  2.41917670e-02
#   1.06551373e+00  1.15766861e-01  7.75310576e-01 -1.64123803e-01
#  -1.43839523e-01 -9.24066305e-02  6.81496203e-01  2.68890142e-01
#  -6.88517213e-01 -6.38463914e-01 -2.55813777e-01  8.00931007e-02
#   6.11511946e-01  5.66710710e-01  3.65840912e-01 -9.04297233e-01
#   1.34102970e-01  1.96393877e-01 -1.27852008e-01 -3.54697704e-01
#  -1.03402778e-01 -1.72328204e-03 -1.76889539e-01 -1.25826076e-01
#   2.53968894e-01  4.97274071e-01 -5.37308901e-02 -1.49033904e-01
#   3.87910694e-01  1.01077759e+00 -4.31928039e-01  2.63187960e-02
#  -2.60483056e-01 -8.84322822e-02  1.00989893e-01 -3.90700102e-01
#  -8.19711566e-01 -5.75398564e-01  4.73818064e-01 -1.19919109e+00
#  -3.17246020e-01  3.44984949e-01 -6.19380355e-01  5.64102888e-01
#  -2.95719594e-01 -5.23869656e-02  3.65782887e-01 -6.05445564e-01
#  -5.63061163e-02 -7.79225975e-02 -3.60037923e-01 -6.48379505e-01
#  -2.78084099e-01 -1.18892588e-01  1.48013741e-01 -2.58962363e-01
#   7.71035254e-01  9.35477838e-02  1.40474629e+00  2.50048488e-02
#   1.77833766e-01  5.51648200e-01  5.84923997e-02 -9.80993628e-01
#   2.40084171e-01 -4.20247376e-01  2.06676453e-01  1.55355543e-01
#   1.67848736e-01 -1.85002923e-01 -1.19547404e-01 -3.25927734e-02
#   4.45123970e-01  4.52360690e-01  2.32283056e-01 -1.11218297e+00
#  -2.55811773e-02  9.12845731e-01  5.03381491e-01 -5.44602573e-01
#  -7.27762937e-01 -6.57241344e-01  4.98653173e-01  5.47905028e-01
#   2.32553370e-02  2.45985851e-01 -3.06938827e-01 -5.31564832e-01
#  -2.67979711e-01 -3.70949417e-01 -3.63393396e-01 -4.77498174e-01
#  -1.76663160e-01  2.71764338e-01  5.94605386e-01 -1.85611367e-01
#  -1.01432234e-01  4.36821356e-02 -1.70097768e-01 -8.75366628e-02
#  -9.13202763e-01  4.94732857e-01  1.33472994e-01  2.87586093e-01
#  -6.14062548e-01  3.72287035e-02  8.88671577e-01 -1.03015184e+00
#  -3.17543149e-02 -2.59275645e-01 -4.22335476e-01 -3.22206110e-01
#  -3.73581946e-01  2.41452903e-01  2.07653195e-01  1.11517429e-01
#  -3.44298214e-01  1.88634396e-02 -9.82851833e-02 -9.48311388e-03
#   5.07912561e-02  1.89435765e-01  3.16025734e-01  5.03223419e-01
#   9.53616381e-01 -3.58925700e-01  2.26898625e-01 -3.24643925e-02
#   5.83347201e-01  5.28843701e-02  1.53874683e+00 -1.09128404e+00
#  -1.01465434e-01  2.07714230e-01 -2.34885156e-01  1.01886988e-02
#  -7.10892618e-01 -2.60841213e-02  8.76777708e-01 -6.34270191e-01
#   7.62620926e-01 -9.93431508e-02 -9.47652101e-01  4.32033837e-01
#   6.02262556e-01 -4.99818206e-01 -2.66418159e-01 -5.64170420e-01
#  -2.44192600e-01 -7.39884794e-01  5.30920803e-01 -1.09640911e-01
#   4.17448819e-01 -3.13142806e-01 -1.00161754e-01  4.69784319e-01
#   2.43315503e-01 -4.27558601e-01 -8.41884911e-02  5.45686006e-01
#  -3.82733822e-01  2.81852409e-02 -6.77958429e-01 -7.36228526e-01
#  -6.87028646e-01  4.84301567e-01 -2.84329951e-01  3.85866314e-02
#  -6.71187282e-01 -2.77590692e-01  1.96739614e-01  1.92748338e-01
#  -2.86472052e-01 -1.94594786e-01  1.12639979e-01 -3.23959351e-01
#   2.96295017e-01  5.43496966e-01 -5.41842341e-01 -1.00502372e-02
#  -3.72559428e-01 -3.92062932e-01 -7.73682594e-01  9.16044474e-01
#  -3.85538191e-01 -2.45125800e-01  3.99871170e-02  2.31058896e-03
#  -8.35049152e-03  1.21869549e-01 -2.85963088e-01 -5.82480550e-01
#   1.70725375e-01 -3.75240505e-01 -6.62386119e-01 -1.07539248e+00
#  -1.80744171e-01 -1.06258845e+00 -4.56285745e-01 -2.32082717e-02
#   1.09310341e+00  2.43940502e-01  4.96553242e-01  6.39726996e-01
#  -7.22399726e-02 -9.54866707e-02  2.04010874e-01  6.14676624e-03
#  -3.65803689e-01  3.07934582e-01 -3.10223371e-01  3.72952402e-01
#  -6.66153133e-01  3.21625233e-01  5.72957635e-01  2.34303549e-01
#   2.28582025e-01  4.99826640e-01 -9.29171801e-01 -8.55471611e-01
#   4.88551259e-02  9.70694870e-02 -8.10519755e-02 -1.11862920e-01
#   3.57024074e-02  1.37346864e-01  5.15064478e-01 -3.55682939e-01
#   4.92823392e-01  1.82989851e-01  1.76290676e-01 -1.91259131e-01
#  -7.10590124e-01  1.75247788e-01 -1.01621938e+00 -1.97003931e-01]
# 小姜机器人回答检索： 16.359036422243992	人太多了!找不到你给我回的了	=。=
#
# 小姜机器人回答检索： 16.359036422243992	就欺负你要怎么!就喜欢欺负你	==
#
# 小姜机器人回答检索： 16.359036422243992	你大爷不认识我!要不先带你去	=。=
#
# 小姜机器人回答检索： 16.35903642224399	什么让你这么伤心	如果我的无心之谈害你流泪，那我和你道歉，我爱你。
#
# 小姜机器人回答检索： 16.35903642224399	你敢不敢	你敢我就敢，小样，敢跟我叫板
#
# 你的问题: